﻿/** @file armoriconswidget.cpp  GUI widget for -.
 *
 * @authors Copyright © 2005-2017 Jaakko Keränen <jaakko.keranen@iki.fi>
 * @authors Copyright © 2005-2015 Daniel Swanson <danij@dengine.net>
 *
 * @par License
 * GPL: http://www.gnu.org/licenses/gpl.html
 *
 * <small>This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version. This program is distributed in the hope that it
 * will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Public License for more details. You should have received a copy of the GNU
 * General Public License along with this program; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA</small>
 */
#include "hud/widgets/armoriconswidget.h"
#include "jhexen.h"
#include "gl_drawpatch.h"
#include "hu_inventory.h"
/** @file bluemanaiconwidget.h  GUI widget for -.
 *
 * @authors Copyright © 2005-2017 Jaakko Keränen <jaakko.keranen@iki.fi>
 * @authors Copyright © 2005-2015 Daniel Swanson <danij@dengine.net>
 *
 * @par License
 * GPL: http://www.gnu.org/licenses/gpl.html
 *
 * <small>This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version. This program is distributed in the hope that it
 * will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Public License for more details. You should have received a copy of the GNU
 * General Public License along with this program; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA</small>
 */
#include "hud/widgets/bluemanaiconwidget.h"
#include "jhexen.h"
#include "gl_drawpatch.h"
#include "hu_inventory.h"
/** @file bluemanavialwidget.cpp  GUI widget for -.
 *
 * @authors Copyright © 2005-2017 Jaakko Keränen <jaakko.keranen@iki.fi>
 * @authors Copyright © 2005-2015 Daniel Swanson <danij@dengine.net>
 *
 * @par License
 * GPL: http://www.gnu.org/licenses/gpl.html
 *
 * <small>This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version. This program is distributed in the hope that it
 * will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Public License for more details. You should have received a copy of the GNU
 * General Public License along with this program; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA</small>
 */
#include "hud/widgets/bluemanavialwidget.h"
#include "jhexen.h"
#include "gl_drawpatch.h"
#include "hu_inventory.h"
/** @file bluemanawidget.cpp  GUI widget for -.
 *
 * @authors Copyright © 2005-2017 Jaakko Keränen <jaakko.keranen@iki.fi>
 * @authors Copyright © 2005-2015 Daniel Swanson <danij@dengine.net>
 *
 * @par License
 * GPL: http://www.gnu.org/licenses/gpl.html
 *
 * <small>This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version. This program is distributed in the hope that it
 * will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Public License for more details. You should have received a copy of the GNU
 * General Public License along with this program; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA</small>
 */
#include "hud/widgets/bluemanawidget.h"
#include "jhexen.h"
#include "hu_inventory.h"
/** @file bootswidget.cpp  GUI widget for -.
 *
 * @authors Copyright © 2005-2017 Jaakko Keränen <jaakko.keranen@iki.fi>
 * @authors Copyright © 2005-2015 Daniel Swanson <danij@dengine.net>
 *
 * @par License
 * GPL: http://www.gnu.org/licenses/gpl.html
 *
 * <small>This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version. This program is distributed in the hope that it
 * will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Public License for more details. You should have received a copy of the GNU
 * General Public License along with this program; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA</small>
 */
#include "hud/widgets/bootswidget.h"
#include "jhexen.h"
#include "gl_drawpatch.h"
/** @file defensewidget.cpp  GUI widget for -.
 *
 * @authors Copyright © 2005-2017 Jaakko Keränen <jaakko.keranen@iki.fi>
 * @authors Copyright © 2005-2015 Daniel Swanson <danij@dengine.net>
 *
 * @par License
 * GPL: http://www.gnu.org/licenses/gpl.html
 *
 * <small>This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version. This program is distributed in the hope that it
 * will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Public License for more details. You should have received a copy of the GNU
 * General Public License along with this program; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA</small>
 */
#include "hud/widgets/defensewidget.h"
#include "jhexen.h"
#include "gl_drawpatch.h"
/** @file greenmanaiconwidget.cpp  GUI widget for -.
 *
 * @authors Copyright © 2005-2017 Jaakko Keränen <jaakko.keranen@iki.fi>
 * @authors Copyright © 2005-2015 Daniel Swanson <danij@dengine.net>
 *
 * @par License
 * GPL: http://www.gnu.org/licenses/gpl.html
 *
 * <small>This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version. This program is distributed in the hope that it
 * will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Public License for more details. You should have received a copy of the GNU
 * General Public License along with this program; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA</small>
 */
#include "hud/widgets/greenmanaiconwidget.h"
#include "jhexen.h"
#include "gl_drawpatch.h"
#include "hu_inventory.h"
/** @file greenmanavialwidget.cpp  GUI widget for -.
 *
 * @authors Copyright © 2005-2017 Jaakko Keränen <jaakko.keranen@iki.fi>
 * @authors Copyright © 2005-2015 Daniel Swanson <danij@dengine.net>
 *
 * @par License
 * GPL: http://www.gnu.org/licenses/gpl.html
 *
 * <small>This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version. This program is distributed in the hope that it
 * will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Public License for more details. You should have received a copy of the GNU
 * General Public License along with this program; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA</small>
 */
#include "hud/widgets/greenmanavialwidget.h"
#include "jhexen.h"
#include "gl_drawpatch.h"
#include "hu_inventory.h"
/** @file greenmanawidget.cpp  GUI widget for -.
 *
 * @authors Copyright © 2005-2017 Jaakko Keränen <jaakko.keranen@iki.fi>
 * @authors Copyright © 2005-2015 Daniel Swanson <danij@dengine.net>
 *
 * @par License
 * GPL: http://www.gnu.org/licenses/gpl.html
 *
 * <small>This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version. This program is distributed in the hope that it
 * will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Public License for more details. You should have received a copy of the GNU
 * General Public License along with this program; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA</small>
 */
#include "hud/widgets/greenmanawidget.h"
#include "jhexen.h"
#include "hu_inventory.h"
/** @file servantwidget.cpp  GUI widget for -.
 *
 * @authors Copyright © 2005-2017 Jaakko Keränen <jaakko.keranen@iki.fi>
 * @authors Copyright © 2005-2015 Daniel Swanson <danij@dengine.net>
 *
 * @par License
 * GPL: http://www.gnu.org/licenses/gpl.html
 *
 * <small>This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version. This program is distributed in the hope that it
 * will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Public License for more details. You should have received a copy of the GNU
 * General Public License along with this program; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA</small>
 */
#include "hud/widgets/servantwidget.h"
#include "jhexen.h"
#include "gl_drawpatch.h"
/** @file weaponpieceswidget.cpp  GUI widget for -.
 *
 * @authors Copyright © 2005-2017 Jaakko Keränen <jaakko.keranen@iki.fi>
 * @authors Copyright © 2005-2015 Daniel Swanson <danij@dengine.net>
 *
 * @par License
 * GPL: http://www.gnu.org/licenses/gpl.html
 *
 * <small>This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version. This program is distributed in the hope that it
 * will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Public License for more details. You should have received a copy of the GNU
 * General Public License along with this program; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA</small>
 */
#include "hud/widgets/weaponpieceswidget.h"
#include "jhexen.h"
#include "gl_drawpatch.h"
#include "hu_inventory.h"
/** @file worldtimewidget.cpp  GUI widget for -.
 *
 * @authors Copyright © 2005-2017 Jaakko Keränen <jaakko.keranen@iki.fi>
 * @authors Copyright © 2005-2015 Daniel Swanson <danij@dengine.net>
 *
 * @par License
 * GPL: http://www.gnu.org/licenses/gpl.html
 *
 * <small>This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version. This program is distributed in the hope that it
 * will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Public License for more details. You should have received a copy of the GNU
 * General Public License along with this program; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA</small>
 */
#include "hud/widgets/worldtimewidget.h"
#include "jhexen.h"
using namespace de;
static patchid_t pArmorIcon[NUMARMOR];
static void ArmorIconsWidget_Draw(guidata_armoricons_t *icons, Point2Raw const *offset) {
    DENG2_ASSERT(icons);
    icons->draw(offset? Vector2i(offset->xy) : Vector2i());
}
static void ArmorIconsWidget_UpdateGeometry(guidata_armoricons_t *icons) {
    DENG2_ASSERT(icons);
    icons->updateGeometry();
}
guidata_armoricons_t::guidata_armoricons_t(dint player)
    : HudWidget(function_cast<UpdateGeometryFunc>(ArmorIconsWidget_UpdateGeometry),
                function_cast<DrawFunc>(ArmorIconsWidget_Draw),
                player)
{}
guidata_armoricons_t::~guidata_armoricons_t()
{}
void guidata_armoricons_t::reset() {
    de::zap(_armorPoints);
}
void guidata_armoricons_t::tick(timespan_t /*elapsed*/)
{
    if(Pause_IsPaused() || !DD_IsSharpTick()) return;
    player_t const &plr = ::players[player()];
    for(dint i = 0; i < NUMARMOR; ++i) {
        _armorPoints[i] = plr.armorPoints[i];
    }
}
void guidata_armoricons_t::draw(Vector2i const &offset) const {
#define X_OFFSET                ( 150 )
#define Y_OFFSET                (   2 )
    static Vector2i const origin(-ST_WIDTH / 2, -ST_HEIGHT);
    dint const plrClass      = ::cfg.playerClass[player()];  // Original player class (i.e. not pig).
    dint const activeHud     = ST_ActiveHud(player());
    dint const yOffset       = ST_HEIGHT * (1 - ST_StatusBarShown(player()));
    dfloat const iconOpacity = (activeHud == 0? 1 : ::uiRendState->pageAlpha * ::cfg.common.statusbarCounterAlpha);
    if(Hu_InventoryIsOpen(player())) return;
    if(!ST_AutomapIsOpen(player())) return;
    if(P_MobjIsCamera(::players[player()].plr->mo) && Get(DD_PLAYBACK)) return;
    DGL_MatrixMode(DGL_MODELVIEW);
    DGL_PushMatrix();
    DGL_Translatef(offset.x, offset.y, 0);
    DGL_Scalef(::cfg.common.statusbarScale, ::cfg.common.statusbarScale, 1);
    DGL_Translatef(0, yOffset, 0);
    classinfo_t const &pcdata = *PCLASS_INFO(plrClass);
    for(dint i = 0; i < NUMARMOR; ++i) {
        if(!_armorPoints[i]) continue;
        dfloat opacity = 1;
        if(_armorPoints[i] <= (pcdata.armorIncrement[i] >> 2)) {
            opacity = .3f;
        }
        else if(_armorPoints[i] <= (pcdata.armorIncrement[i] >> 1)) {
            opacity = .6f;
        }
        DGL_Enable(DGL_TEXTURE_2D);
        DGL_Color4f(1, 1, 1, iconOpacity * opacity);
        GL_DrawPatch(::pArmorIcon[i], origin + Vector2i(X_OFFSET + 31 * i, Y_OFFSET));
        DGL_Disable(DGL_TEXTURE_2D);
    }
    DGL_MatrixMode(DGL_MODELVIEW);
    DGL_PopMatrix();
#undef Y_OFFSET
#undef X_OFFSET
}
void guidata_armoricons_t::updateGeometry() {
    Rect_SetWidthHeight(&geometry(), 0, 0);
    if(Hu_InventoryIsOpen(player())) return;
    if(!ST_AutomapIsOpen(player())) return;
    if(P_MobjIsCamera(::players[player()].plr->mo) && Get(DD_PLAYBACK)) return;
    patchinfo_t info;
    for(dint i = 0, x = 0; i < NUMARMOR; ++i, x += 31) {
        if(!_armorPoints[i]) continue;
        if(!R_GetPatchInfo(::pArmorIcon[i], &info)) continue;
        info.geometry.origin.x = x;
        info.geometry.origin.y = 0;
        Rect_UniteRaw(&geometry(), &info.geometry);
    }
    Rect_SetWidthHeight(&geometry(), Rect_Width (&geometry()) * ::cfg.common.statusbarScale,
                                     Rect_Height(&geometry()) * ::cfg.common.statusbarScale);
}
void guidata_armoricons_t::prepareAssets()  // static
{
    for(dint i = 0; i < NUMARMOR; ++i) {
        ::pArmorIcon[i] = R_DeclarePatch(String("ARMSLOT%1").arg(i + 1).toUtf8().constData());
    }
}
static patchid_t pBlueManaIcon[2];  ///< [ dim, bright ]
guidata_bluemanaicon_t::guidata_bluemanaicon_t(void (*updateGeometry) (HudWidget *wi),
                                               void (*drawer) (HudWidget *wi, Point2Raw const *offset),
                                               dint player)
    : HudWidget(updateGeometry,
                drawer,
                player)
{}
guidata_bluemanaicon_t::~guidata_bluemanaicon_t()
{}
void guidata_bluemanaicon_t::reset() {
    _iconIdx = -1;
}
void guidata_bluemanaicon_t::tick(timespan_t /*elapsed*/)
{
    if(Pause_IsPaused() || !DD_IsSharpTick()) return;
    _iconIdx = 0;  // Dim icon.
    player_t const &plr = ::players[player()];
    if(!VALID_WEAPONTYPE(plr.readyWeapon)) return;
    if(plr.ammo[AT_BLUEMANA].owned > 0) {
        if(WEAPON_INFO(plr.readyWeapon, plr.class_, 0)->ammoType[AT_BLUEMANA]) {
            _iconIdx = 1;  // Bright icon.
        }
    }
}
void BlueManaIconWidget_Draw(guidata_bluemanaicon_t *icon, Point2Raw const *offset) {
    DENG2_ASSERT(icon);
    dfloat const iconOpacity = ::uiRendState->pageAlpha * ::cfg.common.hudIconAlpha;
    if(icon->_iconIdx < 0) return;
    if(!::cfg.hudShown[HUD_MANA]) return;
    if(ST_AutomapIsOpen(icon->player()) && ::cfg.common.automapHudDisplay == 0) return;
    if(P_MobjIsCamera(::players[icon->player()].plr->mo) && Get(DD_PLAYBACK)) return;
    DGL_MatrixMode(DGL_MODELVIEW);
    DGL_PushMatrix();
    if(offset) DGL_Translatef(offset->x, offset->y, 0);
    DGL_Scalef(::cfg.common.hudScale, ::cfg.common.hudScale, 1);
    DGL_Enable(DGL_TEXTURE_2D);
    DGL_Color4f(1, 1, 1, iconOpacity);
    GL_DrawPatch(::pBlueManaIcon[icon->_iconIdx]);
    DGL_Disable(DGL_TEXTURE_2D);
    DGL_MatrixMode(DGL_MODELVIEW);
    DGL_PopMatrix();
}
void SBarBlueManaIconWidget_Draw(guidata_bluemanaicon_t *icon, Point2Raw const *offset) {
#define X_OFFSET                ( 77 )
#define Y_OFFSET                (  2 )
    DENG2_ASSERT(icon);
    static Vector2i const origin(-ST_WIDTH / 2, -ST_HEIGHT);
    dint const activeHud     = ST_ActiveHud(icon->player());
    dfloat const yOffset     = ST_HEIGHT * (1 - ST_StatusBarShown(icon->player()));
    dfloat const iconOpacity = (activeHud  == 0? 1 : ::uiRendState->pageAlpha * ::cfg.common.statusbarCounterAlpha);
    if(icon->_iconIdx < 0) return;
    if(Hu_InventoryIsOpen(icon->player())) return;
    if(ST_AutomapIsOpen(icon->player())) return;
    if(P_MobjIsCamera(::players[icon->player()].plr->mo) && Get(DD_PLAYBACK)) return;
    DGL_MatrixMode(DGL_MODELVIEW);
    DGL_PushMatrix();
    if(offset) DGL_Translatef(offset->x, offset->y, 0);
    DGL_Scalef(::cfg.common.statusbarScale, ::cfg.common.statusbarScale, 1);
    DGL_Translatef(0, yOffset, 0);
    DGL_Enable(DGL_TEXTURE_2D);
    DGL_Color4f(1, 1, 1, iconOpacity);
    GL_DrawPatch(::pBlueManaIcon[icon->_iconIdx], origin + Vector2i(X_OFFSET, Y_OFFSET));
    DGL_Disable(DGL_TEXTURE_2D);
    DGL_MatrixMode(DGL_MODELVIEW);
    DGL_PopMatrix();
#undef Y_OFFSET
#undef X_OFFSET
}
void BlueManaIconWidget_UpdateGeometry(guidata_bluemanaicon_t *icon) {
    DENG2_ASSERT(icon);
    Rect_SetWidthHeight(&icon->geometry(), 0, 0);
    if(icon->_iconIdx < 0) return;
    if(!::cfg.hudShown[HUD_MANA]) return;
    if(ST_AutomapIsOpen(icon->player()) && ::cfg.common.automapHudDisplay == 0) return;
    if(P_MobjIsCamera(::players[icon->player()].plr->mo) && Get(DD_PLAYBACK)) return;
    patchinfo_t info;
    if(R_GetPatchInfo(::pBlueManaIcon[icon->_iconIdx], &info)) {
        Rect_SetWidthHeight(&icon->geometry(), info.geometry.size.width  * ::cfg.common.hudScale,
                                               info.geometry.size.height * ::cfg.common.hudScale);
    }
}
void SBarBlueManaIconWidget_UpdateGeometry(guidata_bluemanaicon_t *icon) {
    DENG2_ASSERT(icon);
    Rect_SetWidthHeight(&icon->geometry(), 0, 0);
    if(icon->_iconIdx < 0) return;
    if(Hu_InventoryIsOpen(icon->player())) return;
    if(ST_AutomapIsOpen(icon->player())) return;
    if(P_MobjIsCamera(::players[icon->player()].plr->mo) && Get(DD_PLAYBACK)) return;
    patchinfo_t info;
    if(R_GetPatchInfo(::pBlueManaIcon[icon->_iconIdx], &info)) {
        Rect_SetWidthHeight(&icon->geometry(), info.geometry.size.width  * ::cfg.common.statusbarScale,
                                               info.geometry.size.height * ::cfg.common.statusbarScale);
    }
}
void guidata_bluemanaicon_t::prepareAssets()  // static
{
    ::pBlueManaIcon[0] = R_DeclarePatch("MANADIM1");
    ::pBlueManaIcon[1] = R_DeclarePatch("MANABRT1");
}
static patchid_t pBlueBackground[2];  ///< [ dim, bright ]
static void BlueManaVialWidget_Draw(guidata_bluemanavial_t *vial, Point2Raw const *offset) {
    DENG2_ASSERT(vial);
    vial->draw(offset? Vector2i(offset->xy) : Vector2i());
}
static void BlueManaVialWidget_UpdateGeometry(guidata_bluemanavial_t *vial) {
    DENG2_ASSERT(vial);
    vial->updateGeometry();
}
guidata_bluemanavial_t::guidata_bluemanavial_t(dint player)
    : HudWidget(function_cast<UpdateGeometryFunc>(BlueManaVialWidget_UpdateGeometry),
                function_cast<DrawFunc>(BlueManaVialWidget_Draw),
                player)
{}
guidata_bluemanavial_t::~guidata_bluemanavial_t()
{}
void guidata_bluemanavial_t::reset() {
    _backgroundIdx = -1;
    _filled = 0;
}
void guidata_bluemanavial_t::tick(timespan_t /*elapsed*/)
{
    if(Pause_IsPaused() || !DD_IsSharpTick()) return;
    _backgroundIdx = 0;  // Dim icon.
    player_t const &plr = ::players[player()];
    if(VALID_WEAPONTYPE(plr.readyWeapon)) {
        if(plr.ammo[AT_BLUEMANA].owned > 0) {
            if(WEAPON_INFO(plr.readyWeapon, plr.class_, 0)->ammoType[AT_BLUEMANA]) {
                _backgroundIdx = 1;  // Bright icon.
            }
        }
    }
    _filled = de::clamp(0.f, dfloat( plr.ammo[AT_BLUEMANA].owned ) / MAX_MANA, 1.f);
}
void guidata_bluemanavial_t::draw(Vector2i const &offset) const {
#define X_OFFSET            ( 94 )
#define Y_OFFSET            (  2 )
#define VIAL_WIDTH          (  3 )
#define VIAL_HEIGHT         ( 22 )
    static Vector2i const origin(-ST_WIDTH / 2, -ST_HEIGHT);
    dint const activeHud     = ST_ActiveHud(player());
    dfloat const yOffset     = ST_HEIGHT * (1 - ST_StatusBarShown(player()));
    dfloat const iconOpacity = (activeHud == 0? 1 : ::uiRendState->pageAlpha * ::cfg.common.statusbarCounterAlpha);
    if(Hu_InventoryIsOpen(player())) return;
    if(ST_AutomapIsOpen(player())) return;
    if(P_MobjIsCamera(::players[player()].plr->mo) && Get(DD_PLAYBACK)) return;
    DGL_MatrixMode(DGL_MODELVIEW);
    DGL_PushMatrix();
    DGL_Translatef(offset.x, offset.y, 0);
    DGL_Scalef(::cfg.common.statusbarScale, ::cfg.common.statusbarScale, 1);
    DGL_Translatef(0, yOffset, 0);
    if(_backgroundIdx >= 0) {
        DGL_Enable(DGL_TEXTURE_2D);
        DGL_Color4f(1, 1, 1, iconOpacity);
        GL_DrawPatch(::pBlueBackground[_backgroundIdx], origin + Vector2i(X_OFFSET, Y_OFFSET));
        DGL_Disable(DGL_TEXTURE_2D);
    }
    DGL_SetNoMaterial();
    DGL_DrawRectf2Color(origin.x + X_OFFSET + 1, origin.y + Y_OFFSET + 1, VIAL_WIDTH, dint( VIAL_HEIGHT * (1 - _filled) + .5f ), 0, 0, 0, iconOpacity);
    DGL_MatrixMode(DGL_MODELVIEW);
    DGL_PopMatrix();
#undef VIAL_HEIGHT
#undef VIAL_WIDTH
#undef Y_OFFSET
#undef X_OFFSET
}
void guidata_bluemanavial_t::updateGeometry() {
    Rect_SetWidthHeight(&geometry(), 0, 0);
    if(_backgroundIdx < 0) return;
    if(Hu_InventoryIsOpen(player())) return;
    if(ST_AutomapIsOpen(player())) return;
    if(P_MobjIsCamera(::players[player()].plr->mo) && Get(DD_PLAYBACK)) return;
    patchinfo_t info;
    if(R_GetPatchInfo(::pBlueBackground[_backgroundIdx], &info)) {
        Rect_SetWidthHeight(&geometry(), info.geometry.size.width  * ::cfg.common.statusbarScale,
                                         info.geometry.size.height * ::cfg.common.statusbarScale);
    }
}
void guidata_bluemanavial_t::prepareAssets()  // static
{
    ::pBlueBackground[0] = R_DeclarePatch("MANAVL1D");
    ::pBlueBackground[1] = R_DeclarePatch("MANAVL1");
}
guidata_bluemana_t::guidata_bluemana_t(void (*updateGeometry) (HudWidget *wi),
                                       void (*drawer) (HudWidget *wi, Point2Raw const *offset),
                                       dint player)
    : HudWidget(updateGeometry,
                drawer,
                player)
{}
guidata_bluemana_t::~guidata_bluemana_t()
{}
void guidata_bluemana_t::reset() {
    _value = 1994;
}
void guidata_bluemana_t::tick(timespan_t /*tickLength*/)
{
    if(Pause_IsPaused() || !DD_IsSharpTick()) return;
    player_t const &plr = ::players[player()];
    _value = plr.ammo[AT_BLUEMANA].owned;
}
void BlueManaWidget_Draw(guidata_bluemana_t *mana, Point2Raw const *offset) {
#define TRACKING                ( 1 )
    DENG2_ASSERT(mana);
    dfloat const textOpacity = ::uiRendState->pageAlpha * ::cfg.common.hudColor[3];
    if(mana->_value == 1994) return;
    if(!::cfg.hudShown[HUD_MANA]) return;
    if(ST_AutomapIsOpen(mana->player()) && ::cfg.common.automapHudDisplay == 0) return;
    if(P_MobjIsCamera(::players[mana->player()].plr->mo) && Get(DD_PLAYBACK)) return;
    auto const valueAsText = String::number(mana->_value);
    DGL_MatrixMode(DGL_MODELVIEW);
    DGL_PushMatrix();
    if(offset) DGL_Translatef(offset->x, offset->y, 0);
    DGL_Scalef(::cfg.common.hudScale, ::cfg.common.hudScale, 1);
    DGL_Enable(DGL_TEXTURE_2D);
    FR_SetFont(mana->font());
    FR_SetTracking(TRACKING);
    FR_SetColorAndAlpha(::defFontRGB2[0], ::defFontRGB2[1], ::defFontRGB2[2], textOpacity);
    FR_DrawTextXY3(valueAsText.toUtf8().constData(), 0, 0, ALIGN_TOPLEFT, DTF_NO_EFFECTS);
    DGL_Disable(DGL_TEXTURE_2D);
    DGL_MatrixMode(DGL_MODELVIEW);
    DGL_PopMatrix();
#undef TRACKING
}
void SBarBlueManaWidget_Draw(guidata_bluemana_t *mana, Point2Raw const *offset) {
#define X_OFFSET                ( 91 )
#define Y_OFFSET                ( 19 )
#define TRACKING                (  0 )
    DENG2_ASSERT(mana);
    static Vector2i const origin(-ST_WIDTH / 2, -ST_HEIGHT);
    dint const activeHud     = ST_ActiveHud(mana->player());
    dfloat const yOffset     = ST_HEIGHT * (1 - ST_StatusBarShown(mana->player()));
    dfloat const textOpacity = (activeHud == 0? 1 : ::uiRendState->pageAlpha * ::cfg.common.statusbarCounterAlpha);
    if(mana->_value == 1994) return;
    if(mana->_value <= 0) return;
    if(Hu_InventoryIsOpen(mana->player())) return;
    if(ST_AutomapIsOpen(mana->player())) return;
    if(P_MobjIsCamera(::players[mana->player()].plr->mo) && Get(DD_PLAYBACK)) return;
    auto const valueAsText = String::number(mana->_value);
    DGL_MatrixMode(DGL_MODELVIEW);
    DGL_PushMatrix();
    if(offset) DGL_Translatef(offset->x, offset->y, 0);
    DGL_Scalef(::cfg.common.statusbarScale, ::cfg.common.statusbarScale, 1);
    DGL_Translatef(0, yOffset, 0);
    DGL_Enable(DGL_TEXTURE_2D);
    FR_SetFont(mana->font());
    FR_SetTracking(TRACKING);
    FR_SetColorAndAlpha(::defFontRGB2[0], ::defFontRGB2[1], ::defFontRGB2[2], textOpacity);
    FR_DrawTextXY3(valueAsText.toUtf8().constData(), origin.x + X_OFFSET, origin.y + Y_OFFSET, ALIGN_TOPRIGHT, DTF_NO_EFFECTS);
    DGL_Disable(DGL_TEXTURE_2D);
    DGL_MatrixMode(DGL_MODELVIEW);
    DGL_PopMatrix();
#undef TRACKING
#undef Y_OFFSET
#undef X_OFFSET
}
void BlueMana_UpdateGeometry(guidata_bluemana_t *mana) {
#define TRACKING                ( 1 )
    DENG2_ASSERT(mana);
    Rect_SetWidthHeight(&mana->geometry(), 0, 0);
    if(mana->_value == 1994) return;
    if(!::cfg.hudShown[HUD_MANA]) return;
    if(ST_AutomapIsOpen(mana->player()) && ::cfg.common.automapHudDisplay == 0) return;
    if(P_MobjIsCamera(::players[mana->player()].plr->mo) && Get(DD_PLAYBACK)) return;
    auto const valueAsText = String::number(mana->_value);
    FR_SetFont(mana->font());
    FR_SetTracking(TRACKING);
    Size2Raw textSize; FR_TextSize(&textSize, valueAsText.toUtf8().constData());
    Rect_SetWidthHeight(&mana->geometry(), textSize.width  * cfg.common.hudScale,
                                           textSize.height * cfg.common.hudScale);
#undef TRACKING
}
void SBarBlueManaWidget_UpdateGeometry(guidata_bluemana_t *mana) {
#define TRACKING                ( 0 )
    DENG2_ASSERT(mana);
    Rect_SetWidthHeight(&mana->geometry(), 0, 0);
    if(mana->_value == 1994) return;
    if(mana->_value <= 0) return;
    if(Hu_InventoryIsOpen(mana->player())) return;
    if(ST_AutomapIsOpen(mana->player())) return;
    if(P_MobjIsCamera(::players[mana->player()].plr->mo) && Get(DD_PLAYBACK)) return;
    auto const valueAsText = String::number(mana->_value);
    FR_SetFont(mana->font());
    FR_SetTracking(TRACKING);
    Size2Raw textSize; FR_TextSize(&textSize, valueAsText.toUtf8().constData());
    Rect_SetWidthHeight(&mana->geometry(), textSize.width  * ::cfg.common.statusbarScale,
                                           textSize.height * ::cfg.common.statusbarScale);
#undef TRACKING
}
#define FRAME_COUNT             ( 16 )  ///< min 1
static patchid_t pBootsIcon[FRAME_COUNT];
static void BootsWidget_Draw(guidata_boots_t *boots, Point2Raw const *offset) {
    DENG2_ASSERT(boots);
    boots->draw(offset? Vector2i(offset->xy) : Vector2i());
}
static void BootsWidget_UpdateGeometry(guidata_boots_t *boots) {
    DENG2_ASSERT(boots);
    boots->updateGeometry();
}
guidata_boots_t::guidata_boots_t(dint player)
    : HudWidget(function_cast<UpdateGeometryFunc>(BootsWidget_UpdateGeometry),
                function_cast<DrawFunc>(BootsWidget_Draw),
                player)
{}
guidata_boots_t::~guidata_boots_t()
{}
void guidata_boots_t::reset() {
    _patchId = 0;
}
void guidata_boots_t::tick(timespan_t /*elapsed*/)
{
    if(Pause_IsPaused() || !DD_IsSharpTick()) return;
    _patchId = 0;
    player_t const &plr = ::players[player()];
    if(plr.powers[PT_SPEED] &&
       (plr.powers[PT_SPEED] > BLINKTHRESHOLD || !(plr.powers[PT_SPEED] & 16))) {
        _patchId = ::pBootsIcon[(::mapTime / 3) & (FRAME_COUNT - 1)];
    }
}
void guidata_boots_t::draw(Vector2i const &offset) const {
    player_t const &plr      = ::players[player()];
    dfloat const iconOpacity = ::uiRendState->pageAlpha * ::cfg.common.hudIconAlpha;
    if(_patchId == 0) return;
    if(ST_AutomapIsOpen(player()) && ::cfg.common.automapHudDisplay == 0) return;
    if(P_MobjIsCamera(plr.plr->mo) && Get(DD_PLAYBACK)) return;
    DGL_MatrixMode(DGL_MODELVIEW);
    DGL_PushMatrix();
    DGL_Translatef(offset.x, offset.y, 0);
    DGL_Scalef(::cfg.common.hudScale, ::cfg.common.hudScale, 1);
    DGL_Enable(DGL_TEXTURE_2D);
    DGL_Color4f(1, 1, 1, iconOpacity);
    GL_DrawPatch(_patchId, Vector2i(12, 14));
    DGL_Disable(DGL_TEXTURE_2D);
    DGL_MatrixMode(DGL_MODELVIEW);
    DGL_PopMatrix();
}
void guidata_boots_t::updateGeometry() {
    player_t const &plr = ::players[player()];
    Rect_SetWidthHeight(&geometry(), 0, 0);
    if(ST_AutomapIsOpen(player()) && ::cfg.common.automapHudDisplay == 0) return;
    if(P_MobjIsCamera(plr.plr->mo) && Get(DD_PLAYBACK)) return;
    if(!plr.powers[PT_SPEED]) return;
    Rect_SetWidthHeight(&geometry(), 24 * ::cfg.common.hudScale,
                                     28 * ::cfg.common.hudScale);
}
void guidata_boots_t::prepareAssets()  // static
{
    for(dint i = 0; i < FRAME_COUNT; ++i) {
        ::pBootsIcon[i] = R_DeclarePatch(String("SPBOOT%1").arg(i).toUtf8().constData());
    }
}
#define FRAME_COUNT             ( 16 )  ///< min 1
static patchid_t pDefenseIcon[FRAME_COUNT];
static void DefenseWidget_Draw(guidata_defense_t *dfns, Point2Raw const *offset) {
    DENG2_ASSERT(dfns);
    dfns->draw(offset? Vector2i(offset->xy) : Vector2i());
}
static void DefenseWidget_UpdateGeometry(guidata_defense_t *dfns) {
    DENG2_ASSERT(dfns);
    dfns->updateGeometry();
}
guidata_defense_t::guidata_defense_t(dint player)
    : HudWidget(function_cast<UpdateGeometryFunc>(DefenseWidget_UpdateGeometry),
                function_cast<DrawFunc>(DefenseWidget_Draw),
                player)
{}
guidata_defense_t::~guidata_defense_t()
{}
void guidata_defense_t::reset() {
    _patchId = 0;
}
void guidata_defense_t::tick(timespan_t /*elapsed*/)
{
    if(Pause_IsPaused() || !DD_IsSharpTick()) return;
    _patchId = 0;
    player_t const &plr = ::players[player()];
    if(plr.powers[PT_INVULNERABILITY] &&
       (plr.powers[PT_INVULNERABILITY] > BLINKTHRESHOLD || !(plr.powers[PT_INVULNERABILITY] & 16))) {
        _patchId = ::pDefenseIcon[(::mapTime / 3) & (FRAME_COUNT - 1)];
    }
}
void guidata_defense_t::draw(Vector2i const &offset) const {
    dfloat const iconOpacity = ::uiRendState->pageAlpha * ::cfg.common.hudIconAlpha;
    if(_patchId == 0) return;
    if(ST_AutomapIsOpen(player()) && ::cfg.common.automapHudDisplay == 0) return;
    if(P_MobjIsCamera(::players[player()].plr->mo) && Get(DD_PLAYBACK)) return;
    DGL_MatrixMode(DGL_MODELVIEW);
    DGL_PushMatrix();
    DGL_Translatef(offset.x, offset.y, 0);
    DGL_Scalef(::cfg.common.hudScale, ::cfg.common.hudScale, 1);
    DGL_Enable(DGL_TEXTURE_2D);
    DGL_Color4f(1, 1, 1, iconOpacity);
    GL_DrawPatch(_patchId, Vector2i(13, 14));
    DGL_Disable(DGL_TEXTURE_2D);
    DGL_MatrixMode(DGL_MODELVIEW);
    DGL_PopMatrix();
}
void guidata_defense_t::updateGeometry() {
    player_t const &plr = ::players[player()];
    Rect_SetWidthHeight(&geometry(), 0, 0);
    if(ST_AutomapIsOpen(player()) && ::cfg.common.automapHudDisplay == 0) return;
    if(P_MobjIsCamera(plr.plr->mo) && Get(DD_PLAYBACK)) return;
    if(!plr.powers[PT_INVULNERABILITY]) return;
    Rect_SetWidthHeight(&geometry(), 26 * ::cfg.common.hudScale,
                                     28 * ::cfg.common.hudScale);
}
void guidata_defense_t::prepareAssets()  // static
{
    for(dint i = 0; i < FRAME_COUNT; ++i) {
        ::pDefenseIcon[i] = R_DeclarePatch(String("SPSHLD%1").arg(i).toUtf8().constData());
    }
}
static patchid_t pGreenManaIcon[2];  ///< [ dim, bright ]
guidata_greenmanaicon_t::guidata_greenmanaicon_t(void (*updateGeometry) (HudWidget *wi),
                                                 void (*drawer) (HudWidget *wi, Point2Raw const *offset),
                                                 dint player)
    : HudWidget(updateGeometry,
                drawer,
                player)
{}
guidata_greenmanaicon_t::~guidata_greenmanaicon_t()
{}
void guidata_greenmanaicon_t::reset() {
    _iconIdx = -1;
}
void guidata_greenmanaicon_t::tick(timespan_t /*elapsed*/)
{
    if(Pause_IsPaused() || !DD_IsSharpTick()) return;
    _iconIdx = 0;  // Dim icon.
    player_t const &plr = ::players[player()];
    if(!VALID_WEAPONTYPE(plr.readyWeapon)) return;
    if(plr.ammo[AT_GREENMANA].owned > 0) {
        if(WEAPON_INFO(plr.readyWeapon, plr.class_, 0)->ammoType[AT_GREENMANA]) {
            _iconIdx = 1;  // Bright icon.
        }
    }
}
void GreenManaIconWidget_Draw(guidata_greenmanaicon_t *icon, Point2Raw const *offset) {
    DENG2_ASSERT(icon);
    dfloat const iconOpacity = ::uiRendState->pageAlpha * ::cfg.common.hudIconAlpha;
    if(icon->_iconIdx < 0) return;
    if(!::cfg.hudShown[HUD_MANA]) return;
    if(ST_AutomapIsOpen(icon->player()) && ::cfg.common.automapHudDisplay == 0) return;
    if(P_MobjIsCamera(::players[icon->player()].plr->mo) && Get(DD_PLAYBACK)) return;
    DGL_MatrixMode(DGL_MODELVIEW);
    DGL_PushMatrix();
    if(offset) DGL_Translatef(offset->x, offset->y, 0);
    DGL_Scalef(::cfg.common.hudScale, ::cfg.common.hudScale, 1);
    DGL_Enable(DGL_TEXTURE_2D);
    DGL_Color4f(1, 1, 1, iconOpacity);
    GL_DrawPatch(::pGreenManaIcon[icon->_iconIdx]);
    DGL_Disable(DGL_TEXTURE_2D);
    DGL_MatrixMode(DGL_MODELVIEW);
    DGL_PopMatrix();
}
void SBarGreenManaIconWidget_Draw(guidata_greenmanaicon_t *icon, Point2Raw const *offset) {
#define X_OFFSET            ( 110 )
#define Y_OFFSET            (   2 )
    DENG2_ASSERT(icon);
    static Vector2i const origin(-ST_WIDTH / 2, -ST_HEIGHT);
    dint const activeHud     = ST_ActiveHud(icon->player());
    dfloat const yOffset     = ST_HEIGHT * (1 - ST_StatusBarShown(icon->player()));
    dfloat const iconOpacity = (activeHud  == 0? 1 : ::uiRendState->pageAlpha * ::cfg.common.statusbarCounterAlpha);
    if(icon->_iconIdx < 0) return;
    if(Hu_InventoryIsOpen(icon->player())) return;
    if(ST_AutomapIsOpen(icon->player())) return;
    if(P_MobjIsCamera(::players[icon->player()].plr->mo) && Get(DD_PLAYBACK)) return;
    DGL_MatrixMode(DGL_MODELVIEW);
    DGL_PushMatrix();
    if(offset) DGL_Translatef(offset->x, offset->y, 0);
    DGL_Scalef(::cfg.common.statusbarScale, ::cfg.common.statusbarScale, 1);
    DGL_Translatef(0, yOffset, 0);
    DGL_Enable(DGL_TEXTURE_2D);
    DGL_Color4f(1, 1, 1, iconOpacity);
    GL_DrawPatch(::pGreenManaIcon[icon->_iconIdx], origin + Vector2i(X_OFFSET, Y_OFFSET));
    DGL_Disable(DGL_TEXTURE_2D);
    DGL_MatrixMode(DGL_MODELVIEW);
    DGL_PopMatrix();
#undef Y_OFFSET
#undef X_OFFSET
}
void GreenManaIconWidget_UpdateGeometry(guidata_greenmanaicon_t *icon) {
    DENG2_ASSERT(icon);
    Rect_SetWidthHeight(&icon->geometry(), 0, 0);
    if(icon->_iconIdx < 0) return;
    if(!::cfg.hudShown[HUD_MANA]) return;
    if(ST_AutomapIsOpen(icon->player()) && ::cfg.common.automapHudDisplay == 0) return;
    if(P_MobjIsCamera(::players[icon->player()].plr->mo) && Get(DD_PLAYBACK)) return;
    patchinfo_t info;
    if(R_GetPatchInfo(::pGreenManaIcon[icon->_iconIdx], &info)) {
        Rect_SetWidthHeight(&icon->geometry(), info.geometry.size.width  * ::cfg.common.hudScale,
                                               info.geometry.size.height * ::cfg.common.hudScale);
    }
}
void SBarGreenManaIconWidget_UpdateGeometry(guidata_greenmanaicon_t *icon) {
    DENG2_ASSERT(icon);
    Rect_SetWidthHeight(&icon->geometry(), 0, 0);
    if(icon->_iconIdx < 0) return;
    if(Hu_InventoryIsOpen(icon->player())) return;
    if(ST_AutomapIsOpen(icon->player())) return;
    if(P_MobjIsCamera(::players[icon->player()].plr->mo) && Get(DD_PLAYBACK)) return;
    patchinfo_t info;
    if(R_GetPatchInfo(::pGreenManaIcon[icon->_iconIdx], &info)) {
        Rect_SetWidthHeight(&icon->geometry(), info.geometry.size.width  * ::cfg.common.statusbarScale,
                                               info.geometry.size.height * ::cfg.common.statusbarScale);
    }
}
void guidata_greenmanaicon_t::prepareAssets()  // static
{
    ::pGreenManaIcon[0] = R_DeclarePatch("MANADIM2");
    ::pGreenManaIcon[1] = R_DeclarePatch("MANABRT2");
}
static patchid_t pGreenBackground[2];  ///< [ dim, bright ]
static void GreenManaVialWidget_Draw(guidata_greenmanavial_t *vial, Point2Raw const *offset) {
    DENG2_ASSERT(vial);
    vial->draw(offset? Vector2i(offset->xy) : Vector2i());
}
static void GreenManaVial_UpdateGeometry(guidata_greenmanavial_t *vial) {
    DENG2_ASSERT(vial);
    vial->updateGeometry();
}
guidata_greenmanavial_t::guidata_greenmanavial_t(dint player)
    : HudWidget(function_cast<UpdateGeometryFunc>(GreenManaVial_UpdateGeometry),
                function_cast<DrawFunc>(GreenManaVialWidget_Draw),
                player)
{}
guidata_greenmanavial_t::~guidata_greenmanavial_t()
{}
void guidata_greenmanavial_t::reset() {
    _backgroundIdx = -1;
    _filled = 0;
}
void guidata_greenmanavial_t::tick(timespan_t /*elapsed*/)
{
    if(Pause_IsPaused() || !DD_IsSharpTick()) return;
    _backgroundIdx = 0;  // Dim icon.
    player_t const &plr = ::players[player()];
    if(VALID_WEAPONTYPE(plr.readyWeapon)) {
        if(plr.ammo[AT_GREENMANA].owned > 0) {
            if(WEAPON_INFO(plr.readyWeapon, plr.class_, 0)->ammoType[AT_GREENMANA]) {
                _backgroundIdx = 1;  // Bright icon.
            }
        }
    }
    _filled = de::clamp(0.f, dfloat( plr.ammo[AT_GREENMANA].owned ) / MAX_MANA, 1.f);
}
void guidata_greenmanavial_t::draw(Vector2i const &offset) const {
#define X_OFFSET            ( 102 )
#define Y_OFFSET            (   2 )
#define VIAL_WIDTH          (   3 )
#define VIAL_HEIGHT         (  22 )
    static Vector2i const origin(-ST_WIDTH / 2, -ST_HEIGHT);
    dint const activeHud     = ST_ActiveHud(player());
    dfloat const yOffset     = ST_HEIGHT * (1 - ST_StatusBarShown(player()));
    dfloat const iconOpacity = (activeHud == 0? 1 : ::uiRendState->pageAlpha * ::cfg.common.statusbarCounterAlpha);
    if(Hu_InventoryIsOpen(player())) return;
    if(ST_AutomapIsOpen(player())) return;
    if(P_MobjIsCamera(::players[player()].plr->mo) && Get(DD_PLAYBACK)) return;
    DGL_MatrixMode(DGL_MODELVIEW);
    DGL_PushMatrix();
    DGL_Translatef(offset.x, offset.y, 0);
    DGL_Scalef(::cfg.common.statusbarScale, ::cfg.common.statusbarScale, 1);
    DGL_Translatef(0, yOffset, 0);
    if(_backgroundIdx >= 0) {
        DGL_Enable(DGL_TEXTURE_2D);
        DGL_Color4f(1, 1, 1, iconOpacity);
        GL_DrawPatch(::pGreenBackground[_backgroundIdx], origin + Vector2i(X_OFFSET, Y_OFFSET));
        DGL_Disable(DGL_TEXTURE_2D);
    }
    DGL_SetNoMaterial();
    DGL_DrawRectf2Color(origin.x + X_OFFSET + 1, origin.y + Y_OFFSET + 1, VIAL_WIDTH, dint( VIAL_HEIGHT * (1 - _filled) + .5f ), 0, 0, 0, iconOpacity);
    DGL_MatrixMode(DGL_MODELVIEW);
    DGL_PopMatrix();
#undef VIAL_HEIGHT
#undef VIAL_WIDTH
#undef Y_OFFSET
#undef X_OFFSET
}
void guidata_greenmanavial_t::updateGeometry() {
    Rect_SetWidthHeight(&geometry(), 0, 0);
    if(_backgroundIdx < 0) return;
    if(Hu_InventoryIsOpen(player())) return;
    if(ST_AutomapIsOpen(player())) return;
    if(P_MobjIsCamera(::players[player()].plr->mo) && Get(DD_PLAYBACK)) return;
    patchinfo_t info;
    if(R_GetPatchInfo(::pGreenBackground[_backgroundIdx], &info)) {
        Rect_SetWidthHeight(&geometry(), info.geometry.size.width  * ::cfg.common.statusbarScale,
                                         info.geometry.size.height * ::cfg.common.statusbarScale);
    }
}
void guidata_greenmanavial_t::prepareAssets()  // static
{
    ::pGreenBackground[0] = R_DeclarePatch("MANAVL2D");
    ::pGreenBackground[1] = R_DeclarePatch("MANAVL2");
}
guidata_greenmana_t::guidata_greenmana_t(void (*updateGeometry) (HudWidget *wi),
                                         void (*drawer) (HudWidget *wi, Point2Raw const *offset),
                                         dint player)
    : HudWidget(updateGeometry,
                drawer,
                player)
{}
guidata_greenmana_t::~guidata_greenmana_t()
{}
void guidata_greenmana_t::reset() {
    _value = 1994;
}
void guidata_greenmana_t::tick(timespan_t /*elapsed*/)
{
    if(Pause_IsPaused() || !DD_IsSharpTick()) return;
    player_t const &plr = ::players[player()];
    _value = plr.ammo[AT_GREENMANA].owned;
}
void GreenManaWidget_Draw(guidata_greenmana_t *mana, Point2Raw const *offset) {
#define TRACKING                ( 1 )
    DENG2_ASSERT(mana);
    dfloat const textOpacity = ::uiRendState->pageAlpha * ::cfg.common.hudColor[3];
    if(mana->_value == 1994) return;
    if(!::cfg.hudShown[HUD_MANA]) return;
    if(ST_AutomapIsOpen(mana->player()) && ::cfg.common.automapHudDisplay == 0) return;
    if(P_MobjIsCamera(::players[mana->player()].plr->mo) && Get(DD_PLAYBACK)) return;
    auto const valueAsText = String::number(mana->_value);
    DGL_MatrixMode(DGL_MODELVIEW);
    DGL_PushMatrix();
    if(offset) DGL_Translatef(offset->x, offset->y, 0);
    DGL_Scalef(::cfg.common.hudScale, ::cfg.common.hudScale, 1);
    DGL_Enable(DGL_TEXTURE_2D);
    FR_SetFont(mana->font());
    FR_SetTracking(TRACKING);
    FR_SetColorAndAlpha(::defFontRGB2[0], ::defFontRGB2[1], ::defFontRGB2[2], textOpacity);
    FR_DrawTextXY3(valueAsText.toUtf8().constData(), 0, 0, ALIGN_TOPLEFT, DTF_NO_EFFECTS);
    DGL_Disable(DGL_TEXTURE_2D);
    DGL_MatrixMode(DGL_MODELVIEW);
    DGL_PopMatrix();
#undef TRACKING
}
void SBarGreenManaWidget_Draw(guidata_greenmana_t *mana, Point2Raw const *offset) {
#define X_OFFSET                ( 123 )
#define Y_OFFSET                (  19 )
    static Vector2i const origin(-ST_WIDTH / 2, -ST_HEIGHT);
    DENG2_ASSERT(mana);
    dint const activeHud     = ST_ActiveHud(mana->player());
    dfloat const yOffset     = ST_HEIGHT * (1 - ST_StatusBarShown(mana->player()));
    dfloat const textOpacity = (activeHud == 0? 1 : ::uiRendState->pageAlpha * ::cfg.common.statusbarCounterAlpha);
    if(mana->_value == 1994) return;
    if(mana->_value == 0) return;
    if(Hu_InventoryIsOpen(mana->player())) return;
    if(ST_AutomapIsOpen(mana->player())) return;
    if(P_MobjIsCamera(::players[mana->player()].plr->mo) && Get(DD_PLAYBACK)) return;
    auto const valueAsText = String::number(mana->_value);
    DGL_MatrixMode(DGL_MODELVIEW);
    DGL_PushMatrix();
    if(offset) DGL_Translatef(offset->x, offset->y, 0);
    DGL_Scalef(::cfg.common.statusbarScale, ::cfg.common.statusbarScale, 1);
    DGL_Translatef(0, yOffset, 0);
    DGL_Enable(DGL_TEXTURE_2D);
    FR_SetFont(mana->font());
    FR_SetTracking(0);
    FR_SetColorAndAlpha(::defFontRGB2[0], ::defFontRGB2[1], ::defFontRGB2[2], textOpacity);
    FR_DrawTextXY3(valueAsText.toUtf8().constData(), origin.x + X_OFFSET, origin.y + Y_OFFSET, ALIGN_TOPRIGHT, DTF_NO_EFFECTS);
    DGL_Disable(DGL_TEXTURE_2D);
    DGL_MatrixMode(DGL_MODELVIEW);
    DGL_PopMatrix();
#undef Y_OFFSET
#undef X_OFFSET
}
void GreenManaWidget_UpdateGeometry(guidata_greenmana_t *mana) {
#define TRACKING                ( 1 )
    DENG2_ASSERT(mana);
    Rect_SetWidthHeight(&mana->geometry(), 0, 0);
    if(mana->_value == 1994) return;
    if(!::cfg.hudShown[HUD_MANA]) return;
    if(ST_AutomapIsOpen(mana->player()) && ::cfg.common.automapHudDisplay == 0) return;
    if(P_MobjIsCamera(players[mana->player()].plr->mo) && Get(DD_PLAYBACK)) return;
    auto const valueAsText = String::number(mana->_value);
    FR_SetFont(mana->font());
    FR_SetTracking(TRACKING);
    Size2Raw textSize; FR_TextSize(&textSize, valueAsText.toUtf8().constData());
    Rect_SetWidthHeight(&mana->geometry(), textSize.width  * ::cfg.common.hudScale,
                                           textSize.height * ::cfg.common.hudScale);
#undef TRACKING
}
void SBarGreenManaWidget_UpdateGeometry(guidata_greenmana_t *mana) {
    DENG2_ASSERT(mana);
    Rect_SetWidthHeight(&mana->geometry(), 0, 0);
    if(mana->_value == 1994) return;
    if(mana->_value == 0) return;
    if(Hu_InventoryIsOpen(mana->player())) return;
    if(ST_AutomapIsOpen(mana->player())) return;
    if(P_MobjIsCamera(::players[mana->player()].plr->mo) && Get(DD_PLAYBACK)) return;
    auto const valueAsText = String::number(mana->_value);
    FR_SetFont(mana->font());
    FR_SetTracking(0);
    Size2Raw textSize;
    FR_TextSize(&textSize, valueAsText.toUtf8().constData());
    Rect_SetWidthHeight(&mana->geometry(), textSize.width  * ::cfg.common.statusbarScale,
                                           textSize.height * ::cfg.common.statusbarScale);
}
#define FRAME_COUNT             ( 16 )  ///< min 1
static patchid_t pServantIcon[FRAME_COUNT];
static void ServantWidget_Draw(guidata_servant_t *svnt, Point2Raw const *offset) {
    DENG2_ASSERT(svnt);
    svnt->draw(offset? Vector2i(offset->xy) : Vector2i());
}
static void ServantWidget_UpdateGeometry(guidata_servant_t *svnt) {
    DENG2_ASSERT(svnt);
    svnt->updateGeometry();
}
guidata_servant_t::guidata_servant_t(dint player)
    : HudWidget(function_cast<UpdateGeometryFunc>(ServantWidget_UpdateGeometry),
                function_cast<DrawFunc>(ServantWidget_Draw),
                player)
{}
guidata_servant_t::~guidata_servant_t()
{}
void guidata_servant_t::reset() {
    _patchId = 0;
}
void guidata_servant_t::tick(timespan_t /*elapsed*/)
{
    if(Pause_IsPaused() || !DD_IsSharpTick()) return;
    _patchId = 0;
    player_t const &plr = ::players[player()];
    if(plr.powers[PT_MINOTAUR] &&
       (plr.powers[PT_MINOTAUR] > BLINKTHRESHOLD || !(plr.powers[PT_MINOTAUR] & 16))) {
        _patchId = ::pServantIcon[(::mapTime / 3) & (FRAME_COUNT - 1)];
    }
}
void guidata_servant_t::draw(Vector2i const &offset) const {
    dfloat const iconOpacity = ::uiRendState->pageAlpha * ::cfg.common.hudIconAlpha;
    if(ST_AutomapIsOpen(player()) && ::cfg.common.automapHudDisplay == 0) return;
    if(P_MobjIsCamera(::players[player()].plr->mo) && Get(DD_PLAYBACK)) return;
    if(_patchId == 0) return;
    DGL_MatrixMode(DGL_MODELVIEW);
    DGL_PushMatrix();
    DGL_Translatef(offset.x, offset.y, 0);
    DGL_Scalef(::cfg.common.hudScale, ::cfg.common.hudScale, 1);
    DGL_Enable(DGL_TEXTURE_2D);
    DGL_Color4f(1, 1, 1, iconOpacity);
    GL_DrawPatch(_patchId, Vector2i(13, 17));
    DGL_Disable(DGL_TEXTURE_2D);
    DGL_MatrixMode(DGL_MODELVIEW);
    DGL_PopMatrix();
}
void guidata_servant_t::updateGeometry() {
    player_t const &plr = ::players[player()];
    Rect_SetWidthHeight(&geometry(), 0, 0);
    if(ST_AutomapIsOpen(player()) && ::cfg.common.automapHudDisplay == 0) return;
    if(P_MobjIsCamera(::players[player()].plr->mo) && Get(DD_PLAYBACK)) return;
    if(!plr.powers[PT_MINOTAUR]) return;
    Rect_SetWidthHeight(&geometry(), 26 * ::cfg.common.hudScale,
                                     29 * ::cfg.common.hudScale);
}
void guidata_servant_t::prepareAssets()  // static
{
    for(dint i = 0; i < FRAME_COUNT; ++i) {
        ::pServantIcon[i] = R_DeclarePatch(String("SPMINO%1").arg(i).toUtf8().constData());
    }
}
static patchid_t pPiece[NUM_PLAYER_CLASSES][WEAPON_FOURTH_PIECE_COUNT];
static patchid_t pComplete[NUM_PLAYER_CLASSES];
static void WeaponPiecesWidget_Draw(guidata_weaponpieces_t *wp, Point2Raw const *offset) {
    DENG2_ASSERT(wp);
    wp->draw(offset? Vector2i(offset->xy) : Vector2i());
}
static void WeaponPiecesWidget_UpdateGeometry(guidata_weaponpieces_t *wp) {
    DENG2_ASSERT(wp);
    wp->updateGeometry();
}
guidata_weaponpieces_t::guidata_weaponpieces_t(dint player)
    : HudWidget(function_cast<UpdateGeometryFunc>(WeaponPiecesWidget_UpdateGeometry),
                function_cast<DrawFunc>(WeaponPiecesWidget_Draw),
                player)
{}
guidata_weaponpieces_t::~guidata_weaponpieces_t()
{}
void guidata_weaponpieces_t::reset() {
    _ownedPieces = 0;
}
void guidata_weaponpieces_t::tick(timespan_t /*elapsed*/)
{
    if(Pause_IsPaused() || !DD_IsSharpTick()) return;
    _ownedPieces = players[player()].pieces;
}
void guidata_weaponpieces_t::draw(Vector2i const &offset) const {
    static Vector2i const origin(-ST_WIDTH / 2, -ST_HEIGHT);
    dint const plrClass    = ::cfg.playerClass[player()];  // Original player class (i.e. not pig).
    dint const activeHud     = ST_ActiveHud(player());
    dfloat const yOffset     = ST_HEIGHT * (1 - ST_StatusBarShown(player()));
    dfloat const iconOpacity = (activeHud == 0? 1 : ::uiRendState->pageAlpha * ::cfg.common.statusbarCounterAlpha);
    if(Hu_InventoryIsOpen(player())) return;
    if(ST_AutomapIsOpen(player())) return;
    if(P_MobjIsCamera(::players[player()].plr->mo) && Get(DD_PLAYBACK)) return;
    DGL_MatrixMode(DGL_MODELVIEW);
    DGL_PushMatrix();
    DGL_Translatef(offset.x, offset.y, 0);
    DGL_Scalef(::cfg.common.statusbarScale, ::cfg.common.statusbarScale, 1);
    DGL_Translatef(0, yOffset, 0);
    DGL_Enable(DGL_TEXTURE_2D);
    if(_ownedPieces == WEAPON_FOURTH_COMPLETE) {
        DGL_Color4f(1, 1, 1, iconOpacity);
        GL_DrawPatch(::pComplete[plrClass], origin + Vector2i(190, 0));
    }
    else {
        classinfo_t const &pcdata = *PCLASS_INFO(plrClass);
        for(dint piece = 0; piece < WEAPON_FOURTH_PIECE_COUNT; ++piece) {
            if(_ownedPieces & (1 << piece)) {
                DGL_Color4f(1, 1, 1, iconOpacity);
                GL_DrawPatch(::pPiece[plrClass][piece], origin + Vector2i(pcdata.fourthWeaponPiece[piece].offset.xy));
            }
        }
    }
    DGL_Disable(DGL_TEXTURE_2D);
    DGL_MatrixMode(DGL_MODELVIEW);
    DGL_PopMatrix();
}
void guidata_weaponpieces_t::updateGeometry() {
    Rect_SetWidthHeight(&geometry(), 0, 0);
    if(Hu_InventoryIsOpen(player())) return;
    if(ST_AutomapIsOpen(player())) return;
    if(P_MobjIsCamera(::players[player()].plr->mo) && Get(DD_PLAYBACK)) return;
    Rect_SetWidthHeight(&geometry(), 57 * ::cfg.common.statusbarScale,
                                     30 * ::cfg.common.statusbarScale);
}
void guidata_weaponpieces_t::prepareAssets()  // static
{
    de::zap(::pComplete);
    de::zap(::pPiece);
    for(dint plrClass = 0; plrClass < NUM_PLAYER_CLASSES; ++plrClass) {
        classinfo_t const &pcdata = *PCLASS_INFO(plrClass);
        if(!pcdata.userSelectable) continue;
        ::pComplete[plrClass] = R_DeclarePatch(pcdata.fourthWeaponCompletePatchName);
        for(dint piece = 0; piece < WEAPON_FOURTH_PIECE_COUNT; ++piece) {
            ::pPiece[plrClass][piece] = R_DeclarePatch(pcdata.fourthWeaponPiece[piece].patchName);
        }
    }
}
static void WorldTimeWidget_Draw(guidata_worldtime_t *time, Point2Raw const *offset) {
    DENG2_ASSERT(time);
    time->draw(offset? Vector2i(offset->xy) : Vector2i());
}
static void WorldTimeWidget_UpdateGeometry(guidata_worldtime_t *time) {
    DENG2_ASSERT(time);
    time->updateGeometry();
}
DENG2_PIMPL_NOREF(guidata_worldtime_t) {
    dint days    = 0;
    dint hours   = 0;
    dint minutes = 0;
    dint seconds = 0;
};
guidata_worldtime_t::guidata_worldtime_t(dint player)
    : HudWidget(function_cast<UpdateGeometryFunc>(WorldTimeWidget_UpdateGeometry),
                function_cast<DrawFunc>(WorldTimeWidget_Draw),
                player)
    , d(new Impl)
{}
guidata_worldtime_t::~guidata_worldtime_t()
{}
void guidata_worldtime_t::reset() {
    d->days = d->hours = d->minutes = d->seconds = 0;
}
void guidata_worldtime_t::tick(timespan_t /*elapsed*/)
{
    if(Pause_IsPaused() || !DD_IsSharpTick()) return;
    player_t const &plr = ::players[player()];
    dint wt = plr.worldTimer / TICRATE;
    d->days    = wt / 86400; wt -= d->days * 86400;
    d->hours   = wt / 3600;  wt -= d->hours * 3600;
    d->minutes = wt / 60;    wt -= d->minutes * 60;
    d->seconds = wt;
}
void guidata_worldtime_t::draw(Vector2i const &offset) const {
#define LEADING         ( 0.5 )
    dfloat const textOpacity = ::uiRendState->pageAlpha * ::cfg.common.hudColor[3];
    if(!ST_AutomapIsOpen(player())) return;
    auto const secondsAsText = String("%1").arg(d->seconds, 2, 10, QChar('0'));
    auto const minutesAsText = String("%1").arg(d->minutes, 2, 10, QChar('0'));
    auto const hoursAsText   = String("%1").arg(d->hours  , 2, 10, QChar('0'));
    FR_SetFont(font());
    FR_SetTracking(0);
    FR_SetColorAndAlpha(1, 1, 1, textOpacity);
    dint const counterWidth = FR_TextWidth("00");
    dint const spacerWidth  = FR_TextWidth(" : ");
    dint const lineHeight   = FR_TextHeight("00");
    dint x = -counterWidth;
    dint y = 0;
    DGL_MatrixMode(DGL_MODELVIEW);
    DGL_PushMatrix();
    DGL_Translatef(offset.x, offset.y, 0);
    DGL_Scalef(::cfg.common.hudScale, ::cfg.common.hudScale, 1);
    DGL_Enable(DGL_TEXTURE_2D);
    FR_DrawTextXY(secondsAsText.toUtf8().constData(), x, y);
    x -= spacerWidth;
    FR_DrawCharXY2(':', x + spacerWidth/2, y, ALIGN_TOP);
    x -= counterWidth;
    FR_DrawTextXY(minutesAsText.toUtf8().constData(), x, y);
    x -= spacerWidth;
    FR_DrawCharXY2(':', x + spacerWidth/2, y, ALIGN_TOP);
    x -= counterWidth;
    FR_DrawTextXY(hoursAsText.toUtf8().constData(), x, y);
    y += lineHeight;
    if(d->days) {
        auto const daysAsText = String("%1").arg(d->days, 2, 10, QChar('0')) + " day" + DENG2_PLURAL_S(d->days);
        y += lineHeight * LEADING;  // Extra padding.
        FR_DrawTextXY(daysAsText.toUtf8().constData(), 0, y);
        y += lineHeight;
        if(d->days >= 5) {
            y += lineHeight * LEADING;  // Extra padding.
            FR_DrawTextXY("You Freak!!!", 0, y);
        }
    }
    DGL_Disable(DGL_TEXTURE_2D);
    DGL_MatrixMode(DGL_MODELVIEW);
    DGL_PopMatrix();
#undef LEADING
}
void guidata_worldtime_t::updateGeometry() {
#define LEADING             ( 0.5 )
    Rect_SetWidthHeight(&geometry(), 0, 0);
    if(!ST_AutomapIsOpen(player())) return;
    FR_SetFont(font());
    FR_SetTracking(0);
    dint const counterWidth = FR_TextWidth("00");
    dint const spacerWidth  = FR_TextWidth(" : ");
    dint const lineHeight   = FR_TextHeight("00");
    dint x = -(counterWidth * 2 + spacerWidth * 3);
    dint y = lineHeight;
    if(d->days) {
        y += lineHeight * LEADING;  // Extra padding.
        y += lineHeight;
        if(d->days >= 5) {
            y += lineHeight * LEADING;  // Extra padding.
            x = -de::max(std::abs(x), FR_TextWidth("You Freak!!!"));
            y += lineHeight;
        }
    }
    Rect_SetWidthHeight(&geometry(), x * cfg.common.hudScale, y * cfg.common.hudScale);
#undef LEADING
}
