﻿/*
 * The Doomsday Engine Project -- libcore
 *
 * Copyright © 2004-2017 Jaakko Keränen <jaakko.keranen@iki.fi>
 *
 * @par License
 * LGPL: http://www.gnu.org/licenses/lgpl.html
 *
 * <small>This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or (at your
 * option) any later version. This program is distributed in the hope that it
 * will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
 * General Public License for more details. You should have received a copy of
 * the GNU Lesser General Public License along with this program; if not, see:
 * http://www.gnu.org/licenses</small>
 */
#include "de/ArrayExpression"
#include "de/Evaluator"
#include "de/Expression"
#include "de/ArrayValue"
#include "de/Writer"
#include "de/Reader"
/*
 * The Doomsday Engine Project -- libcore
 *
 * Copyright © 2004-2017 Jaakko Keränen <jaakko.keranen@iki.fi>
 *
 * @par License
 * LGPL: http://www.gnu.org/licenses/lgpl.html
 *
 * <small>This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or (at your
 * option) any later version. This program is distributed in the hope that it
 * will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
 * General Public License for more details. You should have received a copy of
 * the GNU Lesser General Public License along with this program; if not, see:
 * http://www.gnu.org/licenses</small>
 */
#include "de/AssignStatement"
#include "de/Context"
#include "de/Expression"
#include "de/ArrayValue"
#include "de/RefValue"
#include "de/Writer"
#include "de/Reader"
/** @file bindings_core.cpp
 *
 * @authors Copyright (c) 2015-2017 Jaakko Keränen <jaakko.keranen@iki.fi>
 *
 * @par License
 * LGPL: http://www.gnu.org/licenses/lgpl.html
 *
 * <small>This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or (at your
 * option) any later version. This program is distributed in the hope that it
 * will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
 * General Public License for more details. You should have received a copy of
 * the GNU Lesser General Public License along with this program; if not, see:
 * http://www.gnu.org/licenses</small>
 */
#include "de/Animation"
#include "de/AnimationValue"
#include "de/App"
#include "de/BlockValue"
#include "de/Context"
#include "de/DictionaryValue"
#include "de/Folder"
#include "de/Function"
#include "de/NativePointerValue"
#include "de/Path"
#include "de/Record"
#include "de/RecordValue"
#include "de/RemoteFile"
#include "de/TextValue"
#include "de/TimeValue"
/** @file bindings_math.cpp  Built-in Math module.
 *
 * @authors Copyright (c) 2015-2017 Jaakko Keränen <jaakko.keranen@iki.fi>
 *
 * @par License
 * LGPL: http://www.gnu.org/licenses/lgpl.html
 *
 * <small>This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or (at your
 * option) any later version. This program is distributed in the hope that it
 * will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
 * General Public License for more details. You should have received a copy of
 * the GNU Lesser General Public License along with this program; if not, see:
 * http://www.gnu.org/licenses</small>
 */
#include "../src/scriptsys/bindings_math.h"
#include "de/math.h"
#include <de/NumberValue>
/*
 * The Doomsday Engine Project -- libcore
 *
 * Copyright © 2004-2017 Jaakko Keränen <jaakko.keranen@iki.fi>
 *
 * @par License
 * LGPL: http://www.gnu.org/licenses/lgpl.html
 *
 * <small>This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or (at your
 * option) any later version. This program is distributed in the hope that it
 * will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
 * General Public License for more details. You should have received a copy of
 * the GNU Lesser General Public License along with this program; if not, see:
 * http://www.gnu.org/licenses</small>
 */
#include "de/BuiltInExpression"
#include "de/App"
#include "de/ArrayValue"
#include "de/BlockValue"
#include "de/DictionaryValue"
#include "de/Evaluator"
#include "de/Folder"
#include "de/NumberValue"
#include "de/Process"
#include "de/Reader"
#include "de/RecordValue"
#include "de/RefValue"
#include "de/Script"
#include "de/TextValue"
#include "de/TimeValue"
#include "de/Writer"
#include "de/math.h"
/*
 * The Doomsday Engine Project -- libcore
 *
 * Copyright © 2009-2017 Jaakko Keränen <jaakko.keranen@iki.fi>
 *
 * @par License
 * LGPL: http://www.gnu.org/licenses/lgpl.html
 *
 * <small>This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or (at your
 * option) any later version. This program is distributed in the hope that it
 * will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
 * General Public License for more details. You should have received a copy of
 * the GNU Lesser General Public License along with this program; if not, see:
 * http://www.gnu.org/licenses</small>
 */
#include "de/CatchStatement"
#include "de/NameExpression"
#include "de/Writer"
#include "de/Reader"
#include "de/Context"
#include "de/TextValue"
#include "de/RefValue"
/*
 * The Doomsday Engine Project -- libcore
 *
 * Copyright © 2004-2017 Jaakko Keränen <jaakko.keranen@iki.fi>
 *
 * @par License
 * LGPL: http://www.gnu.org/licenses/lgpl.html
 *
 * <small>This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or (at your
 * option) any later version. This program is distributed in the hope that it
 * will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
 * General Public License for more details. You should have received a copy of
 * the GNU Lesser General Public License along with this program; if not, see:
 * http://www.gnu.org/licenses</small>
 */
#include "de/Compound"
#include "de/Statement"
#include "de/Writer"
#include "de/Reader"
/*
 * The Doomsday Engine Project -- libcore
 *
 * Copyright © 2004-2017 Jaakko Keränen <jaakko.keranen@iki.fi>
 *
 * @par License
 * LGPL: http://www.gnu.org/licenses/lgpl.html
 *
 * <small>This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or (at your
 * option) any later version. This program is distributed in the hope that it
 * will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
 * General Public License for more details. You should have received a copy of
 * the GNU Lesser General Public License along with this program; if not, see:
 * http://www.gnu.org/licenses</small>
 */
#include "de/ConstantExpression"
#include "de/NumberValue"
#include "de/NoneValue"
#include "de/Writer"
#include "de/Reader"
#include "de/math.h"
/*
 * The Doomsday Engine Project -- libcore
 *
 * Copyright © 2004-2017 Jaakko Keränen <jaakko.keranen@iki.fi>
 *
 * @par License
 * LGPL: http://www.gnu.org/licenses/lgpl.html
 *
 * <small>This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or (at your
 * option) any later version. This program is distributed in the hope that it
 * will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
 * General Public License for more details. You should have received a copy of
 * the GNU Lesser General Public License along with this program; if not, see:
 * http://www.gnu.org/licenses</small>
 */
#include "de/Context"
#include "de/Statement"
#include "de/Process"
#include "de/RecordValue"
/*
 * The Doomsday Engine Project -- libcore
 *
 * Copyright © 2012-2017 Jaakko Keränen <jaakko.keranen@iki.fi>
 *
 * @par License
 * LGPL: http://www.gnu.org/licenses/lgpl.html
 *
 * <small>This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or (at your
 * option) any later version. This program is distributed in the hope that it
 * will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
 * General Public License for more details. You should have received a copy of
 * the GNU Lesser General Public License along with this program; if not, see:
 * http://www.gnu.org/licenses</small>
 */
#include "de/DeleteStatement"
#include "de/Context"
#include "de/ArrayValue"
#include "de/RefValue"
#include "de/Writer"
#include "de/Reader"
/*
 * The Doomsday Engine Project -- libcore
 *
 * Copyright © 2004-2017 Jaakko Keränen <jaakko.keranen@iki.fi>
 *
 * @par License
 * LGPL: http://www.gnu.org/licenses/lgpl.html
 *
 * <small>This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or (at your
 * option) any later version. This program is distributed in the hope that it
 * will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
 * General Public License for more details. You should have received a copy of
 * the GNU Lesser General Public License along with this program; if not, see:
 * http://www.gnu.org/licenses</small>
 */
#include "de/DictionaryExpression"
#include "de/DictionaryValue"
#include "de/Evaluator"
#include "de/Writer"
#include "de/Reader"
#include <list>
/*
 * The Doomsday Engine Project -- libcore
 *
 * Copyright © 2004-2017 Jaakko Keränen <jaakko.keranen@iki.fi>
 *
 * @par License
 * LGPL: http://www.gnu.org/licenses/lgpl.html
 *
 * <small>This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or (at your
 * option) any later version. This program is distributed in the hope that it
 * will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
 * General Public License for more details. You should have received a copy of
 * the GNU Lesser General Public License along with this program; if not, see:
 * http://www.gnu.org/licenses</small>
 */
#include "de/Evaluator"
#include "de/Expression"
#include "de/Value"
#include "de/Context"
#include "de/Process"
#include <QList>
/*
 * The Doomsday Engine Project -- libcore
 *
 * Copyright © 2004-2017 Jaakko Keränen <jaakko.keranen@iki.fi>
 *
 * @par License
 * LGPL: http://www.gnu.org/licenses/lgpl.html
 *
 * <small>This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or (at your
 * option) any later version. This program is distributed in the hope that it
 * will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
 * General Public License for more details. You should have received a copy of
 * the GNU Lesser General Public License along with this program; if not, see:
 * http://www.gnu.org/licenses</small>
 */
#include "de/Expression"
#include "de/Evaluator"
#include "de/ArrayExpression"
#include "de/BuiltInExpression"
#include "de/ConstantExpression"
#include "de/DictionaryExpression"
#include "de/NameExpression"
#include "de/OperatorExpression"
#include "de/Writer"
#include "de/Reader"
/*
 * The Doomsday Engine Project -- libcore
 *
 * Copyright © 2004-2017 Jaakko Keränen <jaakko.keranen@iki.fi>
 *
 * @par License
 * LGPL: http://www.gnu.org/licenses/lgpl.html
 *
 * <small>This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or (at your
 * option) any later version. This program is distributed in the hope that it
 * will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
 * General Public License for more details. You should have received a copy of
 * the GNU Lesser General Public License along with this program; if not, see:
 * http://www.gnu.org/licenses</small>
 */
#include "de/ExpressionStatement"
#include "de/Expression"
#include "de/Context"
#include "de/Evaluator"
#include "de/Writer"
#include "de/ArrayValue"
#include "de/RefValue"
#include "de/Reader"
/*
 * The Doomsday Engine Project -- libcore
 *
 * Copyright © 2004-2017 Jaakko Keränen <jaakko.keranen@iki.fi>
 *
 * @par License
 * LGPL: http://www.gnu.org/licenses/lgpl.html
 *
 * <small>This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or (at your
 * option) any later version. This program is distributed in the hope that it
 * will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
 * General Public License for more details. You should have received a copy of
 * the GNU Lesser General Public License along with this program; if not, see:
 * http://www.gnu.org/licenses</small>
 */
#include "de/FlowStatement"
#include "de/Evaluator"
#include "de/Context"
#include "de/Process"
#include "de/Expression"
#include "de/Value"
#include "de/Writer"
#include "de/Reader"
/*
 * The Doomsday Engine Project -- libcore
 *
 * Copyright © 2004-2017 Jaakko Keränen <jaakko.keranen@iki.fi>
 *
 * @par License
 * LGPL: http://www.gnu.org/licenses/lgpl.html
 *
 * <small>This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or (at your
 * option) any later version. This program is distributed in the hope that it
 * will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
 * General Public License for more details. You should have received a copy of
 * the GNU Lesser General Public License along with this program; if not, see:
 * http://www.gnu.org/licenses</small>
 */
#include "de/ForStatement"
#include "de/Expression"
#include "de/Context"
#include "de/Evaluator"
#include "de/Process"
#include "de/Value"
#include "de/Variable"
#include "de/RefValue"
#include "de/Writer"
#include "de/Reader"
/*
 * The Doomsday Engine Project -- libcore
 *
 * Copyright © 2004-2017 Jaakko Keränen <jaakko.keranen@iki.fi>
 *
 * @par License
 * LGPL: http://www.gnu.org/licenses/lgpl.html
 *
 * <small>This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or (at your
 * option) any later version. This program is distributed in the hope that it
 * will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
 * General Public License for more details. You should have received a copy of
 * the GNU Lesser General Public License along with this program; if not, see:
 * http://www.gnu.org/licenses</small>
 */
#include "de/Function"
#include "de/TextValue"
#include "de/ArrayValue"
#include "de/DictionaryValue"
#include "de/NoneValue"
#include "de/FunctionValue"
#include "de/Writer"
#include "de/Reader"
#include "de/Log"
#include <QTextStream>
#include <QMap>
/*
 * The Doomsday Engine Project -- libcore
 *
 * Copyright © 2004-2017 Jaakko Keränen <jaakko.keranen@iki.fi>
 *
 * @par License
 * LGPL: http://www.gnu.org/licenses/lgpl.html
 *
 * <small>This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or (at your
 * option) any later version. This program is distributed in the hope that it
 * will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
 * General Public License for more details. You should have received a copy of
 * the GNU Lesser General Public License along with this program; if not, see:
 * http://www.gnu.org/licenses</small>
 */
#include "de/FunctionStatement"
#include "de/Function"
#include "de/Context"
#include "de/ConstantExpression"
#include "de/TextValue"
#include "de/ArrayValue"
#include "de/DictionaryValue"
#include "de/FunctionValue"
#include "de/RefValue"
#include "de/Process"
#include "de/Writer"
#include "de/Reader"
/*
 * The Doomsday Engine Project -- libcore
 *
 * Copyright © 2004-2017 Jaakko Keränen <jaakko.keranen@iki.fi>
 *
 * @par License
 * LGPL: http://www.gnu.org/licenses/lgpl.html
 *
 * <small>This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or (at your
 * option) any later version. This program is distributed in the hope that it
 * will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
 * General Public License for more details. You should have received a copy of
 * the GNU Lesser General Public License along with this program; if not, see:
 * http://www.gnu.org/licenses</small>
 */
#include "de/FunctionValue"
#include "de/Process"
#include "de/ArrayValue"
#include "de/Writer"
#include "de/Reader"
/*
 * The Doomsday Engine Project -- libcore
 *
 * Copyright © 2004-2017 Jaakko Keränen <jaakko.keranen@iki.fi>
 *
 * @par License
 * LGPL: http://www.gnu.org/licenses/lgpl.html
 *
 * <small>This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or (at your
 * option) any later version. This program is distributed in the hope that it
 * will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
 * General Public License for more details. You should have received a copy of
 * the GNU Lesser General Public License along with this program; if not, see:
 * http://www.gnu.org/licenses</small>
 */
#include "de/IfStatement"
#include "de/Context"
#include "de/Expression"
#include "de/Value"
#include "de/Writer"
#include "de/Reader"
/*
 * The Doomsday Engine Project -- libcore
 *
 * Copyright © 2004-2017 Jaakko Keränen <jaakko.keranen@iki.fi>
 *
 * @par License
 * LGPL: http://www.gnu.org/licenses/lgpl.html
 *
 * <small>This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or (at your
 * option) any later version. This program is distributed in the hope that it
 * will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
 * General Public License for more details. You should have received a copy of
 * the GNU Lesser General Public License along with this program; if not, see:
 * http://www.gnu.org/licenses</small>
 */
#include "de/Lex"
#include "de/TokenBuffer"
#include <cctype>
/*
 * The Doomsday Engine Project -- libcore
 *
 * Copyright © 2009-2017 Jaakko Keränen <jaakko.keranen@iki.fi>
 *
 * @par License
 * LGPL: http://www.gnu.org/licenses/lgpl.html
 *
 * <small>This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or (at your
 * option) any later version. This program is distributed in the hope that it
 * will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
 * General Public License for more details. You should have received a copy of
 * the GNU Lesser General Public License along with this program; if not, see:
 * http://www.gnu.org/licenses</small>
 */
#include "de/Module"
#include "de/File"
#include "de/Process"
#include "de/App"
#include "de/Folder"
#include "de/Script"
/*
 * The Doomsday Engine Project -- libcore
 *
 * Copyright © 2004-2017 Jaakko Keränen <jaakko.keranen@iki.fi>
 *
 * @par License
 * LGPL: http://www.gnu.org/licenses/lgpl.html
 *
 * <small>This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or (at your
 * option) any later version. This program is distributed in the hope that it
 * will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
 * General Public License for more details. You should have received a copy of
 * the GNU Lesser General Public License along with this program; if not, see:
 * http://www.gnu.org/licenses</small>
 */
#include "de/NameExpression"
#include "de/App"
#include "de/ArrayValue"
#include "de/Evaluator"
#include "de/Module"
#include "de/Process"
#include "de/Reader"
#include "de/RecordValue"
#include "de/RefValue"
#include "de/ScopeStatement"
#include "de/ScriptSystem"
#include "de/TextValue"
#include "de/Writer"
/*
 * The Doomsday Engine Project -- libcore
 *
 * Copyright © 2004-2017 Jaakko Keränen <jaakko.keranen@iki.fi>
 *
 * @par License
 * LGPL: http://www.gnu.org/licenses/lgpl.html
 *
 * <small>This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or (at your
 * option) any later version. This program is distributed in the hope that it
 * will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
 * General Public License for more details. You should have received a copy of
 * the GNU Lesser General Public License along with this program; if not, see:
 * http://www.gnu.org/licenses</small>
 */
#include "de/Operator"
#include "de/String"
/*
 * The Doomsday Engine Project -- libcore
 *
 * Copyright © 2004-2017 Jaakko Keränen <jaakko.keranen@iki.fi>
 *
 * @par License
 * LGPL: http://www.gnu.org/licenses/lgpl.html
 *
 * <small>This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or (at your
 * option) any later version. This program is distributed in the hope that it
 * will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
 * General Public License for more details. You should have received a copy of
 * the GNU Lesser General Public License along with this program; if not, see:
 * http://www.gnu.org/licenses</small>
 */
#include "de/OperatorExpression"
#include "de/Evaluator"
#include "de/Value"
#include "de/NumberValue"
#include "de/TextValue"
#include "de/ArrayValue"
#include "de/RefValue"
#include "de/RecordValue"
#include "de/NoneValue"
#include "de/Writer"
#include "de/Reader"
#include "de/math.h"
/*
 * The Doomsday Engine Project -- libcore
 *
 * Copyright © 2004-2017 Jaakko Keränen <jaakko.keranen@iki.fi>
 *
 * @par License
 * LGPL: http://www.gnu.org/licenses/lgpl.html
 *
 * <small>This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or (at your
 * option) any later version. This program is distributed in the hope that it
 * will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
 * General Public License for more details. You should have received a copy of
 * the GNU Lesser General Public License along with this program; if not, see:
 * http://www.gnu.org/licenses</small>
 */
#include "de/Parser"
#include "de/ArrayExpression"
#include "de/AssignStatement"
#include "de/BuiltInExpression"
#include "de/CatchStatement"
#include "de/ConstantExpression"
#include "de/DeleteStatement"
#include "de/DictionaryExpression"
#include "de/ExpressionStatement"
#include "de/FlowStatement"
#include "de/ForStatement"
#include "de/FunctionStatement"
#include "de/IfStatement"
#include "de/LogBuffer"
#include "de/NameExpression"
#include "de/NumberValue"
#include "de/Operator"
#include "de/OperatorExpression"
#include "de/PrintStatement"
#include "de/ScopeStatement"
#include "de/Script"
#include "de/ScriptLex"
#include "de/TextValue"
#include "de/TokenBuffer"
#include "de/TokenRange"
#include "de/TryStatement"
#include "de/WhileStatement"
#include <sstream>
/*
 * The Doomsday Engine Project -- libcore
 *
 * Copyright © 2004-2017 Jaakko Keränen <jaakko.keranen@iki.fi>
 *
 * @par License
 * LGPL: http://www.gnu.org/licenses/lgpl.html
 *
 * <small>This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or (at your
 * option) any later version. This program is distributed in the hope that it
 * will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
 * General Public License for more details. You should have received a copy of
 * the GNU Lesser General Public License along with this program; if not, see:
 * http://www.gnu.org/licenses</small>
 */
#include "de/PrintStatement"
#include "de/Context"
#include "de/ArrayValue"
#include "de/ArrayExpression"
#include "de/Writer"
#include "de/Reader"
#include "de/Log"
#include <QTextStream>
/*
 * The Doomsday Engine Project -- libcore
 *
 * Copyright © 2004-2017 Jaakko Keränen <jaakko.keranen@iki.fi>
 *
 * @par License
 * LGPL: http://www.gnu.org/licenses/lgpl.html
 *
 * <small>This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or (at your
 * option) any later version. This program is distributed in the hope that it
 * will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
 * General Public License for more details. You should have received a copy of
 * the GNU Lesser General Public License along with this program; if not, see:
 * http://www.gnu.org/licenses</small>
 */
#include "de/Process"
#include "de/Variable"
#include "de/ArrayValue"
#include "de/RecordValue"
#include "de/TextValue"
#include "de/NoneValue"
#include "de/TryStatement"
#include "de/CatchStatement"
#include <sstream>
/** @file scheduler.cpp  Scheduler for scripts and timelines.
 *
 * @authors Copyright (c) 2017 Jaakko Keränen <jaakko.keranen@iki.fi>
 *
 * @par License
 * LGPL: http://www.gnu.org/licenses/lgpl.html
 *
 * <small>This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or (at your
 * option) any later version. This program is distributed in the hope that it
 * will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
 * General Public License for more details. You should have received a copy of
 * the GNU Lesser General Public License along with this program; if not, see:
 * http://www.gnu.org/licenses</small>
 */
#include "de/Scheduler"
#include <QHash>
/** @file scopestatement.cpp  Scope statement.
 *
 * @authors Copyright (c) 2014-2017 Jaakko Keränen <jaakko.keranen@iki.fi>
 *
 * @par License
 * LGPL: http://www.gnu.org/licenses/lgpl.html
 *
 * <small>This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or (at your
 * option) any later version. This program is distributed in the hope that it
 * will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
 * General Public License for more details. You should have received a copy of
 * the GNU Lesser General Public License along with this program; if not, see:
 * http://www.gnu.org/licenses</small>
 */
#include "de/ScopeStatement"
#include "de/Evaluator"
#include "de/Context"
#include "de/RecordValue"
#include "de/ArrayValue"
#include "de/Process"
#include "de/Reader"
#include "de/Writer"
/*
 * The Doomsday Engine Project -- libcore
 *
 * Copyright © 2004-2017 Jaakko Keränen <jaakko.keranen@iki.fi>
 *
 * @par License
 * LGPL: http://www.gnu.org/licenses/lgpl.html
 *
 * <small>This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or (at your
 * option) any later version. This program is distributed in the hope that it
 * will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
 * General Public License for more details. You should have received a copy of
 * the GNU Lesser General Public License along with this program; if not, see:
 * http://www.gnu.org/licenses</small>
 */
#include "de/Script"
#include "de/Parser"
#include "de/File"
/** @file scriptedinfo.cpp  Info document tree with script context.
 *
 * @authors Copyright © 2013-2017 Jaakko Keränen <jaakko.keranen@iki.fi>
 *
 * @par License
 * LGPL: http://www.gnu.org/licenses/lgpl.html
 *
 * <small>This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or (at your
 * option) any later version. This program is distributed in the hope that it
 * will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
 * General Public License for more details. You should have received a copy of
 * the GNU Lesser General Public License along with this program; if not, see:
 * http://www.gnu.org/licenses</small>
 */
#include "de/ScriptedInfo"
#include "de/App"
#include "de/ArrayValue"
#include "de/Folder"
#include "de/LogBuffer"
#include "de/NumberValue"
#include "de/Process"
#include "de/RecordValue"
#include "de/Script"
#include "de/TextValue"
#include <algorithm>
/*
 * The Doomsday Engine Project -- libcore
 *
 * Copyright © 2004-2017 Jaakko Keränen <jaakko.keranen@iki.fi>
 *
 * @par License
 * LGPL: http://www.gnu.org/licenses/lgpl.html
 *
 * <small>This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or (at your
 * option) any later version. This program is distributed in the hope that it
 * will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
 * General Public License for more details. You should have received a copy of
 * the GNU Lesser General Public License along with this program; if not, see:
 * http://www.gnu.org/licenses</small>
 */
#include "de/ScriptLex"
#include "de/TokenBuffer"
#include "de/Vector"
/** @file scriptsystem.cpp  Subsystem for scripts.
 *
 * @authors Copyright © 2013-2017 Jaakko Keränen <jaakko.keranen@iki.fi>
 *
 * @par License
 * LGPL: http://www.gnu.org/licenses/lgpl.html
 *
 * <small>This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or (at your
 * option) any later version. This program is distributed in the hope that it
 * will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
 * General Public License for more details. You should have received a copy of
 * the GNU Lesser General Public License along with this program; if not, see:
 * http://www.gnu.org/licenses</small>
 */
#include "de/ScriptSystem"
#include "de/Animation"
#include "de/App"
#include "de/ArrayValue"
#include "de/BlockValue"
#include "de/Config"
#include "de/DictionaryValue"
#include "de/FileSystem"
#include "de/Module"
#include "de/NumberValue"
#include "de/Record"
#include "de/RecordValue"
#include "de/TextValue"
#include "de/Version"
#include "de/math.h"
#include "../src/scriptsys/bindings_core.h"
#include "../src/scriptsys/bindings_math.h"
#include <QMap>
/*
 * The Doomsday Engine Project -- libcore
 *
 * Copyright © 2009-2017 Jaakko Keränen <jaakko.keranen@iki.fi>
 *
 * @par License
 * LGPL: http://www.gnu.org/licenses/lgpl.html
 *
 * <small>This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or (at your
 * option) any later version. This program is distributed in the hope that it
 * will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
 * General Public License for more details. You should have received a copy of
 * the GNU Lesser General Public License along with this program; if not, see:
 * http://www.gnu.org/licenses</small>
 */
#include "de/Statement"
#include "de/AssignStatement"
#include "de/CatchStatement"
#include "de/DeleteStatement"
#include "de/ExpressionStatement"
#include "de/ForStatement"
#include "de/FunctionStatement"
#include "de/IfStatement"
#include "de/FlowStatement"
#include "de/PrintStatement"
#include "de/ScopeStatement"
#include "de/TryStatement"
#include "de/WhileStatement"
#include "de/Reader"
/** @file scheduler.cpp  Script scheduling utility.
 *
 * @authors Copyright (c) 2015-2017 Jaakko Keränen <jaakko.keranen@iki.fi>
 *
 * @par License
 * LGPL: http://www.gnu.org/licenses/lgpl.html
 *
 * <small>This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or (at your
 * option) any later version. This program is distributed in the hope that it
 * will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
 * General Public License for more details. You should have received a copy of
 * the GNU Lesser General Public License along with this program; if not, see:
 * http://www.gnu.org/licenses</small>
 */
#include "de/Timeline"
#include "de/ScriptedInfo"
#include "de/Record"
#include "de/Script"
#include "de/Process"
#include <queue>
#include <deque>
/*
 * The Doomsday Engine Project -- libcore
 *
 * Copyright © 2004-2017 Jaakko Keränen <jaakko.keranen@iki.fi>
 *
 * @par License
 * LGPL: http://www.gnu.org/licenses/lgpl.html
 *
 * <small>This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or (at your
 * option) any later version. This program is distributed in the hope that it
 * will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
 * General Public License for more details. You should have received a copy of
 * the GNU Lesser General Public License along with this program; if not, see:
 * http://www.gnu.org/licenses</small>
 */
#include "de/TokenBuffer"
#include "de/String"
#include "de/math.h"
#include <QTextStream>
#include <cstring>
/*
 * The Doomsday Engine Project -- libcore
 *
 * Copyright © 2004-2017 Jaakko Keränen <jaakko.keranen@iki.fi>
 *
 * @par License
 * LGPL: http://www.gnu.org/licenses/lgpl.html
 *
 * <small>This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or (at your
 * option) any later version. This program is distributed in the hope that it
 * will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
 * General Public License for more details. You should have received a copy of
 * the GNU Lesser General Public License along with this program; if not, see:
 * http://www.gnu.org/licenses</small>
 */
#include "de/TokenRange"
#include "de/TokenBuffer"
#include <QTextStream>
/*
 * The Doomsday Engine Project -- libcore
 *
 * Copyright © 2009-2017 Jaakko Keränen <jaakko.keranen@iki.fi>
 *
 * @par License
 * LGPL: http://www.gnu.org/licenses/lgpl.html
 *
 * <small>This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or (at your
 * option) any later version. This program is distributed in the hope that it
 * will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
 * General Public License for more details. You should have received a copy of
 * the GNU Lesser General Public License along with this program; if not, see:
 * http://www.gnu.org/licenses</small>
 */
#include "de/TryStatement"
#include "de/Context"
#include "de/Writer"
#include "de/Reader"
/*
 * The Doomsday Engine Project -- libcore
 *
 * Copyright © 2004-2017 Jaakko Keränen <jaakko.keranen@iki.fi>
 *
 * @par License
 * LGPL: http://www.gnu.org/licenses/lgpl.html
 *
 * <small>This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or (at your
 * option) any later version. This program is distributed in the hope that it
 * will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
 * General Public License for more details. You should have received a copy of
 * the GNU Lesser General Public License along with this program; if not, see:
 * http://www.gnu.org/licenses</small>
 */
#include "de/WhileStatement"
#include "de/Expression"
#include "de/Evaluator"
#include "de/Context"
#include "de/Value"
#include "de/Writer"
#include "de/Reader"
using namespace de;
ArrayExpression::ArrayExpression()
{}
ArrayExpression::~ArrayExpression() {
    clear();
}
void ArrayExpression::clear() {
    for (Arguments::iterator i = _arguments.begin(); i != _arguments.end(); ++i) {
        delete *i;
    }
    _arguments.clear();
}
void ArrayExpression::add(Expression *arg) {
    _arguments.push_back(arg);
}
void ArrayExpression::push(Evaluator &evaluator, Value *scope) const {
    Expression::push(evaluator, scope);
    for (Arguments::const_reverse_iterator i = _arguments.rbegin();
        i != _arguments.rend(); ++i) {
        (*i)->push(evaluator);
    }
}
Expression const &ArrayExpression::at(dint pos) const {
    return *_arguments.at(pos);
}
Value *ArrayExpression::evaluate(Evaluator &evaluator) const {
    ArrayValue *value = new ArrayValue;
    for (dsize count = _arguments.size(); count > 0; --count) {
        value->add(evaluator.popResult());
    }
    value->reverse();
    return value;
}
void ArrayExpression::operator >> (Writer &to) const {
    to << SerialId(ARRAY);
    Expression::operator >> (to);
    to << duint16(_arguments.size());
    for (Arguments::const_iterator i = _arguments.begin(); i != _arguments.end(); ++i) {
        to << **i;
    }
}
void ArrayExpression::operator << (Reader &from) {
    SerialId id;
    from >> id;
    if (id != ARRAY) {
        throw DeserializationError("ArrayExpression::operator <<", "Invalid ID");
    }
    Expression::operator << (from);
    duint16 count;
    from >> count;
    clear();
    while (count--) {
        _arguments.push_back(Expression::constructFrom(from));
    }
}
AssignStatement::AssignStatement() : _indexCount(0)
{}
AssignStatement::AssignStatement(Expression *target, Indices const &indices, Expression *value)
    : _indexCount(0) {
    _args.add(value);
    _indexCount = dint(indices.size());
    for (Indices::const_reverse_iterator i = indices.rbegin(); i != indices.rend(); ++i) {
        _args.add(*i);
    }
    _args.add(target);
}
AssignStatement::~AssignStatement()
{}
void AssignStatement::execute(Context &context) const {
    Evaluator &eval = context.evaluator();
    ArrayValue &results = eval.evaluateTo<ArrayValue>(&_args);
    results.reverse();
    RefValue *ref = dynamic_cast<RefValue *>(results.elements().front());
    if (!ref) {
        throw LeftValueError("AssignStatement::execute",
            "Cannot assign into '" + results.at(0).asText() + "'");
    }
    QScopedPointer<Value> value(results.popLast());
    if (_indexCount > 0) {
        Value *target = &ref->dereference();
        for (dint i = 0; i < _indexCount; ++i) {
            QScopedPointer<Value> index(results.popLast()); // Not released -- will be destroyed.
            if (i < _indexCount - 1) {
                target = &target->element(*index.data());
            }
            else {
                target->setElement(*index.data(), value.take());
            }
        }
    }
    else {
        ref->assign(value.take());
    }
    if (_args.back().flags() & Expression::ReadOnly) {
        DENG2_ASSERT(ref->variable() != NULL);
        ref->variable()->setFlags(Variable::ReadOnly, SetFlags);
    }
    context.proceed();
}
void AssignStatement::operator >> (Writer &to) const {
    to << dbyte(SerialId::Assign) << duint8(_indexCount) << _args;
}
void AssignStatement::operator << (Reader &from) {
    SerialId id;
    from.readAs<dbyte>(id);
    if (id != SerialId::Assign) {
        throw DeserializationError("AssignStatement::operator <<", "Invalid ID");
    }
    duint8 count;
    from >> count;
    _indexCount = count;
    from >> _args;
}
namespace de {
static Value *Function_String_FileNamePath(Context &ctx, Function::ArgumentValues const &) {
    return new TextValue(ctx.nativeSelf().asText().fileNamePath());
}
static Value *Function_String_FileNameExtension(Context &ctx, Function::ArgumentValues const &) {
    return new TextValue(ctx.nativeSelf().asText().fileNameExtension());
}
static Value *Function_String_FileNameWithoutExtension(Context &ctx, Function::ArgumentValues const &) {
    return new TextValue(ctx.nativeSelf().asText().fileNameWithoutExtension());
}
static Value *Function_String_FileNameAndPathWithoutExtension(Context &ctx, Function::ArgumentValues const &) {
    return new TextValue(ctx.nativeSelf().asText().fileNameAndPathWithoutExtension());
}
static Value *Function_String_Upper(Context &ctx, Function::ArgumentValues const &) {
    return new TextValue(ctx.nativeSelf().asText().upper());
}
static Value *Function_String_Lower(Context &ctx, Function::ArgumentValues const &) {
    return new TextValue(ctx.nativeSelf().asText().lower());
}
static Value *Function_String_BeginsWith(Context &ctx, Function::ArgumentValues const &args) {
    return new NumberValue(ctx.nativeSelf().asText().beginsWith(args.at(0)->asText()));
}
static Value *Function_String_EndsWith(Context &ctx, Function::ArgumentValues const &args) {
    return new NumberValue(ctx.nativeSelf().asText().endsWith(args.at(0)->asText()));
}
static Value *Function_Path_WithoutFileName(Context &, Function::ArgumentValues const &args) {
    return new TextValue(args.at(0)->asText().fileNamePath());
}
static Value *Function_Dictionary_Keys(Context &ctx, Function::ArgumentValues const &) {
    return ctx.nativeSelf().as<DictionaryValue>().contentsAsArray(DictionaryValue::Keys);
}
static Value *Function_Dictionary_Values(Context &ctx, Function::ArgumentValues const &) {
    return ctx.nativeSelf().as<DictionaryValue>().contentsAsArray(DictionaryValue::Values);
}
static File &fileInstance(Context &ctx) {
    File *file = ctx.selfInstance().get(Record::VAR_NATIVE_SELF)
            .as<NativePointerValue>().nativeObject<File>();
    if (!file) {
        throw Value::IllegalError("ScriptSystem::fileInstance", "Not a File instance");
    }
    return *file;
}
static File const &constFileInstance(Context &ctx) {
    return fileInstance(ctx);
}
static Value *Function_File_Name(Context &ctx, Function::ArgumentValues const &) {
    return new TextValue(constFileInstance(ctx).name());
}
static Value *Function_File_Path(Context &ctx, Function::ArgumentValues const &) {
    return new TextValue(constFileInstance(ctx).path());
}
static Value *Function_File_Type(Context &ctx, Function::ArgumentValues const &) {
    return new TextValue(constFileInstance(ctx).status().type() == File::Type::File? "file" : "folder");
}
static Value *Function_File_Size(Context &ctx, Function::ArgumentValues const &) {
    return new NumberValue(constFileInstance(ctx).size());
}
static Value *Function_File_ModifiedAt(Context &ctx, Function::ArgumentValues const &) {
    return new TimeValue(constFileInstance(ctx).status().modifiedAt);
}
static Value *Function_File_Description(Context &ctx, Function::ArgumentValues const &) {
    return new TextValue(constFileInstance(ctx).description());
}
static Value *Function_File_Locate(Context &ctx, Function::ArgumentValues const &args) {
    Path const relativePath = args.at(0)->asText();
    if (File const *found = maybeAs<File>(constFileInstance(ctx).tryFollowPath(relativePath))) {
        return new RecordValue(found->objectNamespace());
    }
    return nullptr;
}
static Value *Function_File_Read(Context &ctx, Function::ArgumentValues const &) {
    QScopedPointer<BlockValue> data(new BlockValue);
    constFileInstance(ctx) >> *data;
    return data.take();
}
static Value *Function_File_ReadUtf8(Context &ctx, Function::ArgumentValues const &) {
    Block raw;
    constFileInstance(ctx) >> raw;
    return new TextValue(String::fromUtf8(raw));
}
static Value *Function_File_Replace(Context &ctx, Function::ArgumentValues const &args) {
    Folder &parentFolder = fileInstance(ctx).as<Folder>();
    File &created = parentFolder.replaceFile(args.at(0)->asText());
    return new RecordValue(created.objectNamespace());
}
static Value *Function_File_Write(Context &ctx, Function::ArgumentValues const &args) {
    BlockValue const &data = args.at(0)->as<BlockValue>();
    fileInstance(ctx) << data.block();
    return nullptr;
}
static Value *Function_File_Flush(Context &ctx, Function::ArgumentValues const &) {
    fileInstance(ctx).flush();
    return nullptr;
}
static Value *Function_File_MetaId(Context &ctx, Function::ArgumentValues const &) {
    return new TextValue(constFileInstance(ctx).metaId().asHexadecimalText());
}
static Value *Function_Folder_List(Context &ctx, Function::ArgumentValues const &) {
    Folder const &folder = constFileInstance(ctx).as<Folder>();
    std::unique_ptr<ArrayValue> array(new ArrayValue);
    foreach (String name, folder.contents().keys()) {
        *array << new TextValue(name);
    }
    return array.release();
}
static Value *Function_Folder_ContentSize(Context &ctx, Function::ArgumentValues const &) {
    Folder const &folder = constFileInstance(ctx).as<Folder>();
    return new NumberValue(folder.contents().size());
}
static Value *Function_Folder_Contents(Context &ctx, Function::ArgumentValues const &) {
    Folder const &folder = constFileInstance(ctx).as<Folder>();
    LOG_SCR_MSG(_E(m) "%s") << folder.contentsAsText();
    return nullptr;
}
static Value *Function_RemoteFile_Download(Context &ctx, Function::ArgumentValues const &) {
    RemoteFile &rf = fileInstance(ctx).as<RemoteFile>();
    rf.download();
    return nullptr;
}
static Animation &animationInstance(Context &ctx) {
    if (AnimationValue *v = maybeAs<AnimationValue>(ctx.nativeSelf())) {
        return v->animation();
    }
    Animation *obj = ctx.nativeSelf().as<NativePointerValue>().nativeObject<Animation>();
    if (!obj) {
        throw Value::IllegalError("ScriptSystem::animationInstance", "Not an Animation instance");
    }
    return *obj;
}
static Value *Function_Animation_Value(Context &ctx, Function::ArgumentValues const &) {
    return new NumberValue(animationInstance(ctx).value());
}
static Value *Function_Animation_Target(Context &ctx, Function::ArgumentValues const &) {
    return new NumberValue(animationInstance(ctx).target());
}
static Value *Function_Animation_SetValue(Context &ctx, Function::ArgumentValues const &args) {
    animationInstance(ctx).setValue(float(args.at(0)->asNumber()), // value
                                    args.at(1)->asNumber(),        // span
                                    args.at(2)->asNumber());       // delay
    return nullptr;
}
static Value *Function_Animation_SetValueFrom(Context &ctx, Function::ArgumentValues const &args) {
    animationInstance(ctx).setValueFrom(args.at(0)->asNumber(),    // fromValue
                                        args.at(1)->asNumber(),    // toValue
                                        args.at(2)->asNumber(),    // span
                                        args.at(3)->asNumber());   // delay
    return nullptr;
}
void initCoreModule(Binder &binder, Record &coreModule) { {
        Record &dict = coreModule.addSubrecord("Dictionary")
                .setFlags(Record::WontBeDeleted); // optimize: nobody needs to observe deletion
        binder.init(dict)
                << DENG2_FUNC_NOARG(Dictionary_Keys, "keys")
                << DENG2_FUNC_NOARG(Dictionary_Values, "values");
    } {
        Record &str = coreModule.addSubrecord("String").setFlags(Record::WontBeDeleted);
        binder.init(str)
                << DENG2_FUNC_NOARG(String_Upper, "upper")
                << DENG2_FUNC_NOARG(String_Lower, "lower")
                << DENG2_FUNC      (String_BeginsWith, "beginsWith", "text")
                << DENG2_FUNC      (String_EndsWith, "endsWith", "text")
                << DENG2_FUNC_NOARG(String_FileNamePath, "fileNamePath")
                << DENG2_FUNC_NOARG(String_FileNameExtension, "fileNameExtension")
                << DENG2_FUNC_NOARG(String_FileNameWithoutExtension, "fileNameWithoutExtension")
                << DENG2_FUNC_NOARG(String_FileNameAndPathWithoutExtension, "fileNameAndPathWithoutExtension");
    } {
        Record &path = coreModule.addSubrecord("Path").setFlags(Record::WontBeDeleted);
        binder.init(path)
                << DENG2_FUNC(Path_WithoutFileName, "withoutFileName", "path");
    } {
        Record &file = coreModule.addSubrecord("File").setFlags(Record::WontBeDeleted);
        binder.init(file)
                << DENG2_FUNC_NOARG(File_Name, "name")
                << DENG2_FUNC_NOARG(File_Path, "path")
                << DENG2_FUNC_NOARG(File_Type, "type")
                << DENG2_FUNC_NOARG(File_Size, "size")
                << DENG2_FUNC_NOARG(File_MetaId, "metaId")
                << DENG2_FUNC_NOARG(File_ModifiedAt, "modifiedAt")
                << DENG2_FUNC_NOARG(File_Description, "description")
                << DENG2_FUNC      (File_Locate, "locate", "relativePath")
                << DENG2_FUNC_NOARG(File_Read, "read")
                << DENG2_FUNC_NOARG(File_ReadUtf8, "readUtf8")
                << DENG2_FUNC      (File_Replace, "replace", "relativePath")
                << DENG2_FUNC      (File_Write, "write", "data")
                << DENG2_FUNC_NOARG(File_Flush, "flush");
    } {
        Record &folder = coreModule.addSubrecord("Folder").setFlags(Record::WontBeDeleted);
        binder.init(folder)
                << DENG2_FUNC_NOARG(Folder_List, "list")
                << DENG2_FUNC_NOARG(Folder_Contents, "contents")
                << DENG2_FUNC_NOARG(Folder_ContentSize, "contentSize");
    } {
        Record &remoteFile = coreModule.addSubrecord("RemoteFile").setFlags(Record::WontBeDeleted);
        binder.init(remoteFile)
                << DENG2_FUNC_NOARG(RemoteFile_Download, "download");
    } {
        Function::Defaults setValueArgs;
        setValueArgs["span"]  = new NumberValue(0.0);
        setValueArgs["delay"] = new NumberValue(0.0);
        Function::Defaults setValueFromArgs;
        setValueFromArgs["delay"] = new NumberValue(0.0);
        Record &anim = coreModule.addSubrecord("Animation").setFlags(Record::WontBeDeleted);
        binder.init(anim)
                << DENG2_FUNC_NOARG(Animation_Value, "value")
                << DENG2_FUNC_NOARG(Animation_Target, "target")
                << DENG2_FUNC_DEFS (Animation_SetValue, "setValue",
                                    "value" << "span" << "delay", setValueArgs)
                << DENG2_FUNC_DEFS (Animation_SetValueFrom, "setValueFrom",
                                    "fromValue" << "toValue" << "span" << "delay", setValueFromArgs);
    }
}
} // namespace de
namespace de {
static Value *Function_Math_Random(Context &, Function::ArgumentValues const &) {
    return new NumberValue(randf());
}
static Value *Function_Math_RandInt(Context &, Function::ArgumentValues const &args) {
    Rangei range(args.at(0)->asInt(), args.at(1)->asInt() + 1);
    return new NumberValue(range.random());
}
static Value *Function_Math_RandNum(Context &, const Function::ArgumentValues &args) {
    Ranged range(args.at(0)->asNumber(), args.at(1)->asNumber());
    return new NumberValue(range.random());
}
static Value *Function_Math_Cos(Context &, const Function::ArgumentValues &args) {
    return new NumberValue(std::cos(args.at(0)->asNumber()));
}
static Value *Function_Math_Sin(Context &, const Function::ArgumentValues &args) {
    return new NumberValue(std::sin(args.at(0)->asNumber()));
}
static Value *Function_Math_Tan(Context &, const Function::ArgumentValues &args) {
    return new NumberValue(std::tan(args.at(0)->asNumber()));
}
void initMathModule(Binder &binder, Record &mathModule) {
    binder.init(mathModule)
            << DENG2_FUNC_NOARG(Math_Random, "random")
            << DENG2_FUNC      (Math_RandInt, "randInt", "low" << "high")
            << DENG2_FUNC      (Math_RandNum, "randNum", "low" << "high")
            << DENG2_FUNC      (Math_Cos, "cos", "radians")
            << DENG2_FUNC      (Math_Sin, "sin", "radians")
            << DENG2_FUNC      (Math_Tan, "tan", "radians");
}
} // namespace de
BuiltInExpression::BuiltInExpression() : _type(NONE), _arg(0)
{}
BuiltInExpression::BuiltInExpression(Type type, Expression *argument)
    : _type(type), _arg(argument)
{}
BuiltInExpression::~BuiltInExpression() {
    delete _arg;
}
void BuiltInExpression::push(Evaluator &evaluator, Value *scope) const {
    Expression::push(evaluator, scope);
    _arg->push(evaluator);
}
Value *BuiltInExpression::evaluate(Evaluator &evaluator) const {
    std::unique_ptr<Value> value(evaluator.popResult());
    ArrayValue const &args = value.get()->as<ArrayValue>();
    switch (_type) {
    case LENGTH:
        if (args.size() != 2) {
            throw WrongArgumentsError("BuiltInExpression::evaluate",
                "Expected exactly one argument for LENGTH");
        }
        return new NumberValue(args.at(1).size());
    case DICTIONARY_KEYS:
    case DICTIONARY_VALUES: {
        if (args.size() != 2) {
            throw WrongArgumentsError("BuiltInExpression::evaluate",
                "Expected exactly one argument for " +
                String(_type == DICTIONARY_KEYS?
                       "DICTIONARY_KEYS" : "DICTIONARY_VALUES"));
        }
        DictionaryValue const *dict = dynamic_cast<DictionaryValue const *>(&args.at(1));
        if (!dict) {
            throw WrongArgumentsError("BuiltInExpression::evaluate",
                "Argument must be a dictionary");
        }
        return dict->contentsAsArray(_type == DICTIONARY_KEYS ? DictionaryValue::Keys
                                                              : DictionaryValue::Values);
    }
    case DIR: {
        if (args.size() > 2) {
            throw WrongArgumentsError("BuiltInExpression::evaluate",
                                      "Expected exactly at most one arguments for DIR");
        }
        Record const *ns;
        if (args.size() == 1) {
            ns = evaluator.localNamespace();
        }
        else {
            ns = &args.at(1).as<RecordValue>().dereference();
        }
        ArrayValue *keys = new ArrayValue;
        auto names = ns->members().keys();
        qSort(names);
        for (auto const &name : names) {
            *keys << new TextValue(name);
        }
        return keys;
    }
    case RECORD_MEMBERS:
    case RECORD_SUBRECORDS: {
        if (args.size() != 2) {
            throw WrongArgumentsError("BuiltInExpression::evaluate",
                "Expected exactly one argument for " +
                String(_type == RECORD_MEMBERS? "RECORD_MEMBERS" : "RECORD_SUBRECORDS"));
        }
        RecordValue const *rec = dynamic_cast<RecordValue const *>(&args.at(1));
        if (!rec) {
            throw WrongArgumentsError("BuiltInExpression::evaluate",
                "Argument must be a record");
        }
        DictionaryValue *dict = new DictionaryValue();
        if (_type == RECORD_MEMBERS) {
            for (Record::Members::const_iterator i = rec->dereference().members().begin();
                i != rec->dereference().members().end(); ++i) {
                dict->add(new TextValue(i.key()), new RefValue(i.value()));
            }
        }
        else {
            Record::Subrecords subs = rec->dereference().subrecords();
            DENG2_FOR_EACH(Record::Subrecords, i, subs) {
                dict->add(new TextValue(i.key()), new RecordValue(i.value()));
            }
        }
        return dict;
    }
    case AS_RECORD: {
        if (args.size() == 1) {
            return new RecordValue(new Record, RecordValue::OwnsRecord);
        }
        if (args.size() == 2) {
            std::unique_ptr<Record> returned;
            if (const auto *dict = maybeAs<DictionaryValue>(args.at(1))) {
                returned.reset(new Record);
                for (auto i : dict->elements()) {
                    returned->set(i.first.value->asText(), *i.second);
                }
            }
            else if (const auto *rec = maybeAs<RecordValue>(args.at(1))) {
                returned.reset(new Record(rec->dereference()));
            }
            else {
                throw WrongArgumentsError("BuiltInExpression::evaluate",
                                          "Argument 1 of AS_RECORD must be a record or dictionary");
            }
            return new RecordValue(returned.release(), RecordValue::OwnsRecord);
        }
        throw WrongArgumentsError("BuiltInExpression::evaluate",
                                  "Expected less than two arguments for AS_RECORD");
    }
    case AS_FILE: {
        if (args.size() != 2) {
            throw WrongArgumentsError("BuiltInExpression::evaluate",
                                      "Expected exactly one argument for AS_FILE");
        }
        return new RecordValue(App::rootFolder().locate<File>(args.at(1).asText()).objectNamespace());
    }
    case AS_NUMBER:
        if (args.size() != 2) {
            throw WrongArgumentsError("BuiltInExpression::evaluate",
                                      "Expected exactly one argument for AS_NUMBER");
        }
        return new NumberValue(args.at(1).asNumber());
    case AS_TEXT:
        if (args.size() != 2) {
            throw WrongArgumentsError("BuiltInExpression::evaluate",
                                      "Expected exactly one argument for AS_TEXT");
        }
        return new TextValue(args.at(1).asText());
    case AS_TIME:
        if (args.size() == 1) {
            return new TimeValue;
        }
        if (args.size() == 2) {
            Time t = Time::fromText(args.at(1).asText());
            if (!t.isValid()) {
                t = Time::fromText(args.at(1).asText(), Time::ISODateOnly);
            }
            return new TimeValue(t);
        }
        throw WrongArgumentsError("BuiltInExpression::evaluate",
                                  "Expected less than two arguments for AS_TIME");
    case TIME_DELTA: {
        if (args.size() != 3) {
            throw WrongArgumentsError("BuiltInExpression::evaluate",
                                      "Expected exactly two arguments for TIME_DELTA");
        }
        TimeValue const *fromTime = dynamic_cast<TimeValue const *>(&args.at(1));
        if (!fromTime) {
            throw WrongArgumentsError("BuiltInExpression::evaluate", "Argument 1 of TIME_DELTA must be a time");
        }
        TimeValue const *toTime = dynamic_cast<TimeValue const *>(&args.at(2));
        if (!toTime) {
            throw WrongArgumentsError("BuiltInExpression::evaluate", "Argument 2 of TIME_DELTA must be a time");
        }
        return new NumberValue(toTime->time() - fromTime->time());
    }
    case LOCAL_NAMESPACE: {
        if (args.size() != 1) {
            throw WrongArgumentsError("BuiltInExpression::evaluate",
                "No arguments expected for LOCAL_NAMESPACE");
        }
        return new RecordValue(evaluator.localNamespace());
    }
    case GLOBAL_NAMESPACE: {
        if (args.size() != 1) {
            throw WrongArgumentsError("BuiltInExpression::evaluate",
                "No arguments expected for GLOBAL_NAMESPACE");
        }
        return new RecordValue(evaluator.process().globals());
    }
    case SERIALIZE: {
        if (args.size() != 2) {
            throw WrongArgumentsError("BuiltInExpression::evaluate",
                "Expected exactly one argument for SERIALIZE");
        }
        std::unique_ptr<BlockValue> data(new BlockValue);
        Writer(*data.get()) << args.at(1);
        return data.release();
    }
    case DESERIALIZE: {
        if (args.size() != 2) {
            throw WrongArgumentsError("BuiltInExpression::evaluate",
                "Expected exactly one argument for DESERIALIZE");
        }
        BlockValue const *block = dynamic_cast<BlockValue const *>(&args.at(1));
        if (block) {
            Reader reader(*block);
            return Value::constructFrom(reader);
        }
        /*
        TextValue const *text = dynamic_cast<TextValue const *>(&args.at(1));
        if (text) {
            return Value::constructFrom(Reader(Block(text->asText().toUtf8())));
        }
        */
        throw WrongArgumentsError("BuiltInExpression::evaluate",
            "deserialize() can operate only on block values");
    }
    case FLOOR:
        if (args.size() != 2) {
            throw WrongArgumentsError("BuiltInExpression::evaluate",
                                      "Expected exactly one argument for FLOOR");
        }
        return new NumberValue(std::floor(args.at(1).asNumber()));
    case EVALUATE: {
        if (args.size() != 2) {
            throw WrongArgumentsError("BuiltInExpression::evaluate",
                                      "Expected exactly one argument for EVALUATE");
        }
        Process subProcess(evaluator.localNamespace());
        Script subScript(args.at(1).asText());
        subProcess.run(subScript);
        subProcess.execute();
        return subProcess.context().evaluator().result().duplicate();
    }
    case TYPE_OF:
        if (args.size() != 2) {
            throw WrongArgumentsError("BuiltInExpression::evaluate",
                                      "Expected exactly one argument for TYPE_OF");
        }
        return new TextValue(args.at(1).typeId());
    default:
        DENG2_ASSERT(false);
    }
    return NULL;
}
void BuiltInExpression::operator >> (Writer &to) const {
    to << SerialId(BUILT_IN);
    Expression::operator >> (to);
    to << duint8(_type) << *_arg;
}
void BuiltInExpression::operator << (Reader &from) {
    SerialId id;
    from >> id;
    if (id != BUILT_IN) {
        throw DeserializationError("BuiltInExpression::operator <<", "Invalid ID");
    }
    Expression::operator << (from);
    duint8 t;
    from >> t;
    _type = Type(t);
    delete _arg;
    _arg = 0;
    _arg = Expression::constructFrom(from);
}
static QHash<String, BuiltInExpression::Type> const types {
    { "File",        BuiltInExpression::AS_FILE },
    { "Number",      BuiltInExpression::AS_NUMBER },
    { "Record",      BuiltInExpression::AS_RECORD },
    { "Text",        BuiltInExpression::AS_TEXT },
    { "Time",        BuiltInExpression::AS_TIME },
    { "deserialize", BuiltInExpression::DESERIALIZE },
    { "dictkeys",    BuiltInExpression::DICTIONARY_KEYS },
    { "dictvalues",  BuiltInExpression::DICTIONARY_VALUES },
    { "dir",         BuiltInExpression::DIR },
    { "eval",        BuiltInExpression::EVALUATE },
    { "floor",       BuiltInExpression::FLOOR },
    { "globals",     BuiltInExpression::GLOBAL_NAMESPACE },
    { "len",         BuiltInExpression::LENGTH },
    { "locals",      BuiltInExpression::LOCAL_NAMESPACE },
    { "members",     BuiltInExpression::RECORD_MEMBERS },
    { "serialize",   BuiltInExpression::SERIALIZE },
    { "subrecords",  BuiltInExpression::RECORD_SUBRECORDS },
    { "timedelta",   BuiltInExpression::TIME_DELTA },
    { "typeof",      BuiltInExpression::TYPE_OF },
};
BuiltInExpression::Type BuiltInExpression::findType(String const &identifier) {
    auto found = types.find(identifier);
    if (found != types.end()) return found.value();
    return NONE;
}
StringList BuiltInExpression::identifiers() {
    StringList names;
    foreach (auto const &t, types.keys()) {
        names << t;
    }
    return names;
}
CatchStatement::CatchStatement(ArrayExpression *args) : _args(args) {
    if (!_args) {
        _args = new ArrayExpression;
    }
}
CatchStatement::~CatchStatement() {
    delete _args;
}
void CatchStatement::execute(Context &context) const {
    context.proceed();
}
bool CatchStatement::isFinal() const {
    return flags.testFlag(FinalCompound);
}
bool CatchStatement::matches(const Error &err) const {
    if (!_args->size()) {
        return true;
    }
    const NameExpression &name = static_cast<const NameExpression &>(_args->at(0));
    return (name.identifier() == "Error" ||   // Generic catch-all.
            name.identifier() == err.name() || // Exact match.
            String(err.name()).endsWith("_" + name.identifier())); // Sub-error match.
}
void CatchStatement::executeCatch(Context &context, Error const &err) const {
    if (_args->size() > 1) {
        RefValue &ref = context.evaluator().evaluateTo<RefValue>(&_args->at(1));
        ref.assign(new TextValue(err.asText()));
    }
    context.start(_compound.firstStatement(), next());
}
void CatchStatement::operator >> (Writer &to) const {
    to << dbyte(SerialId::Catch) << duint8(flags) << *_args << _compound;
}
void CatchStatement::operator << (Reader &from) {
    SerialId id;
    from.readAs<dbyte>(id);
    if (id != SerialId::Catch) {
        throw DeserializationError("CatchStatement::operator <<", "Invalid ID");
    }
    duint8 f;
    from >> f;
    flags = Flags(f);
    from >> *_args >> _compound;
}
Compound::Compound()
{}
Compound::~Compound() {
    clear();
}
void Compound::clear() {
    for (Statements::iterator i = _statements.begin(); i != _statements.end(); ++i) {
        delete *i;
    }
    _statements.clear();
}
Statement const *Compound::firstStatement() const {
    if (_statements.empty()) {
        return NULL;
    }
    return *_statements.begin();
}
void Compound::add(Statement *statement, duint lineNumber) {
    statement->setLineNumber(lineNumber);
    if (_statements.size() > 0) {
        _statements.back()->setNext(statement);
    }
    _statements.push_back(statement);
}
void Compound::operator >> (Writer &to) const {
    to << duint32(_statements.size());
    for (Statements::const_iterator i = _statements.begin(); i != _statements.end(); ++i) {
        to << **i;
    }
}
void Compound::operator << (Reader &from) {
    duint32 count;
    from >> count;
    clear();
    while (count--) {
        add(Statement::constructFrom(from), 0 /* unknown line number */);
    }
}
ConstantExpression::ConstantExpression() : _value(0)
{}
ConstantExpression::ConstantExpression(Value *value) : _value(value)
{}
ConstantExpression::~ConstantExpression() {
    delete _value;
}
Value *ConstantExpression::evaluate(Evaluator &) const {
    DENG2_ASSERT(_value != 0);
    return _value->duplicate();
}
ConstantExpression *ConstantExpression::None() {
    return new ConstantExpression(new NoneValue());
}
ConstantExpression *ConstantExpression::True() {
    return new ConstantExpression(new NumberValue(NumberValue::True, NumberValue::Boolean));
}
ConstantExpression *ConstantExpression::False() {
    return new ConstantExpression(new NumberValue(NumberValue::False, NumberValue::Boolean));
}
ConstantExpression *ConstantExpression::Pi() {
    return new ConstantExpression(new NumberValue(PI));
}
void ConstantExpression::operator >> (Writer &to) const {
    to << SerialId(CONSTANT);
    Expression::operator >> (to);
    to << *_value;
}
void ConstantExpression::operator << (Reader &from) {
    SerialId id;
    from >> id;
    if (id != CONSTANT) {
        throw DeserializationError("ConstantExpression::operator <<", "Invalid ID");
    }
    Expression::operator << (from);
    delete _value;
    _value = 0;
    _value = Value::constructFrom(from);
}
namespace de {
DENG2_PIMPL(Context) {
    /**
     * Information about the control flow is stored within a stack of
     * ControlFlow instances.
     */
    class ControlFlow {
    public:
        /**
         * Constructor.
         *
         * @param current  Current statement being executed.
         * @param f        Statement where normal flow continues.
         * @param c        Statement where to jump on "continue".
         *                 @c NULL if continuing is not allowed.
         * @param b        Statement where to jump to and flow from on "break".
         *                 @c NULL if breaking is not allowed.
         */
        ControlFlow(Statement const *current,
                    Statement const *f = 0,
                    Statement const *c = 0,
                    Statement const *b = 0)
            : flow(f), jumpContinue(c), jumpBreak(b), iteration(0), _current(current) {}
        Statement const *current() const { return _current; }
        void setCurrent(Statement const *s) { _current = s; }
    public:
        Statement const *flow;
        Statement const *jumpContinue;
        Statement const *jumpBreak;
        Value *iteration; // owned
    private:
        Statement const *_current;
    };
    Type type;
    Process *owner;
    typedef std::vector<ControlFlow> FlowStack;
    FlowStack controlFlow;
    Evaluator evaluator;
    bool ownsNamespace;
    Record *names;
    QScopedPointer<Value> nativeSelf;
    Variable throwaway;
    Impl(Public *i, Type type, Process *owner, Record *globals)
        : Base(i)
        , type(type)
        , owner(owner)
        , evaluator(*i)
        , ownsNamespace(false)
        , names(globals) {
        if (!names) {
            DENG2_ASSERT(type != GlobalNamespace);
            names = new Record;
            ownsNamespace = true;
        }
    }
    ~Impl() {
        if (ownsNamespace) {
            delete names;
        }
        self().reset();
        DENG2_ASSERT(controlFlow.empty());
    }
    ControlFlow &flow() {
        return controlFlow.back();
    }
    void popFlow() {
        DENG2_ASSERT(!controlFlow.empty());
        delete flow().iteration;
        controlFlow.pop_back();
    }
    void setCurrent(Statement const *statement) {
        if (controlFlow.size()) {
            evaluator.reset();
            flow().setCurrent(statement);
        }
        else {
            DENG2_ASSERT(statement == NULL);
        }
    }
};
Context::Context(Type type, Process *owner, Record *globals)
    : d(new Impl(this, type, owner, globals))
{}
Context::Type Context::type() {
    return d->type;
}
Process &Context::process() {
    return *d->owner;
}
Evaluator &Context::evaluator() {
    return d->evaluator;
}
bool Context::hasExternalGlobalNamespace() const {
    return !d->ownsNamespace;
}
Record &Context::names() {
    return *d->names;
}
void Context::start(Statement const *statement,    Statement const *fallback,
                    Statement const *jumpContinue, Statement const *jumpBreak) {
    d->controlFlow.push_back(Impl::ControlFlow(statement, fallback, jumpContinue, jumpBreak));
    if (!current()) {
        proceed();
    }
}
void Context::reset() {
    while (!d->controlFlow.empty()) {
        d->popFlow();
    }
    d->evaluator.reset();
}
bool Context::execute() {
    if (current() != NULL) {
        current()->execute(*this);
        return true;
    }
    return false;
}
void Context::proceed() {
    Statement const *st = NULL;
    if (current()) {
        st = current()->next();
    }
    while (!st && d->controlFlow.size()) {
        st = d->controlFlow.back().flow;
        d->popFlow();
    }
    d->setCurrent(st);
}
void Context::jumpContinue() {
    Statement const *st = NULL;
    while (!st && d->controlFlow.size()) {
        st = d->controlFlow.back().jumpContinue;
        d->popFlow();
    }
    if (!st) {
        throw JumpError("Context::jumpContinue", "No jump targets defined for continue");
    }
    d->setCurrent(st);
}
void Context::jumpBreak(duint count) {
    if (count < 1) {
        throw JumpError("Context::jumpBreak", "Invalid number of nested breaks");
    }
    Statement const *st = NULL;
    while ((!st || count > 0) && d->controlFlow.size()) {
        st = d->controlFlow.back().jumpBreak;
        if (st) {
            --count;
        }
        d->popFlow();
    }
    if (count > 0) {
        throw JumpError("Context::jumpBreak", "Too few nested compounds to break out of");
    }
    if (!st) {
        throw JumpError("Context::jumpBreak", "No jump targets defined for break");
    }
    d->setCurrent(st);
    proceed();
}
Statement const *Context::current() {
    if (d->controlFlow.size()) {
        return d->flow().current();
    }
    return NULL;
}
Value *Context::iterationValue() {
    DENG2_ASSERT(d->controlFlow.size());
    return d->controlFlow.back().iteration;
}
void Context::setIterationValue(Value *value) {
    DENG2_ASSERT(d->controlFlow.size());
    Impl::ControlFlow &fl = d->flow();
    if (fl.iteration) {
        delete fl.iteration;
    }
    fl.iteration = value;
}
void Context::setNativeSelf(Value *scope) {
    d->nativeSelf.reset(scope);
}
Value &Context::nativeSelf() const {
    DENG2_ASSERT(!d->nativeSelf.isNull());
    if (d->nativeSelf.isNull()) {
        throw UndefinedScopeError("Context::nativeSelf",
                                  "Context is not executing in scope of any instance");
    }
    return *d->nativeSelf;
}
Record &Context::selfInstance() const {
    Record *obj = nativeSelf().as<RecordValue>().record();
    if (!obj) {
        throw UndefinedScopeError("Context::selfInstance", "No \"self\" instance has been set");
    }
    return *obj;
}
Variable &Context::throwaway() {
    return d->throwaway;
}
} // namespace de
DeleteStatement::DeleteStatement() : _targets(new ArrayExpression)
{}
DeleteStatement::DeleteStatement(ArrayExpression *targets) : _targets(targets)
{}
DeleteStatement::~DeleteStatement() {
    delete _targets;
}
void DeleteStatement::execute(Context &context) const {
    Evaluator &eval = context.evaluator();
    ArrayValue &results = eval.evaluateTo<ArrayValue>(_targets);
    DENG2_FOR_EACH_CONST(ArrayValue::Elements, i, results.elements()) {
        RefValue *ref = dynamic_cast<RefValue *>(*i);
        if (!ref) {
            throw LeftValueError("DeleteStatement::execute",
                                 "Cannot delete l-value '" + (*i)->asText() + "'");
        }
        delete ref->variable();
    }
    context.proceed();
}
void DeleteStatement::operator >> (Writer &to) const {
    to << dbyte(SerialId::Delete) << *_targets;
}
void DeleteStatement::operator << (Reader &from) {
    SerialId id;
    from.readAs<dbyte>(id);
    if (id != SerialId::Delete) {
        throw DeserializationError("DeleteStatement::operator <<", "Invalid ID");
    }
    from >> *_targets;
}
DictionaryExpression::DictionaryExpression()
{}
DictionaryExpression::~DictionaryExpression() {
    clear();
}
void DictionaryExpression::clear() {
    for (Arguments::iterator i = _arguments.begin(); i != _arguments.end(); ++i) {
        delete i->first;
        delete i->second;
    }
    _arguments.clear();
}
void DictionaryExpression::add(Expression *key, Expression *value) {
    DENG2_ASSERT(key != NULL);
    DENG2_ASSERT(value != NULL);
    _arguments.push_back(ExpressionPair(key, value));
}
void DictionaryExpression::push(Evaluator &evaluator, Value *scope) const {
    Expression::push(evaluator, scope);
    for (Arguments::const_reverse_iterator i = _arguments.rbegin();
        i != _arguments.rend(); ++i) {
        i->second->push(evaluator);
        i->first->push(evaluator);
    }
}
Value *DictionaryExpression::evaluate(Evaluator &evaluator) const {
    std::unique_ptr<DictionaryValue> dict(new DictionaryValue);
    std::list<Value *> keys, values;
    for (Arguments::const_reverse_iterator i = _arguments.rbegin();
        i != _arguments.rend(); ++i) {
        values.push_back(evaluator.popResult());
        keys.push_back(evaluator.popResult());
    }
    std::list<Value *>::reverse_iterator key = keys.rbegin();
    std::list<Value *>::reverse_iterator value = values.rbegin();
    for (; key != keys.rend(); ++key, ++value) {
        dict->add(*key, *value);
    }
    return dict.release();
}
void DictionaryExpression::operator >> (Writer &to) const {
    to << SerialId(DICTIONARY);
    Expression::operator >> (to);
    to << duint16(_arguments.size());
    for (Arguments::const_iterator i = _arguments.begin(); i != _arguments.end(); ++i) {
        to << *i->first << *i->second;
    }
}
void DictionaryExpression::operator << (Reader &from) {
    SerialId id;
    from >> id;
    if (id != DICTIONARY) {
        throw DeserializationError("DictionaryExpression::operator <<", "Invalid ID");
    }
    Expression::operator << (from);
    duint16 count;
    from >> count;
    clear();
    while (count--) {
        QScopedPointer<Expression> key(Expression::constructFrom(from));
        QScopedPointer<Expression> value(Expression::constructFrom(from));
        _arguments.push_back(ExpressionPair(key.take(), value.take()));
    }
}
namespace de {
DENG2_PIMPL(Evaluator) {
    Context &context;
    struct ScopedExpression {
        Expression const *expression;
        Value *scope; // owned
        ScopedExpression(Expression const *e = 0, Value *s = 0)
            : expression(e), scope(s)
        {}
        Record *names() const {
            if (!scope) return nullptr;
            return scope->memberScope();
        }
    };
    struct ScopedResult {
        Value *result;
        Value *scope; // owned
        ScopedResult(Value *v, Value *s = 0) : result(v), scope(s) {}
    };
    typedef QList<ScopedExpression> Expressions;
    typedef QList<ScopedResult> Results;
    Expression const *current;
    Record *names;
    Expressions expressions;
    Results results;
    NoneValue noResult;
    Impl(Public *i, Context &owner)
        : Base(i)
        , context(owner)
        , current(0)
        , names(0)
    {}
    ~Impl() {
        DENG2_ASSERT(expressions.isEmpty());
        clearNames();
        clearResults();
    }
    void clearNames() {
        if (names) {
            names = 0;
        }
    }
    void clearResults() {
        foreach (ScopedResult const &i, results) {
            delete i.result;
            delete i.scope;
        }
        results.clear();
    }
    void clearExpressions() {
        while (!expressions.empty()) {
            ScopedExpression top = expressions.takeLast();
            clearNames();
            names = top.names();
            delete top.scope;
        }
    }
    void pushResult(Value *value, Value *scope = 0 /*take*/)
    {
        if (value) {
            /*qDebug() << "Evaluator: Pushing result" << value << value->asText() << "in scope"
                        << (scope? scope->asText() : "null")
                        << "result stack size:" << results.size();*/
            results << ScopedResult(value, scope);
        }
        else {
            DENG2_ASSERT(scope == nullptr);
        }
    }
    Value &result() {
        if (results.isEmpty()) {
            return noResult;
        }
        return *results.first().result;
    }
    Value &evaluate(Expression const *expression) {
        DENG2_ASSERT(names == nullptr);
        DENG2_ASSERT(expressions.empty());
        current = expression;
        expression->push(self());
        clearResults();
        while (!expressions.empty()) {
            ScopedExpression top = expressions.takeLast();
            clearNames();
            names = top.names();
            /*qDebug() << "Evaluator: Evaluating latest scoped expression" << top.expression
                     << "in" << (top.scope? names->asText() : "null scope");*/
            pushResult(top.expression->evaluate(self()), top.scope);
        }
        DENG2_ASSERT(&self().process().context() == &context);
        DENG2_ASSERT(self().hasResult());
        clearNames();
        current = nullptr;
        return result();
    }
};
} // namespace de
namespace de {
Evaluator::Evaluator(Context &owner) : d(new Impl(this, owner))
{}
Context &Evaluator::context() {
    return d->context;
}
Process &Evaluator::process() {
    return d->context.process();
}
Process const &Evaluator::process() const {
    return d->context.process();
}
void Evaluator::reset() {
    d->current = nullptr;
    d->clearExpressions();
    d->clearNames();
}
Value &Evaluator::evaluate(Expression const *expression) {
    return d->evaluate(expression);
}
void Evaluator::namespaces(Namespaces &spaces) const {
    if (d->names) {
        spaces.clear();
        spaces.push_back({d->names, Context::Namespace});
    }
    else {
        process().namespaces(spaces);
    }
}
Record *Evaluator::localNamespace() const {
    Namespaces spaces;
    namespaces(spaces);
    DENG2_ASSERT(!spaces.empty());
    DENG2_ASSERT(spaces.front().names != 0);
    return spaces.front().names;
}
bool Evaluator::hasResult() const {
    return d->results.size() == 1;
}
Value &Evaluator::result() {
    return d->result();
}
void Evaluator::push(Expression const *expression, Value *scope) {
    d->expressions.push_back(Impl::ScopedExpression(expression, scope));
}
void Evaluator::pushResult(Value *value) {
    d->pushResult(value);
}
Value *Evaluator::popResult(Value **evaluationScope) {
    DENG2_ASSERT(d->results.size() > 0);
    Impl::ScopedResult result = d->results.takeLast();
    /*qDebug() << "Evaluator: Popping result" << result.result << result.result->asText()
             << "in scope" << (result.scope? result.scope->asText() : "null");*/
    if (evaluationScope) {
        *evaluationScope = result.scope;
    }
    else {
        delete result.scope; // Was owned by us and the caller didn't want it.
    }
    return result.result;
}
} // namespace de
Expression::Expression()
{}
Expression::~Expression()
{}
void Expression::push(Evaluator &evaluator, Value *scope) const {
    evaluator.push(this, scope);
}
Expression *Expression::constructFrom(Reader &reader) {
    SerialId id;
    reader.mark();
    reader >> id;
    reader.rewind();
    std::unique_ptr<Expression> result;
    switch (id) {
    case ARRAY:
        result.reset(new ArrayExpression());
        break;
    case BUILT_IN:
        result.reset(new BuiltInExpression());
        break;
    case CONSTANT:
        result.reset(new ConstantExpression());
        break;
    case DICTIONARY:
        result.reset(new DictionaryExpression());
        break;
    case NAME:
        result.reset(new NameExpression());
        break;
    case OPERATOR:
        result.reset(new OperatorExpression());
        break;
    default:
        throw DeserializationError("Expression::constructFrom", "Invalid expression identifier");
    }
    reader >> *result.get();
    return result.release();
}
Expression::Flags const &Expression::flags () const {
    return _flags;
}
void Expression::setFlags(Flags f, FlagOp operation) {
    applyFlagOperation(_flags, f, operation);
}
void Expression::operator >> (Writer &to) const {
    to << duint16(_flags);
}
void Expression::operator << (Reader &from) {
    duint16 f;
    from >> f;
    _flags = Flags(f);
}
ExpressionStatement::~ExpressionStatement() {
    delete _expression;
}
void ExpressionStatement::execute(Context &context) const {
    context.evaluator().evaluate(_expression);
    context.proceed();
}
void ExpressionStatement::operator >> (Writer &to) const {
    to << dbyte(SerialId::Expression) << *_expression;
}
void ExpressionStatement::operator << (Reader &from) {
    SerialId id;
    from.readAs<dbyte>(id);
    if (id != SerialId::Expression) {
        throw DeserializationError("ExpressionStatement::operator <<", "Invalid ID");
    }
    delete _expression;
    _expression = 0;
    _expression = Expression::constructFrom(from);
}
#define HAS_ARG     0x80
#define TYPE_MASK   0x7f
FlowStatement::FlowStatement() : _type(PASS), _arg(0)
{}
FlowStatement::FlowStatement(Type type, Expression *countArgument)
    : _type(type), _arg(countArgument)
{}
FlowStatement::~FlowStatement() {
    delete _arg;
}
void FlowStatement::execute(Context &context) const {
    Evaluator &eval = context.evaluator();
    switch (_type) {
    case PASS:
        context.proceed();
        break;
    case CONTINUE:
        context.jumpContinue();
        break;
    case BREAK:
        if (_arg) {
            context.jumpBreak(dint(eval.evaluate(_arg).asNumber()));
        }
        else {
            context.jumpBreak();
        }
        break;
    case RETURN:
        if (_arg) {
            eval.evaluate(_arg);
            context.process().finish(eval.popResult());
        }
        else {
            context.process().finish();
        }
        break;
    case THROW:
        if (_arg) {
            throw Error("script", eval.evaluate(_arg).asText());
        }
        else {
            context.proceed();
        }
    }
}
void FlowStatement::operator >> (Writer &to) const {
    to << dbyte(SerialId::Flow);
    duint8 header = duint8(_type);
    if (_arg) {
        header |= HAS_ARG;
    }
    to << header;
    if (_arg) {
        to << *_arg;
    }
}
void FlowStatement::operator << (Reader &from) {
    SerialId id;
    from.readAs<dbyte>(id);
    if (id != SerialId::Flow) {
        throw DeserializationError("FlowStatement::operator <<", "Invalid ID");
    }
    duint8 header;
    from >> header;
    _type = Type(header & TYPE_MASK);
    if (header & HAS_ARG) {
        delete _arg;
        _arg = 0;
        _arg = Expression::constructFrom(from);
    }
}
ForStatement::ForStatement() : _iterator(0), _iteration(0)
{}
ForStatement::~ForStatement() {
    delete _iterator;
    delete _iteration;
}
void ForStatement::execute(Context &context) const {
    Evaluator &eval = context.evaluator();
    if (!context.iterationValue()) {
        eval.evaluate(_iteration);
        context.setIterationValue(eval.popResult());
    }
    Value *nextValue = context.iterationValue()->next();
    if (nextValue) {
        RefValue &ref = eval.evaluateTo<RefValue>(_iterator);
        ref.assign(nextValue);
        context.start(_compound.firstStatement(), this, this, this);
    }
    else {
        context.setIterationValue(nullptr);
        context.proceed();
    }
}
void ForStatement::operator >> (Writer &to) const {
    to << dbyte(SerialId::For) << *_iterator << *_iteration << _compound;
}
void ForStatement::operator << (Reader &from) {
    SerialId id;
    from.readAs<dbyte>(id);
    if (id != SerialId::For) {
        throw DeserializationError("ForStatement::operator <<", "Invalid ID");
    }
    delete _iterator;
    delete _iteration;
    _iterator = 0;
    _iteration = 0;
    _iterator = Expression::constructFrom(from);
    _iteration = Expression::constructFrom(from);
    from >> _compound;
}
namespace de {
typedef QMap<String, Function::NativeEntryPoint> RegisteredEntryPoints;
static RegisteredEntryPoints entryPoints;
DENG2_PIMPL_NOREF(Function) {
    Function::Arguments arguments;
    Function::Defaults defaults;
    Compound compound;
    Record *globals;
    String nativeName;
    Function::NativeEntryPoint nativeEntryPoint;
    Impl() : globals(0), nativeEntryPoint(0)
    {}
    Impl(Function::Arguments const &args, Function::Defaults const &defaults)
        : arguments(args), defaults(defaults), globals(0), nativeEntryPoint(0)
    {}
};
Function::Function() : d(new Impl)
{}
Function::Function(Arguments const &args, Defaults const &defaults)
    : d(new Impl(args, defaults))
{}
Function::Function(String const &nativeName, Arguments const &args, Defaults const &defaults)
    : d(new Impl(args, defaults)) {
    try {
        d->nativeName       = nativeName;
        d->nativeEntryPoint = nativeEntryPoint(nativeName);
    }
    catch (Error const &) {
        addRef(-1); // Cancelled construction of the instance; no one has a reference.
        throw;
    }
}
Function::~Function() {
    DENG2_FOR_EACH(Defaults, i, d->defaults) {
        delete i.value();
    }
}
String Function::asText() const {
    String result;
    QTextStream os(&result);
    os << "(Function " << this << " (";
    DENG2_FOR_EACH_CONST(Arguments, i, d->arguments) {
        if (i != d->arguments.begin()) {
            os << ", ";
        }
        os << *i;
        Defaults::const_iterator def = d->defaults.find(*i);
        if (def != d->defaults.end()) {
            os << "=" << def.value()->asText();
        }
    }
    os << "))";
    return result;
}
Compound &Function::compound() {
    return d->compound;
}
Compound const &Function::compound() const {
    return d->compound;
}
Function::Arguments &Function::arguments() {
    return d->arguments;
}
Function::Arguments const &Function::arguments() const {
    return d->arguments;
}
Function::Defaults &Function::defaults() {
    return d->defaults;
}
Function::Defaults const &Function::defaults() const {
    return d->defaults;
}
void Function::mapArgumentValues(ArrayValue const &args, ArgumentValues &values) const {
    DENG2_ASSERT(args.size() > 0);
    DictionaryValue const *labeledArgs = dynamic_cast<DictionaryValue const *>(
        args.elements().front());
    DENG2_ASSERT(labeledArgs != NULL);
    Arguments::const_iterator k = d->arguments.begin();
    for (ArrayValue::Elements::const_iterator i = args.elements().begin() + 1;
        i != args.elements().end(); ++i) {
        values.push_back(*i);
        if (k != d->arguments.end()) {
            if (labeledArgs->contains(TextValue(*k))) {
                throw WrongArgumentsError("Function::mapArgumentValues",
                    "More than one value has been given for '" +
                    *k + "' in function call");
            }
            ++k;
        }
    }
    if (values.size() < d->arguments.size()) {
        Arguments::const_iterator i = d->arguments.begin();
        for (duint count = values.size(); count > 0; --count, ++i) {}
        for (; i != d->arguments.end(); ++i) {
            const TextValue argName(*i);
            if (const Value *labeledValue = labeledArgs->find(argName)) {
                values.push_back(labeledValue);
            }
            else {
                Defaults::const_iterator k = d->defaults.find(*i);
                if (k != d->defaults.end()) {
                    values.append(k.value());
                }
                else {
                    throw WrongArgumentsError("Function::mapArgumentValues",
                        "The value of argument '" + *i + "' has not been defined in function call");
                }
            }
        }
    }
    if (values.size() != d->arguments.size()) {
        throw WrongArgumentsError("Function::mapArgumentValues",
                                  "Expected " + QString::number(d->arguments.size()) +
                                  " arguments, but got " + QString::number(values.size()) +
                                  " arguments in function call");
    }
}
void Function::setGlobals(Record *globals) {
    LOG_AS("Function::setGlobals");
    DENG2_ASSERT(globals != 0);
    if (!d->globals) {
        d->globals = globals;
        d->globals->audienceForDeletion() += this;
    }
    /*
    else if (d->globals != globals) {
        LOGDEV_SCR_WARNING("Function was offered a different namespace");
        LOGDEV_SCR_VERBOSE("Function %p's namespace is:\n%s\nOffered namespace is:\n%s")
                << this << d->globals->asText() << globals->asText();
    }*/
}
Record *Function::globals() const {
    return d->globals;
}
bool Function::isNative() const {
    return d->nativeEntryPoint != NULL;
}
Value *Function::callNative(Context &context, ArgumentValues const &args) const {
    DENG2_ASSERT(isNative());
    DENG2_ASSERT(args.size() == d->arguments.size()); // all arguments provided
    Value *result = (d->nativeEntryPoint)(context, args);
    if (!result) {
        result = new NoneValue;
    }
    return result;
}
void Function::operator >> (Writer &to) const {
    to << duint16(d->arguments.size());
    DENG2_FOR_EACH_CONST(Arguments, i, d->arguments) {
        to << *i;
    }
    to << duint16(d->defaults.size());
    DENG2_FOR_EACH_CONST(Defaults, i, d->defaults) {
        to << i.key() << *i.value();
    }
    to << d->compound;
    to << d->nativeName;
}
void Function::operator << (Reader &from) {
    duint16 count = 0;
    from >> count;
    d->arguments.clear();
    while (count--) {
        String argName;
        from >> argName;
        d->arguments.push_back(argName);
    }
    from >> count;
    d->defaults.clear();
    while (count--) {
        String name;
        from >> name;
        d->defaults[name] = Value::constructFrom(from);
    }
    from >> d->compound;
    from >> d->nativeName;
    if (!d->nativeName.isEmpty()) {
        d->nativeEntryPoint = nativeEntryPoint(d->nativeName);
    }
}
void Function::recordBeingDeleted(Record &DENG2_DEBUG_ONLY(record)) {
    DENG2_ASSERT(d->globals == &record);
    d->globals = nullptr;
}
void Function::registerNativeEntryPoint(String const &name, Function::NativeEntryPoint entryPoint) {
    entryPoints.insert(name, entryPoint);
}
void Function::unregisterNativeEntryPoint(String const &name) {
    entryPoints.remove(name);
}
Function::NativeEntryPoint Function::nativeEntryPoint(String const &name) {
    RegisteredEntryPoints::const_iterator found = entryPoints.constFind(name);
    if (found == entryPoints.constEnd()) {
        throw UnknownEntryPointError("Function::nativeEntryPoint",
                                     QString("Native entry point '%1' is not available").arg(name));
    }
    return found.value();
}
Function *NativeFunctionSpec::make() const {
    Function::registerNativeEntryPoint(_nativeName, _entryPoint);
    return new Function(_nativeName, _argNames, _argDefaults);
}
Binder::Binder(Record *module, FunctionOwnership ownership)
    : _module(module)
    , _isOwned(false)
    , _funcOwned(ownership)
{}
Binder::~Binder() {
    deinit();
}
Binder &Binder::init(Record &module) {
    _module = &module;
    return *this;
}
Binder &Binder::initNew() {
    DENG2_ASSERT(!_isOwned);
    _isOwned = true;
    _module = new Record;
    return *this;
}
void Binder::deinit() {
    if (_funcOwned == FunctionsOwned) {
        for (auto *var : _boundFunctions) {
            delete var;
        }
        _boundFunctions.clear();
    }
    if (_isOwned) {
        delete _module;
        _module = 0;
        _isOwned = false;
    }
    foreach (String const &name, _boundEntryPoints) {
        Function::unregisterNativeEntryPoint(name);
    }
    _boundEntryPoints.clear();
}
Record &Binder::module() const {
    DENG2_ASSERT(_module != 0);
    return *_module;
}
Binder &Binder::operator << (const NativeFunctionSpec &spec) {
    if (_module) {
        _boundEntryPoints.insert(spec.nativeName());
        *_module << spec;
        if (_funcOwned == FunctionsOwned) {
            _boundFunctions.insert(&(*_module)[spec.name()]);
        }
    }
    return *this;
}
} // namespace de
FunctionStatement::FunctionStatement(Expression *identifier)
    : _identifier(identifier) {
    _function = new Function();
}
FunctionStatement::~FunctionStatement() {
    delete _identifier;
    de::releaseRef(_function);
}
Compound &FunctionStatement::compound() {
    return _function->compound();
}
void FunctionStatement::addArgument(String const &argName, Expression *defaultValue) {
    _function->arguments().push_back(argName);
    if (defaultValue) {
        _defaults.add(new ConstantExpression(new TextValue(argName)), defaultValue);
    }
}
void FunctionStatement::execute(Context &context) const {
    Evaluator &eval = context.evaluator();
    Record &globals = context.process().globals();
    _function->setGlobals(&globals);
    eval.evaluateTo<RefValue>(_identifier);
    std::unique_ptr<RefValue> ref(eval.popResultAs<RefValue>());
    DictionaryValue &dict = eval.evaluateTo<DictionaryValue>(&_defaults);
    DENG2_FOR_EACH_CONST(DictionaryValue::Elements, i, dict.elements()) {
        _function->defaults()[i->first.value->asText()] = i->second->duplicate();
    }
    ref->assign(new FunctionValue(_function));
    context.proceed();
}
void FunctionStatement::operator >> (Writer &to) const {
    to << dbyte(SerialId::Function) << *_identifier << *_function << _defaults;
}
void FunctionStatement::operator << (Reader &from) {
    SerialId id;
    from.readAs<dbyte>(id);
    if (id != SerialId::Function) {
        throw DeserializationError("FunctionStatement::operator <<", "Invalid ID");
    }
    delete _identifier;
    _identifier = 0;
    _identifier = Expression::constructFrom(from);
    from >> *_function >> _defaults;
}
FunctionValue::FunctionValue() : _func(new Function) {
}
FunctionValue::FunctionValue(Function *func) : _func(de::holdRef(func))
{}
FunctionValue::~FunctionValue() {
    de::releaseRef(_func);
}
Value *FunctionValue::duplicate() const {
    return new FunctionValue(_func);
}
Value::Text FunctionValue::asText() const {
    return _func->asText();
}
bool FunctionValue::isTrue() const {
    return true;
}
bool FunctionValue::isFalse() const {
    return false;
}
dint FunctionValue::compare(Value const &value) const {
    FunctionValue const *other = dynamic_cast<FunctionValue const *>(&value);
    if (!other) {
        return -1;
    }
    if (_func == other->_func) {
        return 0;
    }
    if (_func > other->_func) {
        return 1;
    }
    return -1;
}
void FunctionValue::call(Process &process, Value const &arguments, Value *self) const {
    ArrayValue const *array = dynamic_cast<ArrayValue const *>(&arguments);
    if (!array) {
        throw IllegalError("FunctionValue::call", "Arguments is not an array");
    }
    process.call(*_func, *array, self);
}
void FunctionValue::operator >> (Writer &to) const {
    to << SerialId(FUNCTION) << *_func;
}
void FunctionValue::operator << (Reader &from) {
    SerialId id;
    from >> id;
    if (id != FUNCTION) {
        throw DeserializationError("FunctionValue::operator <<", "Invalid ID");
    }
    from >> *_func;
}
Value::Text FunctionValue::typeId() const {
    return "Function";
}
IfStatement::~IfStatement() {
    clear();
}
void IfStatement::clear() {
    for (Branches::iterator i = _branches.begin(); i != _branches.end(); ++i) {
        delete i->condition;
        delete i->compound;
    }
    _branches.clear();
}
void IfStatement::newBranch() {
    _branches.push_back(Branch(new Compound()));
}
void IfStatement::setBranchCondition(Expression *condition) {
    _branches.back().condition = condition;
}
Compound &IfStatement::branchCompound() {
    return *_branches.back().compound;
}
void IfStatement::execute(Context &context) const {
    Evaluator &eval = context.evaluator();
    for (Branches::const_iterator i = _branches.begin(); i != _branches.end(); ++i) {
        if (eval.evaluate(i->condition).isTrue()) {
            context.start(i->compound->firstStatement(), next());
            return;
        }
    }
    if (_elseCompound.size()) {
        context.start(_elseCompound.firstStatement(), next());
    }
    else {
        context.proceed();
    }
}
void IfStatement::operator >> (Writer &to) const {
    to << dbyte(SerialId::If);
    to << duint16(_branches.size());
    for (Branches::const_iterator i = _branches.begin(); i != _branches.end(); ++i) {
        DENG2_ASSERT(i->condition != NULL);
        to << *i->condition << *i->compound;
    }
    to << _elseCompound;
}
void IfStatement::operator << (Reader &from) {
    SerialId id;
    from.readAs<dbyte>(id);
    if (id != SerialId::If) {
        throw DeserializationError("IfStatement::operator <<", "Invalid ID");
    }
    clear();
    duint16 count;
    from >> count;
    while (count--) {
        newBranch();
        setBranchCondition(Expression::constructFrom(from));
        from >> branchCompound();
    }
    from >> _elseCompound;
}
Lex::Lex(String const &input,
         QChar lineCommentChar,
         QChar multiCommentChar,
         ModeFlags initialMode)
    : _input(&input)
    , _lineCommentChar(lineCommentChar)
    , _multiCommentChar(multiCommentChar)
    , _mode(initialMode)
{}
String const &Lex::input() const {
    return *_input;
}
bool Lex::atEnd() const {
    return _state.pos >= duint(_input->size());
}
duint Lex::pos() const {
    return _state.pos;
}
bool Lex::atCommentStart() const {
    if (atEnd() || _mode.testFlag(RetainComments)) {
        return false;
    }
    QChar const c = _input->at(_state.pos);
    if (c == _lineCommentChar) {
        if (!_mode.testFlag(DoubleCharComment)) return true;
        if (int(_state.pos) >= _input->size() - 1) return false;
        QChar const d = _input->at(_state.pos + 1);
        if (d == _lineCommentChar || d == _multiCommentChar) {
            return true;
        }
    }
    return false;
}
QChar Lex::peekComment() const {
    DENG2_ASSERT(atCommentStart());
    duint const inputSize = duint(_input->size());
    if (_mode.testFlag(DoubleCharComment)) {
        QChar c = _input->at(_state.pos + 1);
        if (c == _multiCommentChar) {
            duint p = _state.pos + 2;
            while (p < inputSize - 1 &&
                   !(_input->at(p)     == _multiCommentChar &&
                     _input->at(p + 1) == _lineCommentChar)) {
                ++p;
            }
            p += 2; // skip the ending
            _nextPos = p + 1;
            return (p < inputSize? _input->at(p) : 0);
        }
    }
    duint p = _state.pos;
    while (p < inputSize - 1 && _input->at(++p) != '\n') {}
    _nextPos = p + 1;
    return (p < inputSize? '\n' : 0);
}
QChar Lex::peek() const {
    if (atEnd()) {
        return 0;
    }
    if (atCommentStart()) {
        return peekComment();
    }
#if 0
    if (!_mode.testFlag(SkipComments) && (c == _lineCommentChar)) {
        if (!_mode.testFlag(DoubleCharComment) ||
            (int(_state.pos) < _input->size() - 1 && _input->at(int(_state.pos) + 1) == _lineCommentChar)) {
            duint p = _state.pos;
            while (p < duint(_input->size()) && _input->at(++p) != '\n') {}
            _nextPos = p + 1;
            if (p == duint(_input->size())) {
                return 0;
            }
            return '\n';
        }
    }
#endif
    _nextPos = _state.pos + 1;
    return _input->at(_state.pos);
}
QChar Lex::get() {
    if (atEnd()) {
        throw OutOfInputError("Lex::get", "No more characters in input");
    }
    QChar c = peek();
    for (duint p = _state.pos; p < _nextPos; ++p) {
        if (_input->at(p) == '\n') {
            _state.lineNumber++;
            _state.lineStartPos = p + 1;
        }
    }
    _state.pos = _nextPos;
    return c;
}
void Lex::skipWhite() {
    while (isWhite(peek())) {
        get();
    }
}
void Lex::skipWhiteExceptNewline() {
    QChar c = 0;
    while (isWhite(c = peek()) && c != '\n') {
        get();
    }
}
void Lex::skipToNextLine() {
    while (get() != '\n') {}
}
bool Lex::onlyWhiteOnLine() {
    State saved = _state;
    try {
        for (;;) {
            QChar c = get();
            if (c == '\n') {
                _state = saved;
                return true;
            }
            if (!isWhite(c)) {
                _state = saved;
                return false;
            }
        }
    }
    catch (OutOfInputError const &) {
        _state = saved;
        return true;
    }
}
duint Lex::countLineStartSpace() const {
    duint pos = _state.lineStartPos;
    duint count = 0;
    while (pos < duint(_input->size()) && isWhite(_input->at(pos++))) {
        count++;
    }
    return count;
}
bool Lex::parseLiteralNumber(QChar c, TokenBuffer &output) {
    if ((c == '.' && isNumeric(peek())) ||
        (_mode.testFlag(NegativeNumbers) && c == '-' && isNumeric(peek())) ||
        isNumeric(c)) {
        if (c == '-') {
            c = get();
            output.appendChar(c);
        }
        bool gotPoint = (c == '.');
        bool isHex = (c == '0' && (peek() == 'x' || peek() == 'X'));
        bool gotX = false;
        output.setType(Token::LITERAL_NUMBER);
        while (isNumeric((c = peek())) || (isHex && isHexNumeric(c)) ||
               (!isHex && !gotPoint && c == '.') ||
               (isHex && !gotX && (c == 'x' || c == 'X')) ||
               c == '_') {
            if (c == '_') {
                get();
                continue;
            }
            if (c == '.') gotPoint = true;
            if (c == 'x' || c == 'X') gotX = true;
            output.appendChar(get());
        }
        output.endToken();
        return true;
    }
    return false;
}
bool Lex::isWhite(QChar c) {
    return c.isSpace();
}
bool Lex::isAlpha(QChar c) {
    return c.isLetter();
}
bool Lex::isNumeric(QChar c) {
    return c.isDigit();
}
bool Lex::isHexNumeric(QChar c) {
    return isNumeric(c) || (c >= 'a' && c <= 'f') || (c >= 'A' && c <= 'F');
}
bool Lex::isAlphaNumeric(QChar c) {
    return c.isLetterOrNumber() || c == '_' || c == '@';
}
Module::Module(String const &sourcePath) : _sourcePath(sourcePath), _process(0) {
    initialize(Script(App::rootFolder().locate<File>(sourcePath)));
}
Module::Module(File const &sourceFile) : _sourcePath(sourceFile.path()), _process(0) {
    initialize(Script(sourceFile));
}
void Module::initialize(Script const &script) {
    std::unique_ptr<Process> proc(new Process(script));
    proc->execute();
    _process = proc.release();
}
Module::~Module() {
    delete _process;
}
Record &Module::names() {
    return _process->context().names();
}
namespace de {
String const NameExpression::LOCAL_SCOPE = "-";
DENG2_PIMPL_NOREF(NameExpression) {
    StringList identifierSequence;
    Variable *findInRecord(String const & name,
                           Record const & where,
                           Record *&      foundIn,
                           bool           lookInClass = true) const {
        if (where.hasMember(name)) {
            foundIn = const_cast<Record *>(&where);
            return const_cast<Variable *>(&where[name]);
        }
        if (lookInClass && where.hasMember(Record::VAR_SUPER)) {
            ArrayValue const &supers = where.geta(Record::VAR_SUPER);
            for (int i = int(supers.size() - 1); i >= 0; --i) {
                if (Variable *found = findInRecord(
                        name, supers.at(i).as<RecordValue>().dereference(), foundIn)) {
                    return found;
                }
            }
        }
        return 0;
    }
    Variable *findInNamespaces(String const & name,
                               Evaluator::Namespaces const &spaces,
                               bool           localOnly,
                               Record *&      foundInNamespace,
                               Record **      higherNamespace = 0) {
        DENG2_FOR_EACH_CONST(Evaluator::Namespaces, i, spaces) {
            Record &ns = *i->names;
            if (Variable *variable =
                    findInRecord(name, ns, foundInNamespace,
                                   !localOnly)) {
                Evaluator::Namespaces::const_iterator next = i;
                if (++next != spaces.end()) {
                    if (higherNamespace) *higherNamespace = next->names;
                }
                return variable;
            }
            if (localOnly) {
                break;
            }
        }
        return 0;
    }
};
} // namespace de
namespace de {
NameExpression::NameExpression() : d(new Impl)
{}
NameExpression::NameExpression(const String &identifier, Flags flags)
    : d(new Impl) {
    d->identifierSequence << "" << identifier;
    setFlags(flags);
}
NameExpression::NameExpression(const StringList &identifierSequence, Flags flags)
    : d(new Impl) {
    d->identifierSequence = identifierSequence;
    setFlags(flags);
}
const String &NameExpression::identifier() const {
    return d->identifierSequence.back();
}
Value *NameExpression::evaluate(Evaluator &evaluator) const {
    Evaluator::Namespaces spaces;
    Record *foundInNamespace = nullptr;
    Record *higherNamespace = nullptr;
    Variable *variable = nullptr;
    const String scopeIdentifier = d->identifierSequence.front();
    String identifier = d->identifierSequence.at(1);
    if (!scopeIdentifier || scopeIdentifier == LOCAL_SCOPE) {
        if (!scopeIdentifier) {
            evaluator.namespaces(spaces);
        }
        else {
            evaluator.process().namespaces(spaces);
        }
        variable = d->findInNamespaces(identifier, spaces, flags().testFlag(LocalOnly),
                                       foundInNamespace, &higherNamespace);
    }
    else {
        evaluator.process().namespaces(spaces);
        Variable *scope = d->findInNamespaces(scopeIdentifier, spaces, false, foundInNamespace);
        if (!scope) {
            throw NotFoundError("NameExpression::evaluate",
                                "Scope '" + scopeIdentifier + "' not found");
        }
        variable = d->findInRecord(identifier, scope->valueAsRecord(),
                                   foundInNamespace);
    }
    for (int i = 2; i < d->identifierSequence.size(); ++i) {
        if (!variable) {
            throw NotFoundError("NameExpression::evaluate",
                                "Scope '" + identifier + "' not found");
        }
        identifier = d->identifierSequence.at(i);
        variable = d->findInRecord(identifier, variable->valueAsRecord(), foundInNamespace);
    }
    if (flags().testFlag(ThrowawayIfInScope) && variable) {
        foundInNamespace = nullptr;
        variable = &evaluator.context().throwaway();
    }
    if (flags().testFlag(NotInScope) && variable) {
        throw AlreadyExistsError("NameExpression::evaluate",
                                 "Identifier '" + identifier + "' already exists");
    }
    if (flags().testFlag(NewSubrecord) ||
       (flags().testFlag(NewSubrecordIfNotInScope) && !variable)) {
        Record &record = spaces.front().names->addSubrecord(identifier);
        return new RecordValue(record);
    }
    if (!variable && flags().testFlag(NewVariable)) {
        variable = new Variable(identifier);
        spaces.front().names->add(variable);
        foundInNamespace = spaces.front().names;
        if (!higherNamespace && spaces.size() > 1) {
            Evaluator::Namespaces::iterator i = spaces.begin();
            higherNamespace = (++i)->names;
        }
    }
#if 0
    if (flags().testFlag(Export)) {
        DENG2_ASSERT(!flags().testFlag(ThrowawayIfInScope));
        if (!variable) {
            throw NotFoundError("NameExpression::evaluate",
                                "Cannot export nonexistent identifier '" + identifier + "'");
        }
        if (!higherNamespace) {
            throw NotFoundError("NameExpression::evaluate",
                                "No higher namespace for exporting '" + identifier + "' into");
        }
        if (higherNamespace != foundInNamespace && foundInNamespace) {
            foundInNamespace->remove(*variable);
            higherNamespace->add(variable);
        }
    }
#endif
    if (flags() & Import) {
        Record *record = &App::scriptSystem().importModule(identifier,
            evaluator.process().globals()[Record::VAR_FILE].value().asText());
        spaces.front().names->add(variable = new Variable(identifier));
        if (flags().testFlag(ByValue)) {
            *variable = new RecordValue(new Record(*record), RecordValue::OwnsRecord);
        }
        else {
            *variable = new RecordValue(record);
        }
        return new RecordValue(record);
    }
    if (variable) {
        if (flags() & ByReference) {
            return new RefValue(variable);
        }
        else {
            return variable->value().duplicateAsReference();
        }
    }
    throw NotFoundError("NameExpression::evaluate", "Identifier '" + identifier +
                        "' does not exist");
}
void NameExpression::operator >> (Writer &to) const {
    to << SerialId(NAME);
    Expression::operator >> (to);
    to << uint8_t(d->identifierSequence.size());
    for (const auto &i : d->identifierSequence) {
        to << i;
    }
}
void NameExpression::operator << (Reader &from) {
    SerialId id;
    from >> id;
    if (id != NAME) {
        throw DeserializationError("NameExpression::operator <<", "Invalid ID");
    }
    Expression::operator << (from);
    if (from.version() < DENG2_PROTOCOL_2_2_0_NameExpression_identifier_sequence) {
        String ident, scopeIdent;
        from >> ident;
        if (from.version() >= DENG2_PROTOCOL_1_15_0_NameExpression_with_scope_identifier) {
            from >> scopeIdent;
        }
        d->identifierSequence << scopeIdent;
        d->identifierSequence << ident;
    }
    else {
        uint8_t count = 0;
        from >> count;
        while (count-- != 0) {
            String ident;
            from >> ident;
            d->identifierSequence << ident;
        }
    }
}
} // namespace de
namespace de {
String operatorToText(Operator op) {
    switch (op) {
    case NOT:
        return "NOT";
    case AND:
        return "AND";
    case OR:
        return "OR";
    case IN:
        return "IN";
    case EQUAL:
        return "EQUAL";
    case NOT_EQUAL:
        return "NOT_EQUAL";
    case LESS:
        return "LESS";
    case GREATER:
        return "GREATER";
    case LEQUAL:
        return "LEQUAL";
    case GEQUAL:
        return "GEQUAL";
    case PLUS:
        return "PLUS";
    case MINUS:
        return "MINUS";
    case DIVIDE:
        return "DIVIDE";
    case MULTIPLY:
        return "MULTIPLY";
    case MODULO:
        return "MODULO";
    case PLUS_ASSIGN:
        return "PLUS_ASSIGN";
    case MINUS_ASSIGN:
        return "MINUS_ASSIGN";
    case DIVIDE_ASSIGN:
        return "DIVIDE_ASSIGN";
    case MULTIPLY_ASSIGN:
        return "MULTIPLY_ASSIGN";
    case MODULO_ASSIGN:
        return "MODULO_ASSIGN";
    case DOT:
        return "DOT";
    case MEMBER:
        return "MEMBER";
    case CALL:
        return "CALL";
    case ARRAY:
        return "ARRAY";
    case DICTIONARY:
        return "DICTIONARY";
    case INDEX:
        return "INDEX";
    case SLICE:
        return "SLICE";
    case RESULT_TRUE:
        return "RESULT_TRUE";
    case BITWISE_AND:
        return "BITWISE_AND";
    case BITWISE_OR:
        return "BITWISE_OR";
    case BITWISE_XOR:
        return "BITWISE_XOR";
    case BITWISE_NOT:
        return "BITWISE_NOT";
    default:
        return "UNKNOWN";
    }
}
bool leftOperandByReference(Operator op) {
    switch (op) {
    case PLUS_ASSIGN:
    case MINUS_ASSIGN:
    case DIVIDE_ASSIGN:
    case MULTIPLY_ASSIGN:
    case MODULO_ASSIGN:
        return true;
    default:
        return false;
    }
}
bool isUnary(Operator op) {
    return (op == PLUS || op == MINUS || op == NOT || op == BITWISE_NOT || op == RESULT_TRUE);
}
bool isBinary(Operator op) {
    return (op != NOT && op != BITWISE_NOT);
}
} // namespace de
namespace de {
static OperatorExpression isResultTrue(RESULT_TRUE, nullptr);
OperatorExpression::OperatorExpression() : _op(NONE), _leftOperand(0), _rightOperand(0)
{}
OperatorExpression::OperatorExpression(Operator op, Expression *operand)
    : _op(op), _leftOperand(0), _rightOperand(operand) {
    if (!isUnary(op)) {
        throw NonUnaryError("OperatorExpression::OperatorExpression",
            "Unary " + operatorToText(op) + " not defined");
    }
}
OperatorExpression::OperatorExpression(Operator op, Expression *leftOperand, Expression *rightOperand)
    : _op(op), _leftOperand(leftOperand), _rightOperand(rightOperand) {
    if (!isBinary(op)) {
        throw NonBinaryError("OperatorExpression::OperatorExpression",
            "Binary " + operatorToText(op) + " not defined");
    }
}
OperatorExpression::~OperatorExpression() {
    delete _leftOperand;
    delete _rightOperand;
}
void OperatorExpression::push(Evaluator &evaluator, Value *scope) const {
    Expression::push(evaluator);
    if (_op == MEMBER) {
        _leftOperand->push(evaluator, scope);
    }
    else if (_op == AND || _op == OR) {
        _leftOperand->push(evaluator, scope);
    }
    else if (_op == RESULT_TRUE) {
    }
    else {
        _rightOperand->push(evaluator);
        if (_leftOperand) {
            _leftOperand->push(evaluator, scope);
        }
    }
}
Value *OperatorExpression::newBooleanValue(bool isTrue) {
    return new NumberValue(isTrue? NumberValue::True : NumberValue::False,
                           NumberValue::Boolean);
}
void OperatorExpression::verifyAssignable(Value *value) {
    DENG2_ASSERT(value != 0);
    if (!dynamic_cast<RefValue *>(value)) {
        throw NotAssignableError("OperatorExpression::verifyAssignable",
            "Cannot assign to: " + value->asText());
    }
}
Value *OperatorExpression::evaluate(Evaluator &evaluator) const {
    Value *rightValue = (_op == MEMBER || _op == AND || _op == OR? nullptr : evaluator.popResult());
    Value *leftScopePtr = nullptr;
    Value *leftValue = (_leftOperand? evaluator.popResult(&leftScopePtr) : nullptr);
    Value *result = (leftValue? leftValue : rightValue);
    QScopedPointer<Value> leftScope(leftScopePtr); // will be deleted if not needed
    DENG2_ASSERT(_op == MEMBER || _op == AND || _op == OR ||
                 (!isUnary(_op) && leftValue && rightValue) ||
                 ( isUnary(_op) && rightValue));
    try {
        switch (_op) {
        case PLUS:
            if (leftValue) {
                leftValue->sum(*rightValue);
            }
            else {
            }
            break;
        case PLUS_ASSIGN:
            verifyAssignable(leftValue);
            leftValue->sum(*rightValue);
            break;
        case MINUS:
            if (leftValue) {
                leftValue->subtract(*rightValue);
            }
            else {
                rightValue->negate();
            }
            break;
        case MINUS_ASSIGN:
            verifyAssignable(leftValue);
            leftValue->subtract(*rightValue);
            break;
        case DIVIDE:
            leftValue->divide(*rightValue);
            break;
        case DIVIDE_ASSIGN:
            verifyAssignable(leftValue);
            leftValue->divide(*rightValue);
            break;
        case MULTIPLY:
            leftValue->multiply(*rightValue);
            break;
        case MULTIPLY_ASSIGN:
            verifyAssignable(leftValue);
            leftValue->multiply(*rightValue);
            break;
        case MODULO:
            leftValue->modulo(*rightValue);
            break;
        case MODULO_ASSIGN:
            verifyAssignable(leftValue);
            leftValue->modulo(*rightValue);
            break;
        case NOT:
            result = newBooleanValue(rightValue->isFalse());
            break;
        case RESULT_TRUE:
            result = newBooleanValue(rightValue->isTrue());
            break;
        case BITWISE_AND:
            result = new NumberValue(leftValue->asUInt() & rightValue->asUInt());
            break;
        case BITWISE_OR:
            result = new NumberValue(leftValue->asUInt() | rightValue->asUInt());
            break;
        case BITWISE_XOR:
            result = new NumberValue(leftValue->asUInt() ^ rightValue->asUInt());
            break;
        case BITWISE_NOT:
            result = new NumberValue(~rightValue->asUInt());
            break;
        case AND:
            if (!leftValue->isTrue()) {
                result = newBooleanValue(false);
            }
            else {
                isResultTrue.push(evaluator);
                _rightOperand->push(evaluator);
                result = nullptr;
            }
            break;
        case OR:
            if (leftValue->isTrue()) {
                result = newBooleanValue(true);
            }
            else {
                isResultTrue.push(evaluator);
                _rightOperand->push(evaluator);
                result = nullptr;
            }
            break;
        case EQUAL:
            result = newBooleanValue(!leftValue->compare(*rightValue));
            break;
        case NOT_EQUAL:
            result = newBooleanValue(leftValue->compare(*rightValue) != 0);
            break;
        case LESS:
            result = newBooleanValue(leftValue->compare(*rightValue) < 0);
            break;
        case GREATER:
            result = newBooleanValue(leftValue->compare(*rightValue) > 0);
            break;
        case LEQUAL:
            result = newBooleanValue(leftValue->compare(*rightValue) <= 0);
            break;
        case GEQUAL:
            result = newBooleanValue(leftValue->compare(*rightValue) >= 0);
            break;
        case IN:
            result = newBooleanValue(rightValue->contains(*leftValue));
            break;
        case CALL:
            leftValue->call(evaluator.process(), *rightValue, leftScope.take());
            result = 0;
            break;
        case INDEX: {
            /*
            LOG_DEV_TRACE_DEBUGONLY("INDEX: types %s [ %s ] byref:%b",
                          DENG2_TYPE_NAME(*leftValue) << DENG2_TYPE_NAME(*rightValue)
                          << flags().testFlag(ByReference));
                          */
            RecordValue *recValue = dynamic_cast<RecordValue *>(leftValue);
            if (flags().testFlag(ByReference) && recValue) {
                result = new RefValue(&recValue->dereference()[rightValue->asText()]);
            }
            else {
                result = leftValue->duplicateElement(*rightValue);
            }
            break;
        }
        case SLICE:
            result = performSlice(*leftValue, *rightValue);
            break;
        case MEMBER: {
            Record *scope = (leftValue? leftValue->memberScope() : 0);
            if (!scope) {
                throw ScopeError("OperatorExpression::evaluate",
                    "Left side of " + operatorToText(_op) + " does not have members [" +
                                 DENG2_TYPE_NAME(*leftValue) + "]");
            }
            _rightOperand->push(evaluator, leftValue);
            DENG2_ASSERT(rightValue == NULL);
            return nullptr;
        }
        default:
            throw Error("OperatorExpression::evaluate",
                "Operator " + operatorToText(_op) + " not implemented");
        }
    }
    catch (Error const &) {
        delete rightValue;
        delete leftValue;
        throw;
    }
    if (result != rightValue) delete rightValue;
    if (result != leftValue)  delete leftValue;
    return result;
}
static duint8 const HAS_LEFT_OPERAND = 0x80;
static duint8 const OPERATOR_MASK    = 0x7f;
void OperatorExpression::operator >> (Writer &to) const {
    to << SerialId(OPERATOR);
    Expression::operator >> (to);
    duint8 header = _op;
    if (_leftOperand) {
        header |= HAS_LEFT_OPERAND;
    }
    to << header << *_rightOperand;
    if (_leftOperand) {
        to << *_leftOperand;
    }
}
void OperatorExpression::operator << (Reader &from) {
    SerialId id;
    from >> id;
    if (id != OPERATOR) {
        throw DeserializationError("OperatorExpression::operator <<", "Invalid ID");
    }
    Expression::operator << (from);
    duint8 header;
    from >> header;
    _op = Operator(header & OPERATOR_MASK);
    delete _leftOperand;
    delete _rightOperand;
    _leftOperand = 0;
    _rightOperand = 0;
    _rightOperand = Expression::constructFrom(from);
    if (header & HAS_LEFT_OPERAND) {
        _leftOperand = Expression::constructFrom(from);
    }
}
namespace internal {
    struct SliceTarget {
        SliceTarget(Value *v) : value(v) {}
        virtual ~SliceTarget() {
            delete value;
        }
        Value *take() {
            Value *v = value;
            value = 0;
            return v;
        }
        virtual void append(Value const &src, dint index) = 0;
        Value *value;
    };
    struct ArraySliceTarget : public SliceTarget {
        ArraySliceTarget() : SliceTarget(new ArrayValue) {}
        ArrayValue &array() { return *static_cast<ArrayValue *>(value); }
        void append(Value const &src, dint index) {
            array().add(src.duplicateElement(NumberValue(index)));
        }
    };
    struct TextSliceTarget : public SliceTarget {
        TextSliceTarget() : SliceTarget(new TextValue) {}
        TextValue &text() { return *static_cast<TextValue *>(value); }
        void append(Value const &src, dint index) {
            text().sum(TextValue(String(1, src.asText().at(index))));
        }
    };
}
Value *OperatorExpression::performSlice(Value &leftValue, Value &rightValue) const {
    using internal::SliceTarget;
    using internal::TextSliceTarget;
    using internal::ArraySliceTarget;
    DENG2_ASSERT(rightValue.size() >= 2);
    ArrayValue const *args = dynamic_cast<ArrayValue *>(&rightValue);
    DENG2_ASSERT(args != NULL); // Parser makes sure.
    std::unique_ptr<SliceTarget> slice;
    if (dynamic_cast<TextValue *>(&leftValue)) {
        slice.reset(new TextSliceTarget);
    }
    else {
        slice.reset(new ArraySliceTarget);
    }
    dint step = 1;
    if (args->size() >= 3) {
        step = dint(args->elements()[2]->asNumber());
        if (!step) {
            throw SliceError("OperatorExpression::evaluate",
                operatorToText(_op) + " cannot use zero as step");
        }
    }
    dint leftSize = leftValue.size();
    dint begin = 0;
    dint end = leftSize;
    bool unspecifiedStart = false;
    bool unspecifiedEnd = false;
    Value const *startValue = args->elements()[0];
    if (dynamic_cast<NoneValue const *>(startValue)) {
        unspecifiedStart = true;
    }
    else {
        begin = dint(startValue->asNumber());
    }
    Value const *endValue = args->elements()[1];
    if (dynamic_cast<NoneValue const *>(endValue)) {
        unspecifiedEnd = true;
    }
    else {
        end = dint(endValue->asNumber());
    }
    if (begin < 0) {
        begin += leftSize;
    }
    if (end < 0) {
        end += leftSize;
    }
    if ((end > begin && step < 0) || (begin > end && step > 0)) {
        begin = end = 0;
    }
    if (unspecifiedStart && unspecifiedEnd && step < 0) {
        begin = leftSize - 1;
        end = -1;
    }
    begin = clamp(0, begin, leftSize);
    end = clamp(-1, end, leftSize);
    for (dint i = begin; (end >= begin && i < end) || (begin > end && i > end); i += step) {
        slice->append(leftValue, i);
    }
    return slice->take();
}
} // namespace de
Parser::Parser()
{}
Parser::~Parser()
{}
void Parser::parse(String const &input, Script &output) {
    _analyzer = ScriptLex(input);
    if (nextStatement() > 0) {
        parseCompound(output.compound());
    }
    _tokens.clear();
}
duint Parser::nextStatement() {
    duint result = _analyzer.getStatement(_tokens);
    _statementRange = TokenRange(_tokens);
    return result;
}
void Parser::parseCompound(Compound &compound) {
    while (_statementRange.size() > 0) {
        if (_statementRange.firstToken().equals(ScriptLex::ELSIF) ||
            _statementRange.firstToken().equals(ScriptLex::ELSE)  ||
            _statementRange.firstToken().equals(ScriptLex::CATCH) ||
            (_statementRange.size() == 1 && _statementRange.firstToken().equals(ScriptLex::END))) {
            break;
        }
        parseStatement(compound);
    }
}
void Parser::parseStatement(Compound &compound) {
    DENG2_ASSERT(!_statementRange.isEmpty());
    Token const &firstToken = _statementRange.firstToken();
    const auto firstTokenLine = firstToken.line();
    if (firstToken.equals(ScriptLex::IF)) {
        compound.add(parseIfStatement(), firstTokenLine);
        return;
    }
    else if (firstToken.equals(ScriptLex::WHILE)) {
        compound.add(parseWhileStatement(), firstTokenLine);
        return;
    }
    else if (firstToken.equals(ScriptLex::FOR)) {
        compound.add(parseForStatement(), firstTokenLine);
        return;
    }
    else if (firstToken.equals(ScriptLex::DEF)) {
        compound.add(parseFunctionStatement(), firstTokenLine);
        return;
    }
    else if (firstToken.equals(ScriptLex::TRY)) {
        parseTryCatchSequence(compound);
        return;
    }
    if (firstToken.equals(ScriptLex::IMPORT)) {
        compound.add(parseImportStatement(), firstTokenLine);
    }
    else if (firstToken.equals(ScriptLex::RECORD)) {
        compound.add(parseDeclarationStatement(), firstTokenLine);
    }
    else if (firstToken.equals(ScriptLex::DEL)) {
        compound.add(parseDeleteStatement(), firstTokenLine);
    }
    else if (firstToken.equals(ScriptLex::PASS)) {
        compound.add(new FlowStatement(FlowStatement::PASS), firstTokenLine);
    }
    else if (firstToken.equals(ScriptLex::CONTINUE)) {
        compound.add(new FlowStatement(FlowStatement::CONTINUE), firstTokenLine);
    }
    else if (firstToken.equals(ScriptLex::BREAK)) {
        Expression *breakCount = 0;
        if (_statementRange.size() > 1) {
            breakCount = parseExpression(_statementRange.startingFrom(1));
        }
        compound.add(new FlowStatement(FlowStatement::BREAK, breakCount), firstTokenLine);
    }
    else if (firstToken.equals(ScriptLex::RETURN) || firstToken.equals(ScriptLex::THROW)) {
        Expression *argValue = 0;
        if (_statementRange.size() > 1) {
            argValue = parseExpression(_statementRange.startingFrom(1));
        }
        compound.add(new FlowStatement(
            firstToken.equals(ScriptLex::RETURN)? FlowStatement::RETURN : FlowStatement::THROW,
            argValue), firstTokenLine);
    }
    else if (firstToken.equals(ScriptLex::PRINT)) {
        compound.add(parsePrintStatement(), firstTokenLine);
    }
    else if (_statementRange.hasBracketless(ScriptLex::ASSIGN) ||
             _statementRange.hasBracketless(ScriptLex::SCOPE_ASSIGN) ||
             _statementRange.hasBracketless(ScriptLex::WEAK_ASSIGN)) {
        compound.add(parseAssignStatement(), firstTokenLine);
    }
#if 0
    else if (firstToken.equals(ScriptLex::EXPORT)) {
        compound.add(parseExportStatement(), firstTokenLine);
    }
#endif
    else {
        compound.add(parseExpressionStatement(), firstTokenLine);
    }
    nextStatement();
}
IfStatement *Parser::parseIfStatement() {
    bool expectEnd = !_statementRange.hasBracketless(Token::COLON);
    std::unique_ptr<IfStatement> statement(new IfStatement());
    statement->newBranch();
    statement->setBranchCondition(
        parseConditionalCompound(statement->branchCompound(),
            HasCondition | StayAtClosingStatement));
    while (_statementRange.beginsWith(ScriptLex::ELSIF)) {
        expectEnd = !_statementRange.hasBracketless(Token::COLON);
        statement->newBranch();
        statement->setBranchCondition(
            parseConditionalCompound(statement->branchCompound(),
                HasCondition | StayAtClosingStatement));
    }
    if (_statementRange.beginsWith(ScriptLex::ELSE)) {
        expectEnd = !_statementRange.has(Token::COLON);
        parseConditionalCompound(statement->elseCompound(), StayAtClosingStatement);
    }
    if (expectEnd) {
        if (_statementRange.size() != 1 || !_statementRange.firstToken().equals(ScriptLex::END)) {
            throw UnexpectedTokenError("Parser::parseIfStatement", "Expected '" + ScriptLex::END +
                                       "', but got " + _statementRange.firstToken().asText());
        }
        nextStatement();
    }
    return statement.release();
}
WhileStatement *Parser::parseWhileStatement() {
    std::unique_ptr<WhileStatement> statement(new WhileStatement());
    statement->setCondition(parseConditionalCompound(statement->compound(), HasCondition));
    return statement.release();
}
ForStatement *Parser::parseForStatement() {
    dint colonPos = _statementRange.find(Token::COLON);
    dint inPos = _statementRange.find(ScriptLex::IN);
    if (inPos < 0 || (colonPos > 0 && inPos > colonPos)) {
        throw MissingTokenError("Parser::parseForStatement",
            "Expected 'in' to follow " + _statementRange.firstToken().asText());
    }
    std::unique_ptr<Expression> iter(parseExpression(_statementRange.between(1, inPos),
        Expression::ByReference | Expression::NewVariable | Expression::LocalOnly));
    Expression *iterable = parseExpression(_statementRange.between(inPos + 1, colonPos));
    std::unique_ptr<ForStatement> statement(new ForStatement(iter.release(), iterable));
    parseConditionalCompound(statement->compound(), IgnoreExtraBeforeColon);
    return statement.release();
}
ExpressionStatement *Parser::parseImportStatement() {
    if (_statementRange.size() < 2) {
        throw MissingTokenError("Parser::parseImportStatement",
            "Expected identifier to follow " + _statementRange.firstToken().asText());
    }
    dint startAt = 1;
    Expression::Flags flags =
            Expression::Import     |
            Expression::LocalOnly;
    if (_statementRange.size() >= 3 && _statementRange.token(1).equals(ScriptLex::RECORD)) {
        flags |= Expression::ByValue;
        startAt = 2;
    }
    return new ExpressionStatement(parseList(_statementRange.startingFrom(startAt), Token::COMMA, flags));
}
#if 0
ExpressionStatement *Parser::parseExportStatement() {
    if (_statementRange.size() < 2) {
        throw MissingTokenError("Parser::parseExportStatement",
            "Expected identifier to follow " + _statementRange.firstToken().asText());
    }
    return new ExpressionStatement(parseList(_statementRange.startingFrom(1), Token::COMMA,
                                             Expression::Export | Expression::LocalOnly));
}
#endif
Statement *Parser::parseDeclarationStatement() {
    if (_statementRange.size() < 2) {
        throw MissingTokenError("Parser::parseDeclarationStatement",
            "Expected identifier to follow " + _statementRange.firstToken().asText());
    }
    dint pos = _statementRange.find(Token::PARENTHESIS_OPEN);
    if (pos >= 0) {
        QScopedPointer<Expression> name(parseExpression(_statementRange.between(1, pos),
                                                        Expression::NewSubrecordIfNotInScope));
        QScopedPointer<ScopeStatement> names(new ScopeStatement(name.take(),
                parseList(_statementRange.between(pos + 1, _statementRange.closingBracket(pos)))));
        parseConditionalCompound(names->compound(),
                                 IgnoreExtraBeforeColon | StayAtClosingStatement);
        return names.take();
    }
    else {
        Expression::Flags flags = Expression::LocalOnly | Expression::NewSubrecord;
        return new ExpressionStatement(parseList(_statementRange.startingFrom(1), Token::COMMA, flags));
    }
}
DeleteStatement *Parser::parseDeleteStatement() {
    if (_statementRange.size() < 2) {
        throw MissingTokenError("Parser::parseDeleteStatement",
            "Expected identifier to follow " + _statementRange.firstToken().asText());
    }
    return new DeleteStatement(parseList(_statementRange.startingFrom(1), Token::COMMA,
                                         Expression::LocalOnly | Expression::ByReference));
}
FunctionStatement *Parser::parseFunctionStatement() {
    dint pos = _statementRange.find(Token::PARENTHESIS_OPEN);
    if (pos < 0) {
        throw MissingTokenError("Parser::parseFunctionStatement",
            "Expected arguments for " + _statementRange.firstToken().asText());
    }
    std::unique_ptr<FunctionStatement> statement(new FunctionStatement(
        parseExpression(_statementRange.between(1, pos),
                        Expression::LocalOnly   | Expression::ByReference |
                        Expression::NewVariable | Expression::NotInScope)));
    TokenRange argRange = _statementRange.between(pos + 1, _statementRange.closingBracket(pos));
    if (!argRange.isEmpty()) {
        TokenRange delim = argRange.undefinedRange();
        while (argRange.getNextDelimited(Token::COMMA, delim)) {
            if (delim.size() == 1 && delim.firstToken().type() == Token::IDENTIFIER) {
                statement->addArgument(delim.firstToken().str());
            }
            else if (delim.size() >= 3 &&
                delim.token(0).type() == Token::IDENTIFIER &&
                delim.token(1).equals(ScriptLex::ASSIGN)) {
                statement->addArgument(delim.firstToken().str(),
                    parseExpression(delim.startingFrom(2)));
            }
            else {
                throw UnexpectedTokenError("Parser::parseFunctionStatement",
                    "'" + delim.asText() + "' was unexpected in argument definition at " +
                    argRange.firstToken().asText());
            }
        }
    }
    parseConditionalCompound(statement->compound(), IgnoreExtraBeforeColon);
    return statement.release();
}
void Parser::parseTryCatchSequence(Compound &compound) {
    const duint lineNumber = _statementRange.firstToken().line();
    std::unique_ptr<TryStatement> tryStat(new TryStatement);
    parseConditionalCompound(tryStat->compound(), StayAtClosingStatement);
    compound.add(tryStat.release(), lineNumber);
    if (!_statementRange.firstToken().equals(ScriptLex::CATCH)) {
        throw UnexpectedTokenError("Parser::parseTryCatchSequence",
            "Expected 'catch', but got " + _statementRange.firstToken().asText());
    }
    CatchStatement *finalCatch = nullptr;
    bool expectEnd = false;
    while (!_statementRange.isEmpty() &&
           _statementRange.firstToken().equals(ScriptLex::CATCH)) {
        dint colon = _statementRange.find(Token::COLON);
        expectEnd = (colon < 0);
        std::unique_ptr<ArrayExpression> args;
        if (_statementRange.size() > 1) {
            TokenRange argRange;
            if (colon < 0) {
                argRange = _statementRange.startingFrom(1);
            }
            else {
                argRange = _statementRange.between(1, colon);
            }
            args.reset(parseList(argRange, Token::COMMA,
                Expression::ByReference | Expression::LocalOnly | Expression::NewVariable));
        }
        std::unique_ptr<CatchStatement> catchStat(new CatchStatement(args.release()));
        parseConditionalCompound(catchStat->compound(),
            StayAtClosingStatement | IgnoreExtraBeforeColon);
        finalCatch = catchStat.get();
        compound.add(catchStat.release(), lineNumber);
    }
    if (finalCatch) {
        finalCatch->flags |= CatchStatement::FinalCompound;
    }
    if (expectEnd) {
        if (!_statementRange.firstToken().equals(ScriptLex::END)) {
            throw UnexpectedTokenError("Parser::parseTryCatchSequence",
            "Expected 'end', but got " + _statementRange.firstToken().asText());
        }
        nextStatement();
    }
}
PrintStatement *Parser::parsePrintStatement() {
    ArrayExpression *args = 0;
    if (_statementRange.size() == 1) // Just the keyword.
    {
        args = new ArrayExpression();
    }
    else {
        args = parseList(_statementRange.startingFrom(1));
    }
    return new PrintStatement(args);
}
AssignStatement *Parser::parseAssignStatement() {
    Expression::Flags flags = Expression::NewVariable | Expression::ByReference | Expression::LocalOnly;
#if 0
    if (_statementRange.firstToken().equals(ScriptLex::EXPORT)) {
        flags |= Expression::Export;
        _statementRange = _statementRange.startingFrom(1);
    }
#endif
    if (_statementRange.firstToken().equals(ScriptLex::CONST)) {
        flags |= Expression::ReadOnly;
        _statementRange = _statementRange.startingFrom(1);
    }
    dint pos = _statementRange.find(ScriptLex::ASSIGN);
    if (pos < 0) {
        flags &= ~Expression::LocalOnly;
        pos = _statementRange.find(ScriptLex::SCOPE_ASSIGN);
        if (pos < 0) {
            pos = _statementRange.find(ScriptLex::WEAK_ASSIGN);
            flags |= Expression::ThrowawayIfInScope;
        }
    }
    AssignStatement::Indices indices;
    dint nameEndPos = pos;
    dint bracketPos = pos - 1;
    try {
        while (_statementRange.token(bracketPos).equals(Token::BRACKET_CLOSE)) {
            dint startPos = _statementRange.openingBracket(bracketPos);
            nameEndPos = startPos;
            Expression *indexExpr = parseExpression(
                _statementRange.between(startPos + 1, bracketPos));
            indices.push_back(indexExpr);
            bracketPos = nameEndPos - 1;
        }
        if (indices.size() > 0 && (flags & Expression::ThrowawayIfInScope)) {
            throw SyntaxError("Parser::parseAssignStatement",
                "Weak assignment cannot be used with indices");
        }
        QScopedPointer<Expression> lValue(parseExpression(_statementRange.endingTo(nameEndPos), flags));
        QScopedPointer<Expression> rValue(parseExpression(_statementRange.startingFrom(pos + 1)));
        AssignStatement *st = new AssignStatement(lValue.data(), indices, rValue.data());
        lValue.take();
        rValue.take();
        return st;
    }
    catch (Error const &) {
        for (AssignStatement::Indices::iterator i = indices.begin(); i != indices.end(); ++i) {
            delete *i;
        }
        throw;
    }
}
ExpressionStatement *Parser::parseExpressionStatement() {
    return new ExpressionStatement(parseExpression(_statementRange));
}
Expression *Parser::parseConditionalCompound(Compound &compound, CompoundFlags const &flags) {
    TokenRange range = _statementRange;
    dint colon = range.findBracketless(Token::COLON);
    QScopedPointer<Expression> condition;
    if (flags.testFlag(HasCondition)) {
        LOG_AS("parseConditionalCompound");
        LOGDEV_SCR_XVERBOSE_DEBUGONLY("colon at %i", colon);
        TokenRange conditionRange = range.between(1, colon);
        if (conditionRange.isEmpty()) {
            throw MissingTokenError("Parser::parseConditionalCompound",
                "A condition expression was expected after " + range.token(0).asText());
        }
        condition.reset(parseExpression(conditionRange));
    }
    else if (colon > 0 && (colon > 1 && !flags.testFlag(IgnoreExtraBeforeColon))) {
        throw UnexpectedTokenError("Parser::parseConditionalCompound",
            range.token(1).asText() + " was unexpected");
    }
    if (colon > 0) {
        if (colon == dint(range.size()) - 1) {
            throw MissingTokenError("Parser::parseConditionalCompound",
                                    "Expected at least one token to follow " +
                                    range.token(colon).asText());
        }
        _statementRange = _statementRange.startingFrom(colon + 1);
        parseStatement(compound);
    }
    else {
        nextStatement();
        parseCompound(compound);
        if (!flags.testFlag(StayAtClosingStatement)) {
            nextStatement();
        }
    }
    return condition.take();
}
ArrayExpression *Parser::parseList(TokenRange const &range, QChar const *separator,
                                   Expression::Flags const &flags) {
    QScopedPointer<ArrayExpression> exp(new ArrayExpression);
    if (range.size() > 0) {
        TokenRange delim = range.undefinedRange();
        while (range.getNextDelimited(separator, delim)) {
            exp->add(parseExpression(delim, flags));
        }
    }
    return exp.take();
}
Expression *Parser::parseExpression(TokenRange const &fullRange, Expression::Flags const &flags) {
    TokenRange range = fullRange;
    LOG_AS("parseExpression");
    LOGDEV_SCR_XVERBOSE_DEBUGONLY("%s (flags:%x)", range.asText() << flags);
    if (!range.size()) {
        return ConstantExpression::None();
    }
    while (range.firstToken().equals(Token::PARENTHESIS_OPEN) && range.closingBracket(0) == range.size() - 1) {
        range = range.shrink(1);
    }
    if (range.firstToken().type() == Token::KEYWORD &&
       range.firstToken().equals(ScriptLex::RECORD)) {
        LOGDEV_SCR_XVERBOSE_DEBUGONLY("declaration expression: RECORD %s", range.startingFrom(1).asText());
        if (range.size() == 1) {
            throw MissingTokenError("Parser::parseDeclarationExpression",
                                    "Expected identifier to follow " + range.firstToken().asText());
        }
        return parseExpression(range.startingFrom(1),
                               flags | Expression::LocalOnly | Expression::NewSubrecord);
    }
    TokenRange leftSide = range.between(0, 0);
    TokenRange rightSide = leftSide;
    Operator op = findLowestOperator(range, leftSide, rightSide);
    if (op == NONE) {
        return parseTokenExpression(range, flags);
    }
    else if (op == ARRAY) {
        return parseArrayExpression(range);
    }
    else if (op == DICTIONARY) {
        return parseDictionaryExpression(range);
    }
    else if (op == CALL) {
        return parseCallExpression(leftSide, rightSide);
    }
    else {
        return parseOperatorExpression(op, leftSide, rightSide, flags);
    }
}
ArrayExpression *Parser::parseArrayExpression(TokenRange const &range) {
    if (!range.firstToken().equals(Token::BRACKET_OPEN) ||
        range.closingBracket(0) != range.size() - 1) {
        throw MissingTokenError("Parser::parseArrayExpression",
            "Expected brackets for the array expression beginning at " +
            range.firstToken().asText());
    }
    return parseList(range.shrink(1));
}
DictionaryExpression *Parser::parseDictionaryExpression(TokenRange const &range) {
    if (!range.firstToken().equals(Token::CURLY_OPEN) ||
        range.closingBracket(0) != range.size() - 1) {
        throw MissingTokenError("Parser::parseDictionaryExpression",
            "Expected brackets for the dictionary expression beginning at " +
            range.firstToken().asText());
    }
    TokenRange shrunk = range.shrink(1);
    std::unique_ptr<DictionaryExpression> exp(new DictionaryExpression);
    if (shrunk.size() > 0) {
        TokenRange delim = shrunk.undefinedRange();
        while (shrunk.getNextDelimited(Token::COMMA, delim)) {
            dint colonPos = delim.findBracketless(Token::COLON);
            if (colonPos < 0) {
                throw MissingTokenError("Parser::parseDictionaryExpression",
                    "Colon is missing from '" + delim.asText() + "' at " +
                    delim.firstToken().asText());
            }
            QScopedPointer<Expression> key(parseExpression(delim.endingTo(colonPos)));
            Expression *value = parseExpression(delim.startingFrom(colonPos + 1));
            exp->add(key.take(), value);
        }
    }
    return exp.release();
}
Expression *Parser::parseCallExpression(TokenRange const &nameRange, TokenRange const &argumentRange) {
    if (!argumentRange.firstToken().equals(Token::PARENTHESIS_OPEN) ||
         argumentRange.closingBracket(0) < argumentRange.size() - 1) {
        throw SyntaxError("Parser::parseCallExpression",
            "Call arguments must be enclosed in parenthesis for " +
            argumentRange.firstToken().asText());
    }
    QScopedPointer<ArrayExpression> args(new ArrayExpression);
    DictionaryExpression *namedArgs = new DictionaryExpression;
    args->add(namedArgs);
    TokenRange argsRange = argumentRange.shrink(1);
    if (!argsRange.isEmpty()) {
        TokenRange delim = argsRange.undefinedRange();
        while (argsRange.getNextDelimited(Token::COMMA, delim)) {
            if (delim.has(ScriptLex::ASSIGN)) {
                if (delim.size() < 3 ||
                    delim.firstToken().type() != Token::IDENTIFIER ||
                    !delim.token(1).equals(ScriptLex::ASSIGN)) {
                    throw UnexpectedTokenError("Parser::parseCallExpression",
                        "Labeled argument '" + delim.asText() + "' is malformed");
                }
                Expression *value = parseExpression(delim.startingFrom(2));
                namedArgs->add(new ConstantExpression(new TextValue(delim.firstToken().str())), value);
            }
            else {
                args->add(parseExpression(delim));
            }
        }
    }
    if (nameRange.size() == 1) {
        BuiltInExpression::Type builtIn = BuiltInExpression::findType(nameRange.firstToken().str());
        if (builtIn != BuiltInExpression::NONE) {
            return new BuiltInExpression(builtIn, args.take());
        }
    }
    QScopedPointer<Expression> identifier(parseExpression(nameRange, Expression::ByReference));
    return new OperatorExpression(CALL, identifier.take(), args.take());
}
OperatorExpression *Parser::parseOperatorExpression(Operator op, TokenRange const &leftSide,
    TokenRange const &rightSide, Expression::Flags const &rightFlags) {
    if (leftSide.isEmpty()) {
        QScopedPointer<Expression> operand(parseExpression(rightSide));
        OperatorExpression *x = new OperatorExpression(op, operand.data());
        operand.take();
        return x;
    }
    else {
        Expression::Flags leftOpFlags = (leftOperandByReference(op)?
                                             Expression::ByReference : Expression::ByValue);
        Expression::Flags rightOpFlags = rightFlags;
        if (op == MEMBER) {
            leftOpFlags &= ~Expression::NewVariable;
        }
        else {
            rightOpFlags &= ~Expression::ByReference;
        }
        QScopedPointer<Expression> leftOperand(parseExpression(leftSide, leftOpFlags));
        QScopedPointer<Expression> rightOperand(op == SLICE? parseList(rightSide, Token::COLON) :
            parseExpression(rightSide, rightOpFlags));
        OperatorExpression *x = new OperatorExpression(op, leftOperand.data(), rightOperand.data());
        x->setFlags(rightFlags); // original flags
        rightOperand.take();
        leftOperand.take();
        return x;
    }
}
Expression *Parser::parseTokenExpression(TokenRange const &range, Expression::Flags const &flags) {
    if (!range.size()) {
        throw MissingTokenError("Parser::parseTokenExpression",
            "Expected tokens, but got nothing -- near " +
            range.buffer().at(range.tokenIndex(0)).asText());
    }
    Token const &token = range.token(0);
    if (token.type() == Token::KEYWORD) {
        if (token.equals(ScriptLex::T_TRUE)) {
            return ConstantExpression::True();
        }
        else if (token.equals(ScriptLex::T_FALSE)) {
            return ConstantExpression::False();
        }
        else if (token.equals(ScriptLex::NONE)) {
            return ConstantExpression::None();
        }
        else if (token.equals(ScriptLex::PI)) {
            return ConstantExpression::Pi();
        }
        else if (token.equals(ScriptLex::SCOPE) &&
                 range.size() == 2 &&
                 range.token(1).type() == Token::IDENTIFIER) {
            return new NameExpression(StringList{NameExpression::LOCAL_SCOPE, range.token(1).str()},
                                      flags);
        }
    }
    switch (token.type()) {
    case Token::IDENTIFIER:
        if (range.size() == 1) {
            return new NameExpression(range.token(0).str(), flags);
        }
        else if (range.size() >= 3 &&
                 range.token(1).equals(ScriptLex::SCOPE) &&
                 range.token(2).type() == Token::IDENTIFIER) {
            StringList identifierSequence;
            identifierSequence << range.token(0).str()
                               << range.token(2).str();
            for (duint i = 3; i < range.size() - 1; i += 2) {
                if (range.token(i).equals(ScriptLex::SCOPE) &&
                    range.token(i + 1).type() == Token::IDENTIFIER) {
                    identifierSequence << range.token(i + 1).str();
                }
                else {
                    throw UnexpectedTokenError("Parser::parseTokenExpression",
                                               "Unexpected tokens: " + range.token(i).asText() +
                                                   " followed by " + range.token(i + 1).asText());
                }
            }
            return new NameExpression(identifierSequence, flags);
        }
        else {
            throw UnexpectedTokenError("Parser::parseTokenExpression",
                "Unexpected token " + range.token(1).asText());
        }
    case Token::LITERAL_STRING_APOSTROPHE:
    case Token::LITERAL_STRING_QUOTED:
    case Token::LITERAL_STRING_LONG:
        return new ConstantExpression(new TextValue(token.unescapeStringLiteral()));
    case Token::LITERAL_NUMBER:
        return new ConstantExpression(new NumberValue(token.toNumber()));
    default:
        throw UnexpectedTokenError("Parser::parseTokenExpression",
            "Unexpected " + token.asText() + " which was identified as " +
            Token::typeToText(token.type()));
    }
}
Operator Parser::findLowestOperator(TokenRange const &range, TokenRange &leftSide, TokenRange &rightSide) {
    enum {
        MAX_RANK         = 0x7fffffff,
        RANK_MEMBER      = 23,
        RANK_CALL        = 24,
        RANK_INDEX       = 24,
        RANK_SLICE       = 24,
        RANK_DOT         = 25,
        RANK_ARRAY       = MAX_RANK - 1,
        RANK_DICTIONARY  = RANK_ARRAY,
        RANK_PARENTHESIS = MAX_RANK - 1
    };
    enum Direction {
        LEFT_TO_RIGHT,
        RIGHT_TO_LEFT
    };
    Operator previousOp = NONE;
    Operator lowestOp = NONE;
    int lowestRank = MAX_RANK;
    for (duint i = 0, continueFrom = 0; i < range.size(); i = continueFrom) {
        continueFrom = i + 1;
        int rank = MAX_RANK;
        Operator op = NONE;
        Direction direction = LEFT_TO_RIGHT;
        Token const &token = range.token(i);
        if (token.equals(Token::PARENTHESIS_OPEN)) {
            continueFrom = range.closingBracket(i) + 1;
            if ((previousOp == NONE || previousOp == INDEX || previousOp == SLICE ||
                previousOp == PARENTHESIS || previousOp == CALL) && i > 0) {
                op = CALL;
                rank = RANK_CALL;
            }
            else {
                op = PARENTHESIS;
                rank = RANK_PARENTHESIS;
            }
        }
        else if (token.equals(Token::BRACKET_OPEN)) {
            continueFrom = range.closingBracket(i) + 1;
            if ((previousOp == NONE || previousOp == PARENTHESIS ||
                previousOp == INDEX || previousOp == SLICE || previousOp == CALL) && i > 0) {
                if (range.between(i + 1, continueFrom - 1).has(Token::COLON)) {
                    op = SLICE;
                    rank = RANK_SLICE;
                }
                else {
                    op = INDEX;
                    rank = RANK_INDEX;
                }
            }
            else {
                op = ARRAY;
                rank = RANK_ARRAY;
            }
        }
        else if (token.equals(Token::CURLY_OPEN)) {
            continueFrom = range.closingBracket(i) + 1;
            op = DICTIONARY;
            rank = RANK_DICTIONARY;
        }
        else {
            const struct {
                char const *token;
                Operator op;
                int rank;
                Direction direction;
            } rankings[] = { // Ascending order.
                { "+=",     PLUS_ASSIGN,        0,          RIGHT_TO_LEFT },
                { "-=",     MINUS_ASSIGN,       0,          RIGHT_TO_LEFT },
                { "*=",     MULTIPLY_ASSIGN,    0,          RIGHT_TO_LEFT },
                { "/=",     DIVIDE_ASSIGN,      0,          RIGHT_TO_LEFT },
                { "%=",     MODULO_ASSIGN,      0,          RIGHT_TO_LEFT },
                { "or",     OR,                 1,          LEFT_TO_RIGHT },
                { "and",    AND,                2,          LEFT_TO_RIGHT },
                { "not",    NOT,                3,          RIGHT_TO_LEFT },
                { "in",     IN,                 4,          LEFT_TO_RIGHT },
                { "|",      BITWISE_OR,         5,          LEFT_TO_RIGHT },
                { "^",      BITWISE_XOR,        6,          LEFT_TO_RIGHT },
                { "&",      BITWISE_AND,        7,          LEFT_TO_RIGHT },
                { "==",     EQUAL,              8,          LEFT_TO_RIGHT },
                { "!=",     NOT_EQUAL,          8,          LEFT_TO_RIGHT },
                { "<",      LESS,               9,          LEFT_TO_RIGHT },
                { ">",      GREATER,            9,          LEFT_TO_RIGHT },
                { "<=",     LEQUAL,             9,          LEFT_TO_RIGHT },
                { ">=",     GEQUAL,             9,          LEFT_TO_RIGHT },
                { "+",      PLUS,               12,         LEFT_TO_RIGHT },
                { "-",      MINUS,              12,         LEFT_TO_RIGHT },
                { "*",      MULTIPLY,           13,         LEFT_TO_RIGHT },
                { "/",      DIVIDE,             13,         LEFT_TO_RIGHT },
                { "%",      MODULO,             13,         LEFT_TO_RIGHT },
                { "~",      BITWISE_NOT,        14,         LEFT_TO_RIGHT },
                { ".",      DOT,                RANK_DOT,   LEFT_TO_RIGHT },
                { 0,        NONE,               MAX_RANK,   LEFT_TO_RIGHT }
            };
            for (int k = 0; rankings[k].token; ++k) {
                if (token.equals(String(rankings[k].token))) {
                    op = rankings[k].op;
                    rank = rankings[k].rank;
                    direction = rankings[k].direction;
                    if (op == DOT) // && previousOp == NONE)
                    {
                        op = MEMBER;
                        rank = RANK_MEMBER;
                        direction = LEFT_TO_RIGHT;
                    }
                    else if (!i || (previousOp != NONE && previousOp != PARENTHESIS &&
                        previousOp != CALL && previousOp != INDEX && previousOp != SLICE &&
                        previousOp != ARRAY && previousOp != DICTIONARY)) {
                        if (op == PLUS || op == MINUS) {
                            rank += 100;
                        }
                    }
                    break;
                }
            }
        }
        if (op != NONE &&
            ((direction == LEFT_TO_RIGHT && rank <= lowestRank) ||
             (direction == RIGHT_TO_LEFT && rank < lowestRank))) {
            lowestOp = op;
            lowestRank = rank;
            leftSide = range.endingTo(i);
            if (op == INDEX || op == SLICE) {
                rightSide = range.between(i + 1, continueFrom - 1);
            }
            else {
                rightSide = range.startingFrom(op == CALL || op == ARRAY ||
                    op == DICTIONARY? i : i + 1);
            }
        }
        previousOp = op;
    }
    return lowestOp;
}
PrintStatement::PrintStatement(ArrayExpression *arguments) : _arg(arguments) {
    if (!_arg) {
        _arg = new ArrayExpression();
    }
}
PrintStatement::~PrintStatement() {
    delete _arg;
}
void PrintStatement::execute(Context &context) const {
    ArrayValue &value = context.evaluator().evaluateTo<ArrayValue>(_arg);
    String msg;
    QTextStream os(&msg);
    bool isFirst = true;
    DENG2_FOR_EACH_CONST(ArrayValue::Elements, i, value.elements()) {
       if (!isFirst) {
           os << " ";
       }
       else {
           isFirst = false;
       }
       os << (*i)->asText();
    }
    LOG_SCR_MSG(_E(m)) << msg;
    context.proceed();
}
void PrintStatement::operator >> (Writer &to) const {
    to << dbyte(SerialId::Print) << *_arg;
}
void PrintStatement::operator << (Reader &from) {
    SerialId id;
    from.readAs<dbyte>(id);
    if (id != SerialId::Print) {
        throw DeserializationError("PrintStatement::operator <<", "Invalid ID");
    }
    from >> *_arg;
}
namespace de {
DENG2_PIMPL(Process) {
    State state;
    typedef std::vector<Context *> ContextStack;
    ContextStack stack;
    String workingPath;
    Time startedAt;
    Impl(Public *i)
        : Base(i)
        , state(Stopped)
        , workingPath("/")
    {}
    ~Impl() {
        clearStack();
    }
    void clear() {
        Record *externalGlobals = (!stack.empty() && stack.front()->hasExternalGlobalNamespace()?
                                   &stack.front()->names() : 0);
        state = Stopped;
        clearStack();
        self().pushContext(new Context(Context::BaseProcess, thisPublic, externalGlobals));
        workingPath = "/";
    }
    Context &context(duint downDepth = 0) {
        DENG2_ASSERT(downDepth < depth());
        return **(stack.rbegin() + downDepth);
    }
    inline dsize depth() const {
        return stack.size();
    }
    void clearStack(duint downToLevel = 0) {
        while (depth() > downToLevel) {
            delete stack.back();
            stack.pop_back();
        }
    }
    void run(Statement const *firstStatement) {
        if (state != Stopped) {
            throw NotStoppedError("Process::run", "Process must be stopped first");
        }
        state = Running;
        clearStack(1);
        context().start(firstStatement);
    }
    bool jumpIntoCatch(const Error &err) {
        dint level = 0;
        for (context().proceed(); context().current(); context().proceed()) {
            const Statement *statement = context().current();
            if (is<TryStatement>(statement)) {
                ++level;
                continue;
            }
            if (const auto *catchStatement = dynamic_cast<const CatchStatement *>(statement)) {
                if (!level) {
                    if (catchStatement->matches(err)) {
                        catchStatement->executeCatch(context(), err);
                        return true;
                    }
                }
                if (catchStatement->isFinal() && level > 0) {
                    --level;
                }
            }
        }
        return false;
    }
};
static TimeSpan const MAX_EXECUTION_TIME = 10;
Process::Process(Record *externalGlobalNamespace) : d(new Impl(this)) {
    pushContext(new Context(Context::BaseProcess, this, externalGlobalNamespace));
}
Process::Process(Script const &script) : d(new Impl(this)) {
    clear();
    run(script);
}
Process::State Process::state() const {
    return d->state;
}
void Process::clear() {
    d->clear();
}
dsize Process::depth() const {
    return d->depth();
}
void Process::run(Script const &script) {
    d->run(script.firstStatement());
    globals().set(Record::VAR_FILE, script.path());
}
void Process::suspend(bool suspended) {
    if (d->state == Stopped) {
        throw SuspendError("Process:suspend",
            "Stopped processes cannot be suspended or resumed");
    }
    d->state = (suspended? Suspended : Running);
}
void Process::stop() {
    d->state = Stopped;
    DENG2_FOR_EACH_REVERSE(Impl::ContextStack, i, d->stack) {
        if (*i != d->stack[0]) {
            delete *i;
        }
    }
    DENG2_ASSERT(!d->stack.empty());
    d->stack.erase(d->stack.begin() + 1, d->stack.end());
    context().reset();
}
void Process::execute() {
    if (d->state == Suspended || d->state == Stopped) {
        return;
    }
    dsize startDepth = d->depth();
    if (startDepth == 1) {
        d->startedAt = Time();
    }
    while (d->state == Running && d->depth() >= startDepth) {
        try {
            dsize execDepth = d->depth();
            if (!context().execute() && d->depth() == execDepth) {
                finish();
            }
            else if (d->startedAt.since() > MAX_EXECUTION_TIME) {
                throw HangError("Process::execute",
                    "Script execution takes too long, or is stuck in an infinite loop");
            }
        }
        catch (Error const &err) {
            if (d->jumpIntoCatch(err)) {
                continue;
            }
            if (startDepth > 1) {
                delete popContext();
                throw;
            }
            else {
                LOG_SCR_ERROR("Stopping process: ") << err.asText();
                stop();
            }
        }
    }
}
Context &Process::context(duint downDepth) {
    return d->context(downDepth);
}
void Process::pushContext(Context *context) {
    d->stack.push_back(context);
}
Context *Process::popContext() {
    Context *topmost = d->stack.back();
    d->stack.pop_back();
    if (context().type() == Context::GlobalNamespace) {
        delete d->stack.back();
        d->stack.pop_back();
    }
    return topmost;
}
void Process::finish(Value *returnValue) {
    DENG2_ASSERT(depth() >= 1);
    if (depth() > 1) {
        std::unique_ptr<Context> topmost(popContext());
        if (topmost->type() == Context::FunctionCall) {
            context().evaluator().pushResult(returnValue? returnValue : new NoneValue);
        }
        else {
            DENG2_ASSERT(returnValue == nullptr);
        }
    }
    else {
        DENG2_ASSERT(d->stack.back()->type() == Context::BaseProcess);
        if (returnValue) delete returnValue; // Possible return value ignored.
        d->state = Stopped;
    }
}
String const &Process::workingPath() const {
    return d->workingPath;
}
void Process::setWorkingPath(String const &newWorkingPath) {
    d->workingPath = newWorkingPath;
}
void Process::call(Function const &function, ArrayValue const &arguments, Value *self) {
    Function::ArgumentValues argValues;
    function.mapArgumentValues(arguments, argValues);
    if (function.isNative()) {
        context().setNativeSelf(self);
        context().evaluator().pushResult(function.callNative(context(), argValues));
        context().setNativeSelf(0);
    }
    else {
        if (function.globals() && function.globals() != &globals()) {
            pushContext(new Context(Context::GlobalNamespace, this, function.globals()));
        }
        pushContext(new Context(Context::FunctionCall, this));
        if (self) {
            context().names().add(new Variable(QStringLiteral("self"), self /*taken*/));
        }
        Function::ArgumentValues::const_iterator b = argValues.begin();
        Function::Arguments     ::const_iterator a = function.arguments().begin();
        for (; b != argValues.end() && a != function.arguments().end(); ++b, ++a) {
            context().names().add(new Variable(*a, (*b)->duplicateAsReference()));
        }
        DENG2_ASSERT(d->state != Suspended);
        if (d->state == Running) {
            context().start(function.compound().firstStatement());
            execute();
        }
        else if (d->state == Stopped) {
            d->state = Running;
            context().start(function.compound().firstStatement());
            execute();
            d->state = Stopped;
        }
    }
}
void Process::namespaces(Namespaces &spaces) const {
    spaces.clear();
    bool gotFunction = false;
    DENG2_FOR_EACH_CONST_REVERSE(Impl::ContextStack, i, d->stack) {
        Context &context = **i;
        if (context.type() == Context::FunctionCall) {
            if (gotFunction) continue;
            gotFunction = true;
        }
        spaces.push_back({&context.names(), unsigned(context.type())});
        if (context.type() == Context::GlobalNamespace) {
            break;
        }
    }
}
Record &Process::globals() {
    DENG2_FOR_EACH_CONST_REVERSE(Impl::ContextStack, i, d->stack) {
        Context &context = **i;
        if (context.type() == Context::GlobalNamespace || context.type() == Context::BaseProcess) {
            return context.names();
        }
    }
    return d->stack[0]->names();
}
Record &Process::locals() {
    return d->stack.back()->names();
}
} // namespace de
namespace de {
DENG2_PIMPL_NOREF(Scheduler) {
    struct RunningTimeline {
        Timeline const *timeline = nullptr;
        std::unique_ptr<Timeline::Clock> clock;
        bool isOwned = false;
        ~RunningTimeline() {
            if (isOwned) delete timeline;
        }
    };
    QHash<String, RunningTimeline *> running;
    duint64 counter = 0;
    ~Impl() {
        clear();
    }
    void clear() {
        qDeleteAll(running);
        running.clear();
    }
    String internalName(String const &publicName) {
        if (publicName.isEmpty()) {
            return QString("__TL%1__").arg(counter++, 0, 16);
        }
        return publicName;
    }
    String start(RunningTimeline *run, String const &name) {
        String const intName = internalName(name);
        stop(intName);
        running.insert(intName, run);
        return intName;
    }
    void stop(String const &intName) {
        if (running.contains(intName)) {
            delete running[intName];
            running.remove(intName);
        }
    }
    void advanceTime(TimeSpan const &elapsed) {
        QMutableHashIterator<String, RunningTimeline *> iter(running);
        while (iter.hasNext()) {
            RunningTimeline *rt = iter.next().value();
            rt->clock->advanceTime(elapsed);
            if (rt->clock->isFinished()) {
                delete rt;
                iter.remove();
            }
        }
    }
};
Scheduler::Scheduler()
    : d(new Impl)
{}
void Scheduler::clear() {
    d->clear();
}
String Scheduler::start(Timeline *timeline, String const &name) {
    auto *run = new Impl::RunningTimeline;
    run->isOwned = true;
    run->timeline = timeline;
    run->clock.reset(new Timeline::Clock(*timeline, timeline->context()));
    return d->start(run, name);
}
String Scheduler::start(Timeline const &sharedTimeline, Record *context, String const &name) {
    auto *run = new Impl::RunningTimeline;
    run->isOwned = false;
    run->timeline = &sharedTimeline;
    run->clock.reset(new Timeline::Clock(sharedTimeline, context));
    return d->start(run, name);
}
void Scheduler::stop(String const &name) {
    d->stop(name);
}
void Scheduler::advanceTime(TimeSpan const &elapsed) {
    d->advanceTime(elapsed);
}
} // namespace de
namespace de {
DENG2_PIMPL_NOREF(ScopeStatement) {
    QScopedPointer<Expression> identifier;
    QScopedPointer<Expression> superRecords;
    Compound compound;
};
ScopeStatement::ScopeStatement() : d(new Impl)
{}
ScopeStatement::ScopeStatement(Expression *identifier, Expression *superRecords)
    : d(new Impl) {
    d->identifier.reset(identifier);
    d->superRecords.reset(superRecords);
}
Compound &ScopeStatement::compound() {
    return d->compound;
}
void ScopeStatement::execute(Context &context) const {
    Evaluator &eval = context.evaluator();
    Record &classRecord = eval.evaluateTo<RecordValue>(d->identifier.data()).dereference();
    eval.evaluate(d->superRecords.data());
    QScopedPointer<ArrayValue> newSupers(eval.popResultAs<ArrayValue>());
    while (newSupers->size() > 0) {
        classRecord.addSuperRecord(newSupers->popFirst());
    }
    context.proceed();
    Context *scope = new Context(Context::Namespace, &context.process(), &classRecord);
    scope->start(d->compound.firstStatement());
    context.process().pushContext(scope);
}
void ScopeStatement::operator >> (Writer &to) const {
    to << dbyte(SerialId::Scope) << *d->identifier << *d->superRecords << d->compound;
}
void ScopeStatement::operator << (Reader &from) {
    SerialId id;
    from.readAs<dbyte>(id);
    if (id != SerialId::Scope) {
        throw DeserializationError("ScopeStatement::operator <<", "Invalid ID");
    }
    d->identifier.reset(Expression::constructFrom(from));
    d->superRecords.reset(Expression::constructFrom(from));
    from >> d->compound;
}
} // namespace de
namespace de {
DENG2_PIMPL_NOREF(Script) {
    Compound compound;
    String path;
};
Script::Script() : d(new Impl)
{}
Script::Script(String const &source) : d(new Impl) {
    Parser().parse(source, *this);
}
Script::Script(File const &file) : d(new Impl) {
    d->path = file.path();
    Parser().parse(String::fromUtf8(Block(file)), *this);
}
void Script::parse(String const &source) {
    d->compound.clear();
    Parser().parse(source, *this);
}
void Script::setPath(String const &path) {
    d->path = path;
}
String const &Script::path() const {
    return d->path;
}
Statement const *Script::firstStatement() const {
    return d->compound.firstStatement();
}
Compound &Script::compound() {
    return d->compound;
}
} // namespace de
namespace de {
String const ScriptedInfo::SCRIPT         = "script";
String const ScriptedInfo::BLOCK_GROUP    = "group";
String const ScriptedInfo::VAR_SOURCE     = "__source__";
String const ScriptedInfo::VAR_BLOCK_TYPE = "__type__";
String const ScriptedInfo::VAR_INHERITED_SOURCES = "__inheritedSources__"; // array
static String const BLOCK_NAMESPACE = "namespace";
static String const BLOCK_SCRIPT    = ScriptedInfo::SCRIPT;
static String const KEY_SCRIPT      = ScriptedInfo::SCRIPT;
static String const KEY_INHERITS    = "inherits";
static String const KEY_CONDITION   = "condition";
static String const VAR_SCRIPT      = "__script%1__";
DENG2_PIMPL(ScriptedInfo) {
    typedef Info::Element::Value InfoValue;
    Info info;                     ///< Original full parsed contents.
    QScopedPointer<Script> script; ///< Current script being executed.
    Process process;               ///< Execution context.
    String currentNamespace;
    Impl(Public *i, Record *globalNamespace)
        : Base(i)
        , process(globalNamespace) {
        info.setAllowDuplicateBlocksOfType(
                    QStringList() << BLOCK_GROUP << BLOCK_NAMESPACE);
        info.setScriptBlocks(QStringList() << BLOCK_SCRIPT);
        info.setImplicitBlockType(BLOCK_GROUP);
    }
    void clear() {
        info.clear();
        process.clear();
        script.reset();
    }
    /**
     * Iterates through the parsed Info contents and processes each element.
     * Script blocks are parsed as Doomsday Script and executed in the local
     * process. Key/value elements become variables (and values) in the
     * process's global namespace.
     */
    void processAll() {
        processBlock(info.root());
        LOG_SCR_XVERBOSE("Processed contents:\n", process.globals().asText());
    }
    void processElement(Info::Element const *element) {
        if (element->isBlock()) {
            processBlock(element->as<Info::BlockElement>());
        }
        else if (element->isKey()) {
            processKey(element->as<Info::KeyElement>());
        }
        else if (element->isList()) {
            processList(element->as<Info::ListElement>());
        }
    }
    void executeWithContext(Info::BlockElement const *context) {
        Record &ns = process.globals();
        bool needRemoveSelf = false;
        if (context) {
            String varName = variableName(*context);
            if (!varName.isEmpty()) {
                if (!ns.has(varName)) {
                    ns.addSubrecord(varName);
                }
                ns.add("self") = new RecordValue(ns.subrecord(varName));
                needRemoveSelf = true;
            }
        }
        process.execute();
        if (needRemoveSelf) {
            delete &ns["self"];
        }
    }
    void inherit(Info::BlockElement const &block, InfoValue const &target) {
        if (block.name().isEmpty()) {
            return;
        }
        String varName = variableName(block);
        if (!varName.isEmpty()) {
            Record &ns = process.globals();
            String targetName = checkNamespaceForVariable(target);
            if (!ns.has(targetName)) {
                targetName = checkNamespaceForVariable(target.text.toLower());
            }
            if (!ns.has(targetName)) {
                targetName = variableName(block.parent()? *block.parent() : block)
                                    .concatenateMember(target);
            }
            ns.add(varName.concatenateMember("__inherit__")) =
                    new TextValue(targetName);
            LOGDEV_SCR_XVERBOSE_DEBUGONLY("setting __inherit__ of %s %s (%p) to %s",
                                         block.blockType() << varName << &block << targetName);
            DENG2_ASSERT(!varName.isEmpty());
            DENG2_ASSERT(!targetName.isEmpty());
            Record const &src = ns[targetName].value<RecordValue>().dereference();
            Record &dest = ns.subrecord(varName);
            dest.copyMembersFrom(src, Record::IgnoreDoubleUnderscoreMembers);
            if (src.hasMember(VAR_SOURCE)) {
                if (!dest.hasMember(VAR_INHERITED_SOURCES)) {
                    dest.addArray(VAR_INHERITED_SOURCES);
                }
                dest[VAR_INHERITED_SOURCES].value<ArrayValue>()
                        .add(new TextValue(ScriptedInfo::sourcePathAndLine(src).first));
            }
        }
    }
    void inheritFromAncestors(Info::BlockElement const &block, Info::BlockElement const *from) {
        if (!from) return;
        if (from->parent()) {
            inheritFromAncestors(block, from->parent());
        }
        if (from->blockType() == BLOCK_GROUP) {
            if (Info::KeyElement *key = from->findAs<Info::KeyElement>(KEY_INHERITS)) {
                inherit(block, key->value());
            }
        }
    }
    /**
     * Determines whether a script block is unqualified, meaning it is an anonymous
     * script block that has no other keys than the script itself and possibly a
     * "condition" key.
     *
     * @param block  Block.
     *
     * @return @c true, if an unqualified script block (that will be executed immediately
     * during processing of the ScriptedInfo document), or otherwise @c false, in which
     * case the script is assumed to be executed at a later point in time.
     */
    bool isUnqualifiedScriptBlock(Info::BlockElement const &block) {
        if (block.blockType() != BLOCK_SCRIPT) return false;
        for (auto const *child : block.contentsInOrder()) {
            if (!child->isKey()) return false;
            Info::KeyElement const &key = child->as<Info::KeyElement>();
            if (key.name() != KEY_SCRIPT && key.name() != KEY_CONDITION) {
                return false;
            }
        }
        return block.contains(KEY_SCRIPT);
    }
    /**
     * Chooses a new automatically generated (anonymous) script block name that is
     * unique within @a where.
     *
     * @param where  Record where the script will be stored.
     *
     * @return Variable name.
     */
    static String chooseScriptName(Record const &where) {
        int counter = 0;
        forever {
            String name = VAR_SCRIPT.arg(counter, 2 /*width*/, 10 /*base*/, QLatin1Char('0'));
            if (!where.has(name)) return name;
            counter++;
        }
    }
    void processBlock(Info::BlockElement const &block) {
        Record &ns = process.globals();
        if (Info::Element *condition = block.find(KEY_CONDITION)) {
            QScopedPointer<Value> result(evaluate(condition->values().first(), 0));
            if (result.isNull() || result->isFalse()) {
                return;
            }
        }
        inheritFromAncestors(block, block.parent());
        if (Info::KeyElement *key = block.findAs<Info::KeyElement>(KEY_INHERITS)) {
            if (key->flags().testFlag(Info::KeyElement::Attribute)) {
                inherit(block, key->value());
            }
        }
        bool const isScriptBlock = (block.blockType() == BLOCK_SCRIPT);
        if (isUnqualifiedScriptBlock(block)) {
            DENG2_ASSERT(process.state() == Process::Stopped);
            script.reset(new Script(block.keyValue(KEY_SCRIPT)));
            script->setPath(info.sourcePath()); // where the source comes from
            process.run(*script);
            executeWithContext(block.parent());
        }
        else {
            String oldNamespace = currentNamespace;
            if (block.blockType() == BLOCK_NAMESPACE) {
                if (!block.name().isEmpty()) {
                    currentNamespace = currentNamespace.concatenateMember(block.name());
                }
                else {
                    currentNamespace = "";
                }
                LOG_SCR_XVERBOSE("%s: Namespace set to '%s'",
                                 block.sourceLocation() << currentNamespace);
            }
            else if (!block.name().isEmpty() || isScriptBlock) {
                String varName;
                if (isScriptBlock) {
                    String const parentVarName = variableName(*block.parent());
                    varName = parentVarName.concatenateMember(chooseScriptName(ns[parentVarName]));
                }
                else {
                    varName = variableName(block);
                }
                if (!ns.has(varName)) {
                    ns.addSubrecord(varName);
                }
                Record &blockRecord = ns[varName];
                blockRecord.addText(VAR_BLOCK_TYPE, block.blockType());
                blockRecord.addNumber(VAR_SOURCE, block.sourceLineId())
                        .value<NumberValue>().setSemanticHints(NumberValue::Hex);
                if (!isScriptBlock) {
                    DENG2_FOR_PUBLIC_AUDIENCE2(NamedBlock, i) {
                        i->parsedNamedBlock(varName, blockRecord);
                    }
                }
                else {
                    for (auto const *elem : block.contents().values()) {
                        if (elem->isKey()) {
                            auto const &key = elem->as<Info::KeyElement>();
                            if (key.name() != KEY_CONDITION) {
                                blockRecord.addText(key.name(), key.value());
                            }
                        }
                    }
                }
            }
            if (!isScriptBlock) {
                foreach (Info::Element const *sub, block.contentsInOrder()) {
                    if (sub->name() == KEY_CONDITION || sub->name() == KEY_INHERITS) {
                        continue;
                    }
                    processElement(sub);
                }
            }
            currentNamespace = oldNamespace;
        }
    }
    /**
     * Determines the name of the variable representing an element. All named
     * containing parent blocks contribute to the variable name.
     *
     * @param element  Element whose variable name to determine.
     *
     * @return Variable name in the form <tt>ancestor.parent.elementname</tt>.
     */
    String variableName(Info::Element const &element) {
        String varName = element.name();
        for (Info::BlockElement *b = element.parent(); b != 0; b = b->parent()) {
            if (b->blockType() == BLOCK_NAMESPACE) continue;
            if (!b->name().isEmpty()) {
                if (varName.isEmpty())
                    varName = b->name();
                else
                    varName = b->name().concatenateMember(varName);
            }
        }
        return checkNamespaceForVariable(varName);
    }
    /**
     * Look up a variable name taking into consideration the current namespace.
     * Unlike simple grouping, namespaces also allow accessing the global
     * namespace if nothing shadows the identifier in the namespace. However,
     * all new variables get created using the current namespace.
     *
     * @param varName  Provided variable name without a namespace.
     *
     * @return Variable to use after namespace has been applied.
     */
    String checkNamespaceForVariable(String varName) {
        if (varName.isEmpty()) return "";
        if (!currentNamespace.isEmpty()) {
            String nsVarName = currentNamespace.concatenateMember(varName);
            if (process.globals().has(nsVarName)) {
                return nsVarName;
            }
        }
        if (process.globals().has(varName)) {
            return varName;
        }
        if (!currentNamespace.isEmpty()) {
            return currentNamespace.concatenateMember(varName);
        }
        return varName;
    }
    Value *evaluate(String const &source, Info::BlockElement const *context) {
        script.reset(new Script(source));
        script->setPath(info.sourcePath()); // where the source comes from
        process.run(*script);
        executeWithContext(context);
        return process.context().evaluator().result().duplicate();
    }
    /**
     * Constructs a Value from the value of an element. If the element value has been
     * marked with the semantic hint for scripting, it will be evaluated as a script. A
     * global "self" variable will be pointed to the Record representing the @a context
     * block.
     *
     * @param rawValue  Value of an element.
     * @param context   Containing block element.
     *
     * @return Value instance. Caller gets ownership.
     */
    Value *makeValue(InfoValue const &rawValue, Info::BlockElement const *context) {
        if (rawValue.flags.testFlag(InfoValue::Script)) {
            return evaluate(rawValue.text, context);
        }
        return new TextValue(rawValue.text);
    }
    void processKey(Info::KeyElement const &key) {
        QScopedPointer<Value> v(makeValue(key.value(), key.parent()));
        process.globals().add(variableName(key)) = v.take();
    }
    void processList(Info::ListElement const &list) {
        ArrayValue* av = new ArrayValue;
        foreach (InfoValue const &v, list.values()) {
            *av << makeValue(v, list.parent());
        }
        process.globals().addArray(variableName(list), av);
    }
    static void findBlocks(String const &blockType, Paths &paths, Record const &rec, String prefix = "") {
        if (rec.hasMember(VAR_BLOCK_TYPE) &&
           !rec[VAR_BLOCK_TYPE].value().asText().compareWithoutCase(blockType)) {
            paths.insert(prefix);
        }
        Record::Subrecords const subs = rec.subrecords();
        DENG2_FOR_EACH_CONST(Record::Subrecords, i, subs) {
            findBlocks(blockType, paths, *i.value(), prefix.concatenateMember(i.key()));
        }
    }
    DENG2_PIMPL_AUDIENCE(NamedBlock)
};
DENG2_AUDIENCE_METHOD(ScriptedInfo, NamedBlock)
ScriptedInfo::ScriptedInfo(Record *globalNamespace)
    : d(new Impl(this, globalNamespace))
{}
void ScriptedInfo::clear() {
    d->clear();
}
void ScriptedInfo::parse(String const &source) {
    d->clear();
    d->info.parse(source);
    d->processAll();
}
void ScriptedInfo::parse(File const &file) {
    d->clear();
    d->info.parse(file);
    d->processAll();
}
Value *ScriptedInfo::evaluate(String const &source) {
    return d->evaluate(source, 0);
}
Record &ScriptedInfo::objectNamespace() {
    return d->process.globals();
}
Record const &ScriptedInfo::objectNamespace() const {
    return d->process.globals();
}
ScriptedInfo::Paths ScriptedInfo::allBlocksOfType(String const &blockType) const {
    return allBlocksOfType(blockType, d->process.globals());
}
String ScriptedInfo::absolutePathInContext(Record const &context, String const &relativePath) // static
{
    if (context.has(VAR_SOURCE)) {
        auto const sourceLocation = Info::sourceLineTable().sourcePathAndLineNumber(
                    context.getui(VAR_SOURCE));
        String absPath = sourceLocation.first.fileNamePath() / relativePath;
        if (!App::rootFolder().has(absPath)) {
            if (context.has(VAR_INHERITED_SOURCES)) {
                auto const &elems = context.geta(VAR_INHERITED_SOURCES);
                for (int i = elems.size() - 1; i >= 0; --i) {
                    String inheritedPath = elems.at(i).asText().fileNamePath() / relativePath;
                    if (App::rootFolder().has(inheritedPath)) {
                        return inheritedPath;
                    }
                }
            }
        }
        return absPath;
    }
    return relativePath;
}
bool ScriptedInfo::isTrue(Value const &value) // static
{
    if (TextValue const *textValue = maybeAs<TextValue>(value)) {
        String const value = textValue->asText();
        if (!value.compareWithoutCase("true") ||
            !value.compareWithoutCase("yes") ||
            !value.compareWithoutCase("on")) {
            return true;
        }
        return false;
    }
    return value.isTrue();
}
bool ScriptedInfo::isTrue(RecordAccessor const &rec, String const &name, bool defaultValue) {
    if (rec.has(name)) {
        return isTrue(rec.get(name));
    }
    return defaultValue;
}
String ScriptedInfo::blockType(Record const &block) {
    return block.gets(VAR_BLOCK_TYPE, BLOCK_GROUP).toLower();
}
bool ScriptedInfo::isFalse(RecordAccessor const &rec, String const &name, bool defaultValue) {
    if (rec.has(name)) {
        return isFalse(rec.get(name));
    }
    return defaultValue;
}
bool ScriptedInfo::isFalse(String const &token) // static
{
    if (!token.compareWithoutCase("false") ||
        !token.compareWithoutCase("no")    ||
        !token.compareWithoutCase("off")) {
        return true;
    }
    return false;
}
bool ScriptedInfo::isFalse(Value const &value) // static
{
    if (TextValue const *textValue = maybeAs<TextValue>(value)) {
        return isFalse(textValue->asText());
    }
    return !value.isTrue();
}
ScriptedInfo::Paths ScriptedInfo::allBlocksOfType(String const &blockType, Record const &root) // static
{
    Paths found;
    Impl::findBlocks(blockType, found, root);
    return found;
}
Record::Subrecords ScriptedInfo::subrecordsOfType(String const &blockType, Record const &record) // static
{
    return record.subrecords([&] (Record const &sub) {
        return sub.gets(VAR_BLOCK_TYPE, "") == blockType;
    });
}
StringList ScriptedInfo::sortRecordsBySource(Record::Subrecords const &subrecs) {
    StringList keys = subrecs.keys();
    std::sort(keys.begin(), keys.end(), [&subrecs] (String const &a, String const &b) -> bool {
        auto const src1 = Info::sourceLineTable().sourcePathAndLineNumber(subrecs[a]->getui(VAR_SOURCE, 0));
        auto const src2 = Info::sourceLineTable().sourcePathAndLineNumber(subrecs[b]->getui(VAR_SOURCE, 0));
        if (!String(src1.first).compareWithoutCase(src2.first)) {
            return src1.second < src2.second;
        }
        return String(src1.first).compareWithoutCase(src2.first) < 0;
    });
    return keys;
}
String ScriptedInfo::sourceLocation(RecordAccessor const &record) {
    return Info::sourceLocation(record.getui(VAR_SOURCE, 0));
}
SourceLineTable::PathAndLine ScriptedInfo::sourcePathAndLine(RecordAccessor const &record) {
    return Info::sourceLineTable().sourcePathAndLineNumber(record.getui(VAR_SOURCE, 0));
}
} // namespace de
String const ScriptLex::AND("and");
String const ScriptLex::OR("or");
String const ScriptLex::NOT("not");
String const ScriptLex::IF("if");
String const ScriptLex::ELSIF("elsif");
String const ScriptLex::ELSE("else");
String const ScriptLex::END("end");
String const ScriptLex::THROW("throw");
String const ScriptLex::CATCH("catch");
String const ScriptLex::IN("in");
String const ScriptLex::WHILE("while");
String const ScriptLex::FOR("for");
String const ScriptLex::DEF("def");
String const ScriptLex::TRY("try");
String const ScriptLex::IMPORT("import");
String const ScriptLex::RECORD("record");
String const ScriptLex::SCOPE("->");
String const ScriptLex::DEL("del");
String const ScriptLex::PASS("pass");
String const ScriptLex::CONTINUE("continue");
String const ScriptLex::BREAK("break");
String const ScriptLex::RETURN("return");
String const ScriptLex::CONST("const");
String const ScriptLex::PRINT("print");
String const ScriptLex::T_TRUE("True");
String const ScriptLex::T_FALSE("False");
String const ScriptLex::NONE("None");
String const ScriptLex::PI("Pi");
String const ScriptLex::ASSIGN("=");
String const ScriptLex::SCOPE_ASSIGN(":=");
String const ScriptLex::WEAK_ASSIGN("?=");
ScriptLex::ScriptLex(String const &input) : Lex(input)
{}
duint ScriptLex::getStatement(TokenBuffer &output, Behaviors const &behavior) {
    output.clear();
    duint counter = 0; // How many tokens have we added?
    enum BracketType {
        BRACKET_PARENTHESIS,
        BRACKET_SQUARE,
        BRACKET_CURLY,
        MAX_BRACKETS
    };
    dint bracketLevel[MAX_BRACKETS] = { 0, 0, 0 };
    skipWhite();
    duint indentation = countLineStartSpace();
    while (!atEnd()) {
        skipWhiteExceptNewline();
        if (behavior.testFlag(StopAtMismatchedCloseBrace) &&
            !bracketLevel[BRACKET_CURLY] &&
            peek() == '}') {
            break;
        }
        if (peek().isNull()) break;
        QChar c = get();
        if (c == '\n' || c == ';') {
            if (Vector3i(bracketLevel).max() > 0)
                continue;
            else
                break;
        }
        output.newToken(lineNumber());
        if (c == '\\') {
            if (onlyWhiteOnLine()) {
                skipToNextLine();
                continue;
            }
        }
        output.appendChar(c);
        if (c == '"' || c == '\'') {
            output.setType(parseString(c, indentation, output));
            output.endToken();
            counter++;
            continue;
        }
        if (parseLiteralNumber(c, output)) {
            counter++;
            continue;
        }
        if (isAlphaNumeric(c)) {
            output.setType(Token::IDENTIFIER);
            while (isAlphaNumeric((c = peek()))) {
                output.appendChar(get());
            }
            if (isKeyword(output.latest())) {
                output.setType(Token::KEYWORD);
            }
            output.endToken();
            counter++;
            continue;
        }
        if (c == '-' && peek() == '>') {
            output.setType(Token::KEYWORD);
            output.appendChar(get());
            output.endToken();
            counter++;
            continue;
        }
        if (isOperator(c)) {
            output.setType(Token::OPERATOR);
            if (combinesWith(c, peek())) {
                output.appendChar(get());
            }
            else {
                if (c == '(') bracketLevel[BRACKET_PARENTHESIS]++;
                if (c == ')') bracketLevel[BRACKET_PARENTHESIS]--;
                if (c == '[') bracketLevel[BRACKET_SQUARE]++;
                if (c == ']') bracketLevel[BRACKET_SQUARE]--;
                if (c == '{') bracketLevel[BRACKET_CURLY]++;
                if (c == '}') bracketLevel[BRACKET_CURLY]--;
                if (Vector3i(bracketLevel).min() < 0) {
                    throw MismatchedBracketError("ScriptLex::getStatement",
                                                 "Mismatched bracket '" + QString(c) +
                                                 "' on line " +
                                                 QString::number(lineNumber()));
                }
            }
            output.endToken();
            counter++;
            continue;
        }
        throw UnexpectedCharacterError("ScriptLex::getStatement",
                                       "Character '" + String(1, c) + "' was unexpected");
    }
    if (atEnd()) {
        for (int i = 0; i < MAX_BRACKETS; ++i) {
            if (bracketLevel[i] > 0) {
                throw MismatchedBracketError("ScriptLex::getStatement", "Unclosed bracket '" +
                    String(i == BRACKET_PARENTHESIS? ")" :
                           i == BRACKET_SQUARE? "]" : "}") + "'");
            }
        }
    }
    return counter; // Number of tokens added.
}
Token::Type
ScriptLex::parseString(QChar startChar, duint startIndentation, TokenBuffer &output) {
    Token::Type type =
        ( startChar == '\''? Token::LITERAL_STRING_APOSTROPHE :
          Token::LITERAL_STRING_QUOTED );
    bool longString = false;
    duint charLineNumber = lineNumber();
    ModeSpan readingMode(*this, RetainComments);
    QChar c = get();
    if (c == '\n') {
        throw UnterminatedStringError("ScriptLex::parseString",
                                      "String on line " + QString::number(charLineNumber) +
                                      " is not terminated");
    }
    output.appendChar(c);
    if (c == startChar) {
        if (c == '"' && peek() == '"') {
            longString = true;
            output.appendChar(get());
        }
        else {
            return type;
        }
    }
    for (;;) {
        charLineNumber = lineNumber();
        output.appendChar(c = get());
        if (c == '\\') // Escape?
        {
            output.appendChar(get()); // Don't care what it is.
            continue;
        }
        if (c == '\n') // Newline?
        {
            if (!longString) {
                throw UnterminatedStringError("ScriptLex::parseString",
                                              "String on line " +
                                              QString::number(charLineNumber) +
                                              " is not terminated");
            }
            duint skipCount = startIndentation;
            while (skipCount-- && isWhite(c = peek()) && c != '\n') {
                get();
            }
            continue;
        }
        if (c == startChar) {
            if (longString) {
                if (peek() == '"') {
                    output.appendChar(get());
                    if (peek() == '"') {
                        output.appendChar(get());
                        break;
                    }
                }
                continue;
            }
            break;
        }
    }
    return (longString? Token::LITERAL_STRING_LONG : type);
}
bool ScriptLex::isOperator(QChar c) {
    return (c == '=' || c == ',' || c == '.'
         || c == '-' || c == '+' || c == '/' || c == '*' || c == '%'
         || c == '&' || c == '|' || c == '!' || c == '^' || c == '~'
         || c == '(' || c == ')' || c == '{' || c == '}' || c == '[' || c == ']'
         || c == ':' || c == '<' || c == '>' || c == '?');
}
bool ScriptLex::combinesWith(QChar a, QChar b) {
    if (b == '=') {
        return (a == '=' || a == '+' || a == '-' || a == '/'
             || a == '*' || a == '%' || a == '!' || a == '|' || a == '&'
             || a == '^' || a == '~' || a == '<' || a == '>' || a == ':' || a == '?');
    }
    else if ((a == '<' && b == '<') || (a == '>' && b == '>')) {
        return true;
    }
    return false;
}
static QSet<QString> const keywordStr {
    ScriptLex::AND,
    ScriptLex::BREAK,
    ScriptLex::CATCH,
    ScriptLex::CONST,
    ScriptLex::CONTINUE,
    ScriptLex::DEF,
    ScriptLex::DEL,
    ScriptLex::ELSE,
    ScriptLex::ELSIF,
    ScriptLex::END,
    ScriptLex::FOR,
    ScriptLex::IF,
    ScriptLex::IMPORT,
    ScriptLex::IN,
    ScriptLex::NOT,
    ScriptLex::OR,
    ScriptLex::PASS,
    ScriptLex::PRINT,
    ScriptLex::RECORD,
    ScriptLex::RETURN,
    ScriptLex::SCOPE,
    ScriptLex::THROW,
    ScriptLex::TRY,
    ScriptLex::WHILE,
    ScriptLex::NONE,
    ScriptLex::T_FALSE,
    ScriptLex::T_TRUE,
    ScriptLex::PI,
};
bool ScriptLex::isKeyword(Token const &token) {
    return keywordStr.contains(token.str());
/*    for (int i = 0; keywordStr[i]; ++i)
    {
        if (token.equals(keywordStr[i])) {
            return true;
        }
    }
    return false;*/
}
StringList ScriptLex::keywords() {
    StringList list;
    foreach (QString const &kw, keywordStr) {
        list << kw;
    }
    return list;
}
namespace de {
static ScriptSystem *_scriptSystem = 0;
DENG2_PIMPL(ScriptSystem)
, DENG2_OBSERVES(Record, Deletion) {
    Binder binder;
    typedef QHash<String, Record *> NativeModules;
    LockableT<NativeModules> nativeModules; // not owned
    Record coreModule;    ///< Script: built-in script classes and functions.
    Record mathModule;    ///< Math: math related functions.
    Record versionModule; ///< Version: information about the platform and build
    typedef QHash<String, Module *> Modules; // owned
    Modules modules;
    QList<Path> additionalImportPaths;
    Impl(Public *i) : Base(*i) {
        initCoreModule();
        initMathModule(binder, mathModule);
        addNativeModule("Math", mathModule); {
            Version const ver = Version::currentBuild();
            Record &mod = versionModule;
            ArrayValue *num = new ArrayValue;
            *num << NumberValue(ver.major) << NumberValue(ver.minor)
                 << NumberValue(ver.patch) << NumberValue(ver.build);
            mod.addArray  ("VERSION",  num                       ).setReadOnly();
            mod.addText   ("TEXT",     ver.fullNumber()          ).setReadOnly();
            mod.addNumber ("BUILD",    ver.build                 ).setReadOnly();
            mod.addText   ("OS",       Version::operatingSystem()).setReadOnly();
            mod.addNumber ("CPU_BITS", Version::cpuBits()        ).setReadOnly();
            mod.addBoolean("DEBUG",    Version::isDebugBuild()   ).setReadOnly();
            mod.addText   ("GIT",      ver.gitDescription        ).setReadOnly();
#ifdef DENG_STABLE
            mod.addBoolean("STABLE",   true).setReadOnly();
#else
            mod.addBoolean("STABLE",   false).setReadOnly();
#endif
            addNativeModule("Version", mod);
        }
    }
    ~Impl() {
        qDeleteAll(modules);
    }
    static Value *Function_ImportPath(Context &, Function::ArgumentValues const &) {
        DENG2_ASSERT(_scriptSystem != nullptr);
        StringList importPaths;
        _scriptSystem->d->listImportPaths(importPaths);
        auto *array = new ArrayValue;
        for (auto const &path : importPaths) {
            *array << TextValue(path);
        }
        return array;
    }
    void initCoreModule() {
        de::initCoreModule(binder, coreModule);
        binder.init(coreModule)
                << DENG2_FUNC_NOARG(ImportPath, "importPath");
        addNativeModule("Core", coreModule);
    }
    void addNativeModule(String const &name, Record &module) {
        DENG2_GUARD(nativeModules);
        nativeModules.value.insert(name, &module); // not owned
        module.audienceForDeletion() += this;
    }
    void removeNativeModule(String const &name) {
        DENG2_GUARD(nativeModules);
        if (!nativeModules.value.contains(name)) return;
        nativeModules.value[name]->audienceForDeletion() -= this;
        nativeModules.value.remove(name);
    }
    void recordBeingDeleted(Record &record) {
        DENG2_GUARD(nativeModules);
        QMutableHashIterator<String, Record *> iter(nativeModules);
        while (iter.hasNext()) {
            iter.next();
            if (iter.value() == &record) {
                iter.remove();
            }
        }
    }
    void listImportPaths(StringList &importPaths) {
        std::unique_ptr<ArrayValue> defaultImportPath(new ArrayValue);
        defaultImportPath->add("");
        ArrayValue const *importPath;
        try {
            importPath = &App::config().geta("importPath");
        }
        catch (Record::NotFoundError const &) {
            importPath = defaultImportPath.get();
        }
        importPaths.clear();
        DENG2_FOR_EACH_CONST(ArrayValue::Elements, i, importPath->elements()) {
            importPaths << (*i)->asText();
        }
        foreach (Path const &path, additionalImportPaths) {
            importPaths << path;
        }
    }
};
ScriptSystem::ScriptSystem() : d(new Impl(this)) {
    _scriptSystem = this;
}
ScriptSystem::~ScriptSystem() {
    _scriptSystem = 0;
}
void ScriptSystem::addModuleImportPath(Path const &path) {
    d->additionalImportPaths << path;
}
void ScriptSystem::removeModuleImportPath(Path const &path) {
    d->additionalImportPaths.removeOne(path);
}
void ScriptSystem::addNativeModule(String const &name, Record &module) {
    d->addNativeModule(name, module);
}
void ScriptSystem::removeNativeModule(String const &name) {
    d->removeNativeModule(name);
}
Record &ScriptSystem::nativeModule(String const &name) {
    DENG2_GUARD_FOR(d->nativeModules, G);
    Impl::NativeModules::const_iterator foundNative = d->nativeModules.value.constFind(name);
    DENG2_ASSERT(foundNative != d->nativeModules.value.constEnd());
    return *foundNative.value();
}
Record &ScriptSystem::operator[](const String &name) {
    if (nativeModuleExists(name)) {
        return nativeModule(name);
    } {
        const auto &mods = d->modules;
        auto found = mods.find(name);
        if (found != mods.end()) {
            return found.value()->names();
        }
    }
    throw NotFoundError("ScriptSystem::operator[]", "Module not found: " + name);
}
bool ScriptSystem::nativeModuleExists(const String &name) const {
    DENG2_GUARD_FOR(d->nativeModules, G);
    return d->nativeModules.value.contains(name);
}
StringList ScriptSystem::nativeModules() const {
    DENG2_GUARD_FOR(d->nativeModules, G);
    return d->nativeModules.value.keys();
}
namespace internal {
    static bool sortFilesByModifiedAt(File *a, File *b) {
        DENG2_ASSERT(a != b);
        return de::cmp(a->status().modifiedAt, b->status().modifiedAt) < 0;
    }
}
File const *ScriptSystem::tryFindModuleSource(String const &name, String const &localPath) {
    StringList importPaths;
    d->listImportPaths(importPaths);
    foreach (String dir, importPaths) {
        String p;
        FS::FoundFiles matching;
        File *found = 0;
        if (dir.empty()) {
            if (!localPath.empty()) {
                p = localPath / name;
            }
            else {
                continue;
            }
        }
        else if (dir == "*") {
            App::fileSystem().findAll(name + ".ds", matching);
            if (matching.empty()) {
                continue;
            }
            matching.sort(internal::sortFilesByModifiedAt);
            found = matching.back();
            LOG_SCR_VERBOSE("Chose ") << found->path() << " out of " << dint(matching.size())
                                      << " candidates (latest modified)";
        }
        else {
            p = dir / name;
        }
        if (!found) {
            found = App::rootFolder().tryLocateFile(p + ".ds");
        }
        if (found) {
            return found;
        }
    }
    return 0;
}
File const &ScriptSystem::findModuleSource(String const &name, String const &localPath) {
    File const *src = tryFindModuleSource(name, localPath);
    if (!src) {
        throw NotFoundError("ScriptSystem::findModuleSource", "Cannot find module '" + name + "'");
    }
    return *src;
}
Record &ScriptSystem::builtInClass(String const &name) {
    return builtInClass(QStringLiteral("Core"), name);
}
Record &ScriptSystem::builtInClass(String const &nativeModuleName, String const &className) {
    return const_cast<Record &>(ScriptSystem::get().nativeModule(nativeModuleName)
                                .getr(className).dereference());
}
ScriptSystem &ScriptSystem::get() {
    DENG2_ASSERT(_scriptSystem);
    return *_scriptSystem;
}
Record &ScriptSystem::importModule(String const &name, String const &importedFromPath) {
    LOG_AS("ScriptSystem::importModule"); {
        DENG2_GUARD_FOR(d->nativeModules, G);
        Impl::NativeModules::const_iterator foundNative = d->nativeModules.value.constFind(name);
        if (foundNative != d->nativeModules.value.constEnd()) {
            return *foundNative.value();
        }
    }
    Impl::Modules::iterator found = d->modules.find(name);
    if (found != d->modules.end()) {
        return found.value()->names();
    }
    File const *src = tryFindModuleSource(name, importedFromPath.fileNamePath());
    if (src) {
        Module *module = new Module(*src);
        d->modules.insert(name, module); // owned
        return module->names();
    }
    throw NotFoundError("ScriptSystem::importModule", "Cannot find module '" + name + "'");
}
void ScriptSystem::timeChanged(Clock const &) {
}
} // namespace de
Statement::Statement() : _next(nullptr), _lineNumber(0)
{}
Statement::~Statement()
{}
Statement *Statement::constructFrom(Reader &reader) {
    SerialId id;
    reader.mark();
    reader.readAs<dbyte>(id);
    reader.rewind();
    std::unique_ptr<Statement> result;
    switch (id) {
    case SerialId::Assign:
        result.reset(new AssignStatement);
        break;
    case SerialId::Catch:
        result.reset(new CatchStatement);
        break;
    case SerialId::Delete:
        result.reset(new DeleteStatement);
        break;
    case SerialId::Expression:
        result.reset(new ExpressionStatement);
        break;
    case SerialId::Flow:
        result.reset(new FlowStatement);
        break;
    case SerialId::For:
        result.reset(new ForStatement);
        break;
    case SerialId::Function:
        result.reset(new FunctionStatement);
        break;
    case SerialId::If:
        result.reset(new IfStatement);
        break;
    case SerialId::Print:
        result.reset(new PrintStatement);
        break;
    case SerialId::Try:
        result.reset(new TryStatement);
        break;
    case SerialId::While:
        result.reset(new WhileStatement);
        break;
    case SerialId::Scope:
        result.reset(new ScopeStatement);
        break;
    default:
        throw DeserializationError("Statement::constructFrom", "Invalid statement identifier");
    }
    reader >> *result.get();
    return result.release();
}
void Statement::setLineNumber(duint line) {
    _lineNumber = line;
}
duint Statement::lineNumber() const {
    return _lineNumber;
}
namespace de {
DENG2_PIMPL(Timeline)
, DENG2_OBSERVES(Record, Deletion) {
    Record *context = nullptr;
    struct Event {
        TimeSpan at;
        Script script;
        Event(TimeSpan at, String const &source, String const &sourcePath)
            : at(at)
            , script(source) {
            script.setPath(sourcePath); // where the source comes from
        }
        struct Compare {
            bool operator () (Event const *a, Event const *b) { return a->at > b->at; }
        };
    };
    typedef std::priority_queue<Event *, std::deque<Event *>, Event::Compare> Events;
    Events events;
    Impl(Public *i) : Base(i)
    {}
    ~Impl() {
        setContext(nullptr);
        clear();
    }
    void clear() {
        while (!events.empty()) {
            delete events.top();
            events.pop();
        }
    }
    void setContext(Record *rec) {
        if (context) context->audienceForDeletion() -= this;
        context = rec;
        if (context) context->audienceForDeletion() += this;
    }
    void recordBeingDeleted(Record &record) {
        if (context == &record) {
            context = nullptr;
        }
    }
};
Timeline::Timeline()
    : d(new Impl(this))
{}
void Timeline::clear() {
    d->clear();
}
void Timeline::setContext(Record &context) {
    d->setContext(&context);
}
Record *Timeline::context() const {
    return d->context;
}
Script &Timeline::addScript(TimeSpan at, String const &source, String const &sourcePath) {
    auto *ev = new Impl::Event(at, source, sourcePath);
    d->events.push(ev);
    return ev->script;
}
void Timeline::addFromInfo(Record const &timelineRecord) {
    auto scripts = ScriptedInfo::subrecordsOfType(ScriptedInfo::SCRIPT, timelineRecord);
    for (String key : ScriptedInfo::sortRecordsBySource(scripts)) {
        auto const &def = *scripts[key];
        try {
            addScript(def.getd("at", 0.0),
                      def.gets(ScriptedInfo::SCRIPT),
                      ScriptedInfo::sourceLocation(def));
        }
        catch (Error const &er) {
            LOG_RES_ERROR("%s: Error in timeline script: %s")
                    << ScriptedInfo::sourceLocation(def)
                    << er.asText();
        }
    }
}
DENG2_PIMPL_NOREF(Timeline::Clock) {
    typedef Timeline::Impl::Event  Event;
    typedef Timeline::Impl::Events Events; // Events not owned
    Record *context = nullptr;
    Timeline const *scheduler = nullptr;
    TimeSpan at = 0.0;
    Events events;
    void rewind(TimeSpan const &toTime) {
        at = toTime;
        events = scheduler->d->events;
        while (!events.empty()) {
            if (events.top()->at < at) {
                events.pop();
            }
            else break;
        }
    }
    void advanceTime(TimeSpan const &elapsed) {
        at += elapsed;
        while (!events.empty()) {
            Event const *ev = events.top();
            if (ev->at > at) break;
            events.pop();
            Process process(context? context : scheduler->d->context);
            process.run(ev->script);
            process.execute();
        }
    }
};
Timeline::Clock::Clock(Timeline const &schedule, Record *context)
    : d(new Impl) {
    d->scheduler = &schedule;
    d->context   = context;
    d->rewind(0.0);
}
TimeSpan Timeline::Clock::at() const {
    return d->at;
}
void Timeline::Clock::rewind(TimeSpan const &toTime) {
    d->rewind(toTime);
}
void Timeline::Clock::advanceTime(TimeSpan const &elapsed) {
    d->advanceTime(elapsed);
}
bool Timeline::Clock::isFinished() const {
    return d->events.empty();
}
} // namespace de
static duint const POOL_SIZE = 1024;
String const Token::PARENTHESIS_OPEN  = "(";
String const Token::PARENTHESIS_CLOSE = ")";
String const Token::BRACKET_OPEN      = "[";
String const Token::BRACKET_CLOSE     = "]";
String const Token::CURLY_OPEN        = "{";
String const Token::CURLY_CLOSE       = "}";
String const Token::COLON             = ":";
String const Token::COMMA             = ",";
String const Token::SEMICOLON         = ";";
bool Token::equals(QChar const *str) const {
    dsize length = qchar_strlen(str);
    if (length != dsize(size())) return false;
    return String::equals(str, _begin, size());
}
bool Token::beginsWith(QChar const *str) const {
    dsize const length = qchar_strlen(str);
    if (length > dsize(size())) {
        return false;
    }
    return String::equals(str, _begin, length);
}
String Token::asText() const {
    return String(typeToText(_type)) + " '" + str() +
           "' (on line " + QString::number(_line) + ")";
}
String Token::str() const {
    return String(_begin, _end - _begin);
}
String Token::unescapeStringLiteral() const {
    DENG2_ASSERT(_type == LITERAL_STRING_APOSTROPHE ||
                 _type == LITERAL_STRING_QUOTED ||
                 _type == LITERAL_STRING_LONG);
    String result;
    QTextStream os(&result);
    bool escaped = false;
    QChar const *begin = _begin;
    QChar const *end   = _end;
    if (_type == LITERAL_STRING_LONG) {
        DENG2_ASSERT(size() >= 6);
        begin += 3;
        end -= 3;
    }
    else {
        ++begin;
        --end;
    }
    for (QChar const *ptr = begin; ptr != end; ++ptr) {
        if (escaped) {
            QChar c = '\\';
            escaped = false;
            if (*ptr == '\\') {
                c = '\\';
            }
            else if (*ptr == '\'') {
                c = '\'';
            }
            else if (*ptr == '\"') {
                c = '\"';
            }
            else if (*ptr == 'a') {
                c = '\a';
            }
            else if (*ptr == 'b') {
                c = '\b';
            }
            else if (*ptr == 'f') {
                c = '\f';
            }
            else if (*ptr == 'n') {
                c = '\n';
            }
            else if (*ptr == 'r') {
                c = '\r';
            }
            else if (*ptr == 't') {
                c = '\t';
            }
            else if (*ptr == 'v') {
                c = '\v';
            }
            else if (*ptr == 'x' && (end - ptr > 2)) {
                QString num(const_cast<QChar const *>(ptr + 1), 2);
                duint code = num.toInt(0, 16);
                c = QChar(code);
                ptr += 2;
            }
            else {
                os << '\\' << *ptr;
                continue;
            }
            os << c;
        }
        else {
            if (*ptr == '\\') {
                escaped = true;
                continue;
            }
            os << *ptr;
        }
    }
    DENG2_ASSERT(!escaped);
    return result;
}
bool Token::isInteger() const {
    if (_type != LITERAL_NUMBER) return false;
    String const string = str();
    if (string.beginsWith(QStringLiteral("0x")) ||
        string.beginsWith(QStringLiteral("0X"))) {
        return true;
    }
    return !isFloat();
}
bool Token::isFloat() const {
    if (_type != LITERAL_NUMBER) return false;
    for (QChar c : *this) {
        if (c == '.') return true;
    }
    return false;
}
ddouble Token::toNumber() const {
    String const string = str();
    if (string.beginsWith(QStringLiteral("0x")) ||
        string.beginsWith(QStringLiteral("0X"))) {
        return ddouble(string.toLongLong(0, 16));
    }
    else {
        return string.toDouble();
    }
}
dint64 Token::toInteger() const {
    return str().toLongLong(nullptr, 0);
}
ddouble Token::toDouble() const {
    return str().toDouble();
}
TokenBuffer::TokenBuffer() : _forming(0), _formPool(0)
{}
TokenBuffer::~TokenBuffer()
{}
void TokenBuffer::clear() {
    _tokens.clear();
    for (Pools::iterator i = _pools.begin(); i != _pools.end(); ++i) {
        i->rover = 0;
    }
    _formPool = 0;
}
QChar *TokenBuffer::advanceToPoolWithSpace(duint minimum) {
    for (;; ++_formPool) {
        if (_pools.size() == _formPool) {
            _pools.push_back(Pool());
            Pool &newFp = _pools[_formPool];
            newFp.size = POOL_SIZE + minimum;
            newFp.chars.resize(newFp.size);
            return newFp.chars.data();
        }
        Pool &fp = _pools[_formPool];
        if (fp.rover + minimum < fp.size) {
            return &fp.chars.data()[fp.rover];
        }
        if (!fp.rover) {
            fp.size = max(POOL_SIZE + minimum, 2 * minimum);
            fp.chars.resize(fp.size);
            return fp.chars.data();
        }
    }
}
void TokenBuffer::newToken(duint line) {
    if (_forming) {
        *_forming = Token(_forming->begin(), _forming->begin(), line);
        return;
    }
    QChar *begin = advanceToPoolWithSpace(0);
    _tokens.push_back(Token(begin, begin, line));
    _forming = &_tokens.back();
}
void TokenBuffer::appendChar(QChar c) {
    DENG2_ASSERT(_forming != 0);
    _forming->appendChar(c);
    Pool &fp = _pools[_formPool];
    if (_forming->end() - fp.chars.data() >= dint(fp.size)) {
        String tok = _forming->str();
        QChar *newBegin = advanceToPoolWithSpace(tok.size());
        memmove(newBegin, tok.data(), tok.size() * sizeof(QChar));
        *_forming = Token(newBegin, newBegin + tok.size(), _forming->line());
    }
}
void TokenBuffer::setType(Token::Type type) {
    DENG2_ASSERT(_forming != 0);
    _forming->setType(type);
}
void TokenBuffer::endToken() {
    if (_forming) {
        _pools[_formPool].rover += _forming->size();
        _forming = 0;
    }
}
dsize TokenBuffer::size() const {
    return _tokens.size();
}
Token const &TokenBuffer::at(duint i) const {
    if (i >= _tokens.size()) {
        throw OutOfRangeError("TokenBuffer::at", "Index out of range");
    }
    return _tokens[i];
}
Token const &TokenBuffer::latest() const {
    return _tokens.back();
}
duint const UNDEFINED_POS = 0xffffffff;
TokenRange::TokenRange() : _tokens(0), _start(0), _end(0)
{}
TokenRange::TokenRange(TokenBuffer const &tokens) : _tokens(&tokens), _start(0) {
    _end = _tokens->size();
}
TokenRange::TokenRange(TokenBuffer const &tokens, duint start, duint end)
    : _tokens(&tokens), _start(start), _end(end) {
}
duint TokenRange::tokenIndex(duint pos) const {
    if (pos >= size()) {
        throw OutOfBoundsError("TokenRange::tokenIndex",
                               "Position " + QString::number(pos) + " is out of the range (" +
                               QString::number(_start) + ", " + QString::number(_end) +
                               "), length " + QString::number(size()));
    }
    return _start + pos;
}
duint TokenRange::tokenPos(duint index) const {
    if (index < _start) {
        throw OutOfBoundsError("TokenRange::tokenPos",
                               "Index " + QString::number(index) + " is out of the range (" +
                               QString::number(_start) + ", " + QString::number(_end) + ")");
    }
    return index - _start;
}
Token const &TokenRange::token(duint pos) const {
    if (pos >= size()) {
        throw OutOfBoundsError("TokenRange::token",
                               "Position " + QString::number(pos) + " is out of the range (" +
                               QString::number(_start) + ", " + QString::number(_end) + ")");
    }
    return _tokens->at(tokenIndex(pos));
}
Token const &TokenRange::firstToken() const {
    if (!size()) {
        throw EmptyRangeError("TokenRange::firstToken", "Token range has no first token");
    }
    return token(0);
}
Token const &TokenRange::lastToken() const {
    if (!size()) {
        throw EmptyRangeError("TokenRange::lastToken", "Token range has no last token");
    }
    return token(size() - 1);
}
bool TokenRange::beginsWith(QChar const *str) const {
    if (size()) {
        return token(0).equals(str);
    }
    return false;
}
TokenRange TokenRange::startingFrom(duint pos) const {
    return TokenRange(*_tokens, tokenIndex(pos), _end);
}
TokenRange TokenRange::endingTo(duint pos) const {
    if (pos > size()) {
        throw OutOfBoundsError("TokenRange::endingTo",
                               "Position " + QString::number(pos) + " is not within the range (" +
                               QString::number(_start) + ", " + QString::number(_end) + ")");
    }
    return TokenRange(*_tokens, _start, tokenIndex(pos));
}
TokenRange TokenRange::between(duint startPos, duint endPos) const {
    if (endPos > size()) {
        return startingFrom(startPos);
    }
    return TokenRange(*_tokens, tokenIndex(startPos), tokenIndex(endPos));
}
dint TokenRange::find(QChar const *token, dint startPos) const {
    duint len = size();
    DENG2_ASSERT(startPos >= 0 && startPos <= dint(len));
    for (dint i = startPos; i < dint(len); ++i) {
        if (_tokens->at(_start + i).equals(token))
            return i;
    }
    return -1;
}
dint TokenRange::findBracketless(QChar const *token, dint startPos) const {
    dint index = findIndexSkippingBrackets(token, tokenIndex(startPos));
    if (index >= 0) {
        return tokenPos(index);
    }
    return -1;
}
dint TokenRange::findIndexSkippingBrackets(QChar const *token, dint startIndex) const {
    DENG2_ASSERT(startIndex >= dint(_start) && startIndex <= dint(_end));
    for (duint i = startIndex; i < _end; ++i) {
        Token const &t = _tokens->at(i);
        if (t.equals(Token::PARENTHESIS_OPEN) || t.equals(Token::BRACKET_OPEN) ||
           t.equals(Token::CURLY_OPEN)) {
            i = tokenIndex(closingBracket(tokenPos(i)));
            continue;
        }
        if (t.equals(token))
            return i;
    }
    return -1;
}
bool TokenRange::getNextDelimited(QChar const *delimiter, TokenRange &subrange) const {
    if (subrange.undefined()) {
        subrange._start = subrange._end = _start;
    }
    else {
        subrange._start = subrange._end + 1;
    }
    if (subrange._start > _end) {
        return false;
    }
    dint index = findIndexSkippingBrackets(delimiter, subrange._start);
    if (index < 0) {
        subrange._end = _end;
    }
    else {
        subrange._end = index;
    }
    return true;
}
void TokenRange::bracketTokens(Token const &openingToken, QChar const * &opening,
                               QChar const * &closing) {
    opening = NULL;
    closing = NULL;
    if (openingToken.equals(Token::PARENTHESIS_OPEN)) {
        opening = Token::PARENTHESIS_OPEN;
        closing = Token::PARENTHESIS_CLOSE;
    }
    else if (openingToken.equals(Token::BRACKET_OPEN)) {
        opening = Token::BRACKET_OPEN;
        closing = Token::BRACKET_CLOSE;
    }
    else if (openingToken.equals(Token::CURLY_OPEN)) {
        opening = Token::CURLY_OPEN;
        closing = Token::CURLY_CLOSE;
    }
}
duint TokenRange::closingBracket(duint openBracketPos) const {
    QChar const *openingToken;
    QChar const *closingToken;
    bracketTokens(token(openBracketPos), openingToken, closingToken);
    int level = 1;
    for (dint i = tokenIndex(openBracketPos + 1); i < dint(_end); ++i) {
        Token const &token = _tokens->at(i);
        if (token.equals(closingToken)) {
            --level;
        }
        else if (token.equals(openingToken)) {
            ++level;
        }
        if (!level) {
            return tokenPos(i);
        }
    }
    throw MismatchedBracketError("TokenRange::closingBracket",
        "Could not find closing bracket for '" + String(openingToken) +
        "' within '" + asText() + "'");
}
duint TokenRange::openingBracket(duint closeBracketPos) const {
    QChar const *openingToken;
    QChar const *closingToken;
    for (dint start = tokenIndex(closeBracketPos - 1); start >= 0; --start) {
        bracketTokens(_tokens->at(start), openingToken, closingToken);
        if (!closingToken || !token(closeBracketPos).equals(closingToken)) {
            continue;
        }
        if (closingBracket(tokenPos(start)) == closeBracketPos) {
            return tokenPos(start);
        }
    }
    throw MismatchedBracketError("TokenRange::openingBracket",
        "Could not find opening bracket for '" + token(closeBracketPos).str() +
        "' within '" + asText() + "'");
}
String TokenRange::asText() const {
    String result;
    QTextStream os(&result);
    for (duint i = _start; i < _end; ++i) {
        if (i > _start) {
            os << " ";
        }
        os << _tokens->at(i).str();
    }
    return result;
}
TokenRange TokenRange::undefinedRange() const {
    return TokenRange(*_tokens, UNDEFINED_POS, UNDEFINED_POS);
}
bool TokenRange::undefined() const {
    return (_start == UNDEFINED_POS && _end == UNDEFINED_POS);
}
void TryStatement::execute(Context &context) const {
    context.start(_compound.firstStatement(), next());
}
void TryStatement::operator >> (Writer &to) const {
    to << dbyte(SerialId::Try) << _compound;
}
void TryStatement::operator << (Reader &from) {
    SerialId id;
    from.readAs<dbyte>(id);
    if (id != SerialId::Try) {
        throw DeserializationError("TryStatement::operator <<", "Invalid ID");
    }
    from >> _compound;
}
WhileStatement::~WhileStatement() {
    delete _loopCondition;
}
void WhileStatement::execute(Context &context) const {
    Evaluator &eval = context.evaluator();
    if (eval.evaluate(_loopCondition).isTrue()) {
        context.start(_compound.firstStatement(), this, this, this);
    }
    else {
        context.proceed();
    }
}
void WhileStatement::operator >> (Writer &to) const {
    to << dbyte(SerialId::While) << *_loopCondition << _compound;
}
void WhileStatement::operator << (Reader &from) {
    SerialId id;
    from.readAs<dbyte>(id);
    if (id != SerialId::While) {
        throw DeserializationError("WhileStatement::operator <<", "Invalid ID");
    }
    delete _loopCondition;
    _loopCondition = 0;
    _loopCondition = Expression::constructFrom(from);
    from >> _compound;
}
